=== modified file 'HACKING'
--- HACKING	2005-08-25 12:46:42 +0000
+++ HACKING	2005-08-25 05:58:05 +0000
@@ -82,18 +82,3 @@
 
 The policy about how output is presented in the text-mode client
 should be only in the command-line tool.
-
-Writing tests
-=============
-In general tests should be placed in a file named test_FOO.py where 
-FOO is the logical thing under test. That file should be placed in the
-tests subdirectory under the package being tested.
-
-For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
-
-Running tests
-=============
-Currently, bzr selftest is used to invoke tests.
-You can provide a pattern argument to run a subset. For example, 
-to run just the whitebox tests, run bzr selftest --pattern .*whitebox.*
-

=== modified file 'Makefile'
--- Makefile	2005-09-15 13:34:01 +0000
+++ Makefile	2005-08-24 02:34:24 +0000
@@ -1,19 +1,7 @@
-all: executables
-
-executables:
+all:
 	chmod u+x ./bzr
-	chmod u+x ./setup.py
 
 check:
 	./bzr selftest
 
-clean: executables
-	./setup.py clean
-
 .PHONY: all
-
-
-# build emacs cross-reference
-tag_files=./bzr ./bzrlib/*py ./bzrlib/selftest/*.py
-TAGS: $(tag_files)
-	ctags-exuberant -e $(tag_files)

=== modified file 'NEWS'
--- NEWS	2005-09-12 09:47:33 +0000
+++ NEWS	2005-08-25 05:58:05 +0000
@@ -1,36 +1,4 @@
-development head
-
-  IMPROVEMENTS:
-
-    * Adding a file whose parent directory is not versioned will
-      implicitly add the parent, and so on up to the root. This means
-      you should never need to explictly add a directory, they'll just
-      get added when you add a file in the directory.  Contributed by
-      Michael Ellerman.
-
-
-  INTERNALS:
-
-    * Refactor xml packing/unpacking.
-
-
-  BUG FIXES: 
-
-    * Fixed 'bzr mv' by Ollie Rutherfurd.
-
-    * Fixed strange error when trying to access a nonexistent http
-      branch.
-
-    * Make sure that the hashcache gets written out if it can't be
-      read.
-
-
-  PORTABILITY:
-
-    * Various Windows fixes from Ollie Rutherfurd.
-
-
-bzr-0.0.7 2005-09-02
+bzr development head
 
   NEW FEATURES:
 
@@ -40,36 +8,11 @@
     * New expert command ``bzr find-merge-base`` for debugging merges.
 
 
-  ENHANCEMENTS:
-
-    * Much better merge support.
-
-    * merge3 conflicts are now reported with markers like '<<<<<<<'
-      (seven characters) which is the same as CVS and pleases things
-      like emacs smerge.
-
-
   BUG FIXES:
 
     * ``bzr upgrade`` no longer fails when trying to fix trees that
       mention revisions that are not present.
 
-    * Fixed bugs in listing plugins from ``bzr plugins``.
-
-    * Fix case of $EDITOR containing options for the editor.
-
-    * Fix log -r refusing to show the last revision.
-      (Patch from Goffredo Baroncelli.)
-
-
-  CHANGES:
-
-    * ``bzr log --show-ids`` shows the revision ids of all parents.
-
-    * Externally provided commands on your $BZRPATH no longer need
-      to recognize --bzr-usage to work properly, and can just handle
-      --help themselves.
-
 
   LIBRARY:
 

=== modified file 'TODO'
--- TODO	2005-09-12 15:06:23 +0000
+++ TODO	2005-08-25 05:58:05 +0000
@@ -24,7 +24,7 @@
 
   2005-11-05      mbp  Flowers for stephane
 
-* print a message at the end of running the tests telling them that the
+* print a message at the end of running the tests telling them tht the
   test log and output exists but can be removed
 
 * tests for running the commit editor, and fix problem of not passing in 
@@ -201,10 +201,6 @@
 * sometimes gives "conflicting add" even when the contents are in fact
   the same???
 
-* BZRDIR should be in branch.py not __init__.py.
-
-* ``status `` should accept a -r option to show changes relative to a revision,
-  or between revisions
 
 Medium things
 -------------

=== modified file 'bzr'
--- bzr	2005-09-09 14:17:50 +0000
+++ bzr	2005-08-25 07:46:11 +0000
@@ -40,8 +40,7 @@
     print >>sys.stderr, "bzr: error: cannot find a suitable python interpreter"
     print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
     sys.exit(1)
-if hasattr(os, "unsetenv"):
-    os.unsetenv(REINVOKE)
+os.unsetenv(REINVOKE)
 
 import bzrlib
 import bzrlib.commands

=== modified file 'bzr-man.py'
--- bzr-man.py	2005-09-09 14:17:50 +0000
+++ bzr-man.py	2005-06-06 13:24:18 +0000
@@ -42,8 +42,7 @@
     print >>sys.stderr, "bzr-man.py: error: cannot find a suitable python interpreter"
     print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
     sys.exit(1)
-if hasattr(os, "unsetenv"):
-    os.unsetenv(REINVOKE)
+os.unsetenv(REINVOKE)
 
 import bzrlib, bzrlib.help
 

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-09-15 21:35:53 +0000
+++ bzrlib/__init__.py	2005-08-25 05:58:05 +0000
@@ -38,7 +38,7 @@
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
 __author__ = "Martin Pool <mbp@canonical.com>"
-__version__ = '0.1pre'
+__version__ = '0.0.7pre'
 
 
 def get_bzr_revision():
@@ -47,8 +47,7 @@
     from bzrlib.branch import Branch
     
     try:
-        import os
-        branch = Branch(os.path.dirname(__path__[0]))
+        branch = Branch(__path__[0])
         rh = branch.revision_history()
         if rh:
             return len(rh), rh[-1]
@@ -57,6 +56,3 @@
     except bzrlib.errors.BzrError:
         return None
     
-def test_suite():
-    import selftest
-    return selftest.test_suite()

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-09-15 21:35:53 +0000
+++ bzrlib/add.py	2005-08-29 04:05:28 +0000
@@ -15,10 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from bzrlib.trace import mutter, note, warning
-from bzrlib.errors import NotBranchError
-from bzrlib.branch import Branch
-from bzrlib.osutils import quotefn
-from os.path import dirname
 
 def glob_expand_for_win32(file_list):
     import glob
@@ -36,63 +32,37 @@
     return expanded_file_list
 
 
-def add_reporter_null(path, kind, entry):
-    """Absorb add reports and do nothing."""
-    pass
-
-def add_reporter_print(path, kind, entry):
-    """Print a line to stdout for each file that's added."""
-    print "added", quotefn(path)
-    
-def _prepare_file_list(file_list):
-    """Prepare a file list for use by smart_add_*."""
+def smart_add(file_list, verbose=True, recurse=True):
+    """Add files to version, optionally recursing into directories.
+
+    This is designed more towards DWIM for humans than API simplicity.
+    For the specific behaviour see the help for cmd_add().
+
+    This yields a sequence of (path, kind, file_id) for added files.
+    """
+    import os
     import sys
+    from bzrlib.osutils import quotefn
+    from bzrlib.errors import BadFileKindError, ForbiddenFileError
+    import bzrlib.branch
+    import bzrlib.osutils
+
     if sys.platform == 'win32':
         file_list = glob_expand_for_win32(file_list)
+        
     if not file_list:
         file_list = ['.']
-    file_list = list(file_list)
-    return file_list
-
-
-def smart_add(file_list, recurse=True, reporter=add_reporter_null):
-    """Add files to version, optionally recursing into directories.
-
-    This is designed more towards DWIM for humans than API simplicity.
-    For the specific behaviour see the help for cmd_add().
-
-    Returns the number of files added.
-    """
-    file_list = _prepare_file_list(file_list)
-    b = Branch(file_list[0], find_root=True)
-    return smart_add_branch(b, file_list, recurse, reporter)
-
-        
-def smart_add_branch(branch, file_list, recurse=True, reporter=add_reporter_null):
-    """Add files to version, optionally recursing into directories.
-
-    This is designed more towards DWIM for humans than API simplicity.
-    For the specific behaviour see the help for cmd_add().
-
-    This yields a sequence of (path, kind, file_id) for added files.
-
-    Returns the number of files added.
-    """
-    import os
-    from bzrlib.errors import BadFileKindError, ForbiddenFileError
-    import bzrlib.branch
-
-    assert isinstance(recurse, bool)
-
-    file_list = _prepare_file_list(file_list)
+    
     user_list = file_list[:]
-    inv = branch.read_working_inventory()
-    tree = branch.working_tree()
+    assert not isinstance(file_list, basestring)
+    b = bzrlib.branch.Branch(file_list[0], find_root=True)
+    inv = b.read_working_inventory()
+    tree = b.working_tree()
     count = 0
 
     for f in file_list:
-        rf = branch.relpath(f)
-        af = branch.abspath(rf)
+        rf = b.relpath(f)
+        af = b.abspath(rf)
 
         kind = bzrlib.osutils.file_kind(af)
 
@@ -110,26 +80,20 @@
             
         versioned = (inv.path2id(rf) != None)
 
-        if kind == 'directory':
-            try:
-                sub_branch = Branch(af, find_root=False)
-                sub_tree = True
-            except NotBranchError:
-                sub_tree = False
-        else:
-            sub_tree = False
-
         if rf == '':
             mutter("branch root doesn't need to be added")
-            sub_tree = False
         elif versioned:
             mutter("%r is already versioned" % f)
-        elif sub_tree:
-            mutter("%r is a bzr tree" %f)
         else:
-            count += __add_one(branch, inv, rf, kind, reporter)
-
-        if kind == 'directory' and recurse and not sub_tree:
+            file_id = bzrlib.branch.gen_file_id(rf)
+            inv.add_path(rf, kind=kind, file_id=file_id)
+            mutter("added %r kind %r file_id={%s}" % (rf, kind, file_id))
+            count += 1 
+
+            yield f, kind, file_id
+
+
+        if kind == 'directory' and recurse:
             for subf in os.listdir(af):
                 subp = os.path.join(rf, subf)
                 if subf == bzrlib.BZRDIR:
@@ -138,30 +102,11 @@
                     mutter("skip ignored sub-file %r" % subp)
                 else:
                     mutter("queue to add sub-file %r" % subp)
-                    file_list.append(branch.abspath(subp))
-
-
-    mutter('added %d entries', count)
-    
+                    file_list.append(b.abspath(subp))
+
+
     if count > 0:
-        branch._write_inventory(inv)
-
-    return count
-
-def __add_one(branch, inv, path, kind, reporter):
-    """Add a file or directory, automatically add unversioned parents."""
-
-    # Nothing to do if path is already versioned.
-    # This is safe from infinite recursion because the branch root is
-    # always versioned.
-    if inv.path2id(path) != None:
-        return 0
-
-    # add parent
-    count = __add_one(branch, inv, dirname(path), 'directory', reporter)
-
-    entry = inv.add_path(path, kind=kind)
-    mutter("added %r kind %r file_id={%s}" % (path, kind, entry.file_id))
-    reporter(path, kind, entry)
-
-    return count + 1
+        if verbose:
+            note('added %d entries', count)
+        b._write_inventory(inv)
+

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-09-15 21:35:53 +0000
+++ bzrlib/branch.py	2005-08-29 04:23:53 +0000
@@ -24,13 +24,13 @@
      splitpath, \
      sha_file, appendpath, file_kind
 
-from bzrlib.errors import BzrError, InvalidRevisionNumber, InvalidRevisionId, \
-     DivergedBranches, NotBranchError
+from bzrlib.errors import BzrError, InvalidRevisionNumber, InvalidRevisionId
+import bzrlib.errors
 from bzrlib.textui import show_status
 from bzrlib.revision import Revision
+from bzrlib.xml import unpack_xml
 from bzrlib.delta import compare_trees
 from bzrlib.tree import EmptyTree, RevisionTree
-import bzrlib.xml
 import bzrlib.ui
 
 
@@ -48,20 +48,29 @@
 
 
 def find_branch(f, **args):
-    from bzrlib.transport import transport
-    from bzrlib.local_transport import LocalTransport
-    t = transport(f)
-    # FIXME: This is a hack around transport so that
-    #        We can search the local directories for
-    #        a branch root.
-    if args.has_key('init') and args['init']:
-        # Don't search if we are init-ing
-        return Branch(t, **args)
-    if isinstance(t, LocalTransport):
-        root = find_branch_root(f)
-        if root != f:
-            t = transport(root)
-    return Branch(t, **args)
+    if f and (f.startswith('http://') or f.startswith('https://')):
+        import remotebranch 
+        return remotebranch.RemoteBranch(f, **args)
+    else:
+        return Branch(f, **args)
+
+
+def find_cached_branch(f, cache_root, **args):
+    from remotebranch import RemoteBranch
+    br = find_branch(f, **args)
+    def cacheify(br, store_name):
+        from meta_store import CachedStore
+        cache_path = os.path.join(cache_root, store_name)
+        os.mkdir(cache_path)
+        new_store = CachedStore(getattr(br, store_name), cache_path)
+        setattr(br, store_name, new_store)
+
+    if isinstance(br, RemoteBranch):
+        cacheify(br, 'inventory_store')
+        cacheify(br, 'text_store')
+        cacheify(br, 'revision_store')
+    return br
+
 
 def _relpath(base, path):
     """Return path relative to base, or raise exception.
@@ -85,6 +94,7 @@
         if tail:
             s.insert(0, tail)
     else:
+        from errors import NotBranchError
         raise NotBranchError("path %r is not within branch %r" % (rp, base))
 
     return os.sep.join(s)
@@ -102,8 +112,10 @@
     """
     if f == None:
         f = os.getcwd()
-    else:
+    elif hasattr(os.path, 'realpath'):
         f = os.path.realpath(f)
+    else:
+        f = os.path.abspath(f)
     if not os.path.exists(f):
         raise BzrError('%r does not exist' % f)
         
@@ -116,11 +128,18 @@
         head, tail = os.path.split(f)
         if head == f:
             # reached the root, whatever that may be
-            raise NotBranchError('%s is not in a branch' % orig_f)
+            raise bzrlib.errors.NotBranchError('%s is not in a branch' % orig_f)
         f = head
 
 
 
+# XXX: move into bzrlib.errors; subclass BzrError    
+class DivergedBranches(Exception):
+    def __init__(self, branch1, branch2):
+        self.branch1 = branch1
+        self.branch2 = branch2
+        Exception.__init__(self, "These branches have diverged.")
+
 
 ######################################################################
 # branch objects
@@ -145,39 +164,49 @@
     _lock_mode = None
     _lock_count = None
     _lock = None
-    cache_root = None
     
     # Map some sort of prefix into a namespace
     # stuff like "revno:10", "revid:", etc.
     # This should match a prefix with a function which accepts
     REVISION_NAMESPACES = {}
 
-    def __init__(self, transport, init=False):
+    def __init__(self, base, init=False, find_root=True):
         """Create new branch object at a particular location.
 
-        transport -- A Transport object, defining how to access files.
-                (If a string, transport.transport() will be used to
-                create a Transport object)
+        base -- Base directory for the branch.
         
         init -- If True, create new control files in a previously
              unversioned directory.  If False, the branch must already
              be versioned.
 
+        find_root -- If true and init is false, find the root of the
+             existing branch containing base.
+
         In the test suite, creation of new trees is tested using the
         `ScratchBranch` class.
         """
-        if isinstance(transport, basestring):
-            from transport import transport as get_transport
-            transport = get_transport(transport)
-
-        self._transport = transport
+        from bzrlib.store import ImmutableStore
         if init:
+            self.base = os.path.realpath(base)
             self._make_control()
+        elif find_root:
+            self.base = find_branch_root(base)
+        else:
+            self.base = os.path.realpath(base)
+            if not isdir(self.controlfilename('.')):
+                from errors import NotBranchError
+                raise NotBranchError("not a bzr branch: %s" % quotefn(base),
+                                     ['use "bzr init" to initialize a new working tree',
+                                      'current bzr can only operate from top-of-tree'])
         self._check_format()
 
+        self.text_store = ImmutableStore(self.controlfilename('text-store'))
+        self.revision_store = ImmutableStore(self.controlfilename('revision-store'))
+        self.inventory_store = ImmutableStore(self.controlfilename('inventory-store'))
+
 
     def __str__(self):
-        return '%s(%r)' % (self.__class__.__name__, self._transport.base)
+        return '%s(%r)' % (self.__class__.__name__, self.base)
 
 
     __repr__ = __str__
@@ -185,64 +214,45 @@
 
     def __del__(self):
         if self._lock_mode or self._lock:
-            from bzrlib.warnings import warn
+            from warnings import warn
             warn("branch %r was not explicitly unlocked" % self)
             self._lock.unlock()
 
-        # TODO: It might be best to do this somewhere else,
-        # but it is nice for a Branch object to automatically
-        # cache it's information.
-        # Alternatively, we could have the Transport objects cache requests
-        # See the earlier discussion about how major objects (like Branch)
-        # should never expect their __del__ function to run.
-        if self.cache_root is not None:
-            #from warnings import warn
-            #warn("branch %r auto-cleanup of cache files" % self)
-            try:
-                import shutil
-                shutil.rmtree(self.cache_root)
-            except:
-                pass
-            self.cache_root = None
-
-    def _get_base(self):
-        if self._transport:
-            return self._transport.base
-        return None
-
-    base = property(_get_base)
 
 
     def lock_write(self):
-        # TODO: Upgrade locking to support using a Transport,
-        # and potentially a remote locking protocol
         if self._lock_mode:
             if self._lock_mode != 'w':
-                from bzrlib.errors import LockError
+                from errors import LockError
                 raise LockError("can't upgrade to a write lock from %r" %
                                 self._lock_mode)
             self._lock_count += 1
         else:
-            self._lock = self._transport.lock_write(
-                    self._rel_controlfilename('branch-lock'))
+            from bzrlib.lock import WriteLock
+
+            self._lock = WriteLock(self.controlfilename('branch-lock'))
             self._lock_mode = 'w'
             self._lock_count = 1
 
 
+
     def lock_read(self):
         if self._lock_mode:
             assert self._lock_mode in ('r', 'w'), \
                    "invalid lock mode %r" % self._lock_mode
             self._lock_count += 1
         else:
-            self._lock = self._transport.lock_read(
-                    self._rel_controlfilename('branch-lock'))
+            from bzrlib.lock import ReadLock
+
+            self._lock = ReadLock(self.controlfilename('branch-lock'))
             self._lock_mode = 'r'
             self._lock_count = 1
                         
+
+            
     def unlock(self):
         if not self._lock_mode:
-            from bzrlib.errors import LockError
+            from errors import LockError
             raise LockError('branch %r is not locked' % (self))
 
         if self._lock_count > 1:
@@ -252,25 +262,24 @@
             self._lock = None
             self._lock_mode = self._lock_count = None
 
+
     def abspath(self, name):
         """Return absolute filename for something in the branch"""
-        return self._transport.abspath(name)
+        return os.path.join(self.base, name)
+
 
     def relpath(self, path):
         """Return path relative to this branch of something inside it.
 
         Raises an error if path is not in this branch."""
-        return self._transport.relpath(path)
-
-
-    def _rel_controlfilename(self, file_or_path):
+        return _relpath(self.base, path)
+
+
+    def controlfilename(self, file_or_path):
+        """Return location relative to branch."""
         if isinstance(file_or_path, basestring):
             file_or_path = [file_or_path]
-        return [bzrlib.BZRDIR] + file_or_path
-
-    def controlfilename(self, file_or_path):
-        """Return location relative to branch."""
-        return self._transport.abspath(self._rel_controlfilename(file_or_path))
+        return os.path.join(self.base, bzrlib.BZRDIR, *file_or_path)
 
 
     def controlfile(self, file_or_path, mode='r'):
@@ -284,78 +293,45 @@
         Controlfiles should almost never be opened in write mode but
         rather should be atomically copied and replaced using atomicfile.
         """
-        import codecs
-
-        relpath = self._rel_controlfilename(file_or_path)
-        #TODO: codecs.open() buffers linewise, so it was overloaded with
-        # a much larger buffer, do we need to do the same for getreader/getwriter?
-        if mode == 'rb': 
-            return self._transport.get(relpath)
-        elif mode == 'wb':
-            raise BzrError("Branch.controlfile(mode='wb') is not supported, use put_controlfiles")
-        elif mode == 'r':
-            return codecs.getreader('utf-8')(self._transport.get(relpath), errors='replace')
-        elif mode == 'w':
-            raise BzrError("Branch.controlfile(mode='w') is not supported, use put_controlfiles")
+
+        fn = self.controlfilename(file_or_path)
+
+        if mode == 'rb' or mode == 'wb':
+            return file(fn, mode)
+        elif mode == 'r' or mode == 'w':
+            # open in binary mode anyhow so there's no newline translation;
+            # codecs uses line buffering by default; don't want that.
+            import codecs
+            return codecs.open(fn, mode + 'b', 'utf-8',
+                               buffering=60000)
         else:
             raise BzrError("invalid controlfile mode %r" % mode)
 
-    def put_controlfile(self, path, f, encode=True):
-        """Write an entry as a controlfile.
-
-        :param path: The path to put the file, relative to the .bzr control
-                     directory
-        :param f: A file-like or string object whose contents should be copied.
-        :param encode:  If true, encode the contents as utf-8
-        """
-        self.put_controlfiles([(path, f)], encode=encode)
-
-    def put_controlfiles(self, files, encode=True):
-        """Write several entries as controlfiles.
-
-        :param files: A list of [(path, file)] pairs, where the path is the directory
-                      underneath the bzr control directory
-        :param encode:  If true, encode the contents as utf-8
-        """
-        import codecs
-        ctrl_files = []
-        for path, f in files:
-            if encode:
-                if isinstance(f, basestring):
-                    f = f.encode('utf-8', 'replace')
-                else:
-                    f = codecs.getwriter('utf-8')(f, errors='replace')
-            path = self._rel_controlfilename(path)
-            ctrl_files.append((path, f))
-        self._transport.put_multi(ctrl_files)
+
 
     def _make_control(self):
         from bzrlib.inventory import Inventory
-        from cStringIO import StringIO
+        from bzrlib.xml import pack_xml
         
-        # Create an empty inventory
-        sio = StringIO()
+        os.mkdir(self.controlfilename([]))
+        self.controlfile('README', 'w').write(
+            "This is a Bazaar-NG control directory.\n"
+            "Do not change any files in this directory.\n")
+        self.controlfile('branch-format', 'w').write(BZR_BRANCH_FORMAT)
+        for d in ('text-store', 'inventory-store', 'revision-store'):
+            os.mkdir(self.controlfilename(d))
+        for f in ('revision-history', 'merged-patches',
+                  'pending-merged-patches', 'branch-name',
+                  'branch-lock',
+                  'pending-merges'):
+            self.controlfile(f, 'w').write('')
+        mutter('created control directory in ' + self.base)
+
         # if we want per-tree root ids then this is the place to set
         # them; they're not needed for now and so ommitted for
         # simplicity.
-        bzrlib.xml.serializer_v4.write_inventory(Inventory(), sio)
+        pack_xml(Inventory(), self.controlfile('inventory','w'))
 
-        dirs = [[], 'text-store', 'inventory-store', 'revision-store']
-        files = [('README', 
-            "This is a Bazaar-NG control directory.\n"
-            "Do not change any files in this directory.\n"),
-            ('branch-format', BZR_BRANCH_FORMAT),
-            ('revision-history', ''),
-            ('merged-patches', ''),
-            ('pending-merged-patches', ''),
-            ('branch-name', ''),
-            ('branch-lock', ''),
-            ('pending-merges', ''),
-            ('inventory', sio.getvalue())
-        ]
-        self._transport.mkdir_multi([self._rel_controlfilename(d) for d in dirs])
-        self.put_controlfiles(files)
-        mutter('created control directory in ' + self._transport.base)
 
     def _check_format(self):
         """Check this branch format is supported.
@@ -369,37 +345,12 @@
         # on Windows from Linux and so on.  I think it might be better
         # to always make all internal files in unix format.
         fmt = self.controlfile('branch-format', 'r').read()
-        fmt = fmt.replace('\r\n', '\n')
+        fmt.replace('\r\n', '')
         if fmt != BZR_BRANCH_FORMAT:
             raise BzrError('sorry, branch format %r not supported' % fmt,
                            ['use a different bzr version',
                             'or remove the .bzr directory and "bzr init" again'])
 
-        # We know that the format is the currently supported one.
-        # So create the rest of the entries.
-        from bzrlib.store.compressed_text import CompressedTextStore
-
-        if self._transport.should_cache():
-            import tempfile
-            self.cache_root = tempfile.mkdtemp(prefix='bzr-cache')
-            mutter('Branch %r using caching in %r' % (self, self.cache_root))
-        else:
-            self.cache_root = None
-
-        def get_store(name):
-            relpath = self._rel_controlfilename(name)
-            store = CompressedTextStore(self._transport.clone(relpath))
-            if self._transport.should_cache():
-                from meta_store import CachedStore
-                cache_path = os.path.join(self.cache_root, name)
-                os.mkdir(cache_path)
-                store = CachedStore(store, cache_path)
-            return store
-
-        self.text_store = get_store('text-store')
-        self.revision_store = get_store('revision-store')
-        self.inventory_store = get_store('inventory-store')
-
     def get_root_id(self):
         """Return the id of this branches root"""
         inv = self.read_working_inventory()
@@ -420,12 +371,18 @@
     def read_working_inventory(self):
         """Read the working inventory."""
         from bzrlib.inventory import Inventory
+        from bzrlib.xml import unpack_xml
+        from time import time
+        before = time()
         self.lock_read()
         try:
             # ElementTree does its own conversion from UTF-8, so open in
             # binary.
-            f = self.controlfile('inventory', 'rb')
-            return bzrlib.xml.serializer_v4.read_inventory(f)
+            inv = unpack_xml(Inventory,
+                             self.controlfile('inventory', 'rb'))
+            mutter("loaded inventory of %d items in %f"
+                   % (len(inv), time() - before))
+            return inv
         finally:
             self.unlock()
             
@@ -436,14 +393,17 @@
         That is to say, the inventory describing changes underway, that
         will be committed to the next revision.
         """
-        from cStringIO import StringIO
+        from bzrlib.atomicfile import AtomicFile
+        from bzrlib.xml import pack_xml
+        
         self.lock_write()
         try:
-            sio = StringIO()
-            bzrlib.xml.serializer_v4.write_inventory(inv, sio)
-            sio.seek(0)
-            # Transport handles atomicity
-            self.put_controlfile('inventory', sio)
+            f = AtomicFile(self.controlfilename('inventory'), 'wb')
+            try:
+                pack_xml(inv, f)
+                f.commit()
+            finally:
+                f.close()
         finally:
             self.unlock()
         
@@ -614,20 +574,24 @@
 
 
     def append_revision(self, *revision_ids):
+        from bzrlib.atomicfile import AtomicFile
+
         for revision_id in revision_ids:
             mutter("add {%s} to revision-history" % revision_id)
 
         rev_history = self.revision_history()
         rev_history.extend(revision_ids)
 
-        self.lock_write()
+        f = AtomicFile(self.controlfilename('revision-history'))
         try:
-            self.put_controlfile('revision-history', '\n'.join(rev_history))
+            for rev_id in rev_history:
+                print >>f, rev_id
+            f.commit()
         finally:
-            self.unlock()
-
-
-    def get_revision_xml_file(self, revision_id):
+            f.close()
+
+
+    def get_revision_xml(self, revision_id):
         """Return XML file object for revision object."""
         if not revision_id or not isinstance(revision_id, basestring):
             raise InvalidRevisionId(revision_id)
@@ -636,22 +600,18 @@
         try:
             try:
                 return self.revision_store[revision_id]
-            except (IndexError, KeyError):
+            except IndexError:
                 raise bzrlib.errors.NoSuchRevision(self, revision_id)
         finally:
             self.unlock()
 
 
-    #deprecated
-    get_revision_xml = get_revision_xml_file
-
-
     def get_revision(self, revision_id):
         """Return the Revision object for a named revision"""
-        xml_file = self.get_revision_xml_file(revision_id)
+        xml_file = self.get_revision_xml(revision_id)
 
         try:
-            r = bzrlib.xml.serializer_v4.read_revision(xml_file)
+            r = unpack_xml(Revision, xml_file)
         except SyntaxError, e:
             raise bzrlib.errors.BzrError('failed to unpack revision_xml',
                                          [revision_id,
@@ -683,34 +643,7 @@
         return compare_trees(old_tree, new_tree)
 
         
-    def get_revisions(self, revision_ids, pb=None):
-        """Return the Revision object for a set of named revisions"""
-        from bzrlib.revision import Revision
-        from bzrlib.xml import unpack_xml
 
-        # TODO: We need to decide what to do here
-        # we cannot use a generator with a try/finally, because
-        # you cannot guarantee that the caller will iterate through
-        # all entries.
-        # in the past, get_inventory wasn't even wrapped in a
-        # try/finally locking block.
-        # We could either lock without the try/finally, or just
-        # not lock at all. We are reading entries that should
-        # never be updated.
-        # I prefer locking with no finally, so that if someone
-        # asks for a list of revisions, but doesn't consume them,
-        # that is their problem, and they will suffer the consequences
-        self.lock_read()
-        for xml_file in self.revision_store.get(revision_ids, pb=pb):
-            try:
-                r = bzrlib.xml.serializer_v4.read_revision(xml_file)
-            except SyntaxError, e:
-                raise bzrlib.errors.BzrError('failed to unpack revision_xml',
-                                             [revision_id,
-                                              str(e)])
-            yield r
-        self.unlock()
-            
     def get_revision_sha1(self, revision_id):
         """Hash the stored value of a revision, and return it."""
         # In the future, revision entries will be signed. At that
@@ -727,39 +660,17 @@
 
         TODO: Perhaps for this and similar methods, take a revision
                parameter which can be either an integer revno or a
-               string hash.
-        """
-        f = self.get_inventory_xml_file(inventory_id)
-        return bzrlib.xml.serializer_v4.read_inventory(f)
+               string hash."""
+        from bzrlib.inventory import Inventory
+        from bzrlib.xml import unpack_xml
+
+        return unpack_xml(Inventory, self.get_inventory_xml(inventory_id))
 
 
     def get_inventory_xml(self, inventory_id):
         """Get inventory XML as a file object."""
-        # Shouldn't this have a read-lock around it?
-        # As well as some sort of trap for missing ids?
         return self.inventory_store[inventory_id]
-
-    get_inventory_xml_file = get_inventory_xml
             
-    def get_inventories(self, inventory_ids, pb=None, ignore_missing=False):
-        """Get Inventory objects by id
-        """
-        from bzrlib.inventory import Inventory
-
-        # See the discussion in get_revisions for why
-        # we don't use a try/finally block here
-        self.lock_read()
-        for f in self.inventory_store.get(inventory_ids, pb=pb, ignore_missing=ignore_missing):
-            if f is not None:
-                # TODO: Possibly put a try/except around this to handle
-                # read serialization errors
-                r = bzrlib.xml.serializer_v4.read_inventory(f)
-                yield r
-            elif ignore_missing:
-                yield None
-            else:
-                raise bzrlib.errors.NoSuchRevision(self, revision_id)
-        self.unlock()
 
     def get_inventory_sha1(self, inventory_id):
         """Return the sha1 hash of the inventory entry
@@ -794,20 +705,20 @@
 
     def common_ancestor(self, other, self_revno=None, other_revno=None):
         """
-        >>> from bzrlib.commit import commit
+        >>> import commit
         >>> sb = ScratchBranch(files=['foo', 'foo~'])
         >>> sb.common_ancestor(sb) == (None, None)
         True
-        >>> commit(sb, "Committing first revision", verbose=False)
+        >>> commit.commit(sb, "Committing first revision", verbose=False)
         >>> sb.common_ancestor(sb)[0]
         1
         >>> clone = sb.clone()
-        >>> commit(sb, "Committing second revision", verbose=False)
+        >>> commit.commit(sb, "Committing second revision", verbose=False)
         >>> sb.common_ancestor(sb)[0]
         2
         >>> sb.common_ancestor(clone)[0]
         1
-        >>> commit(clone, "Committing divergent second revision", 
+        >>> commit.commit(clone, "Committing divergent second revision", 
         ...               verbose=False)
         >>> sb.common_ancestor(clone)[0]
         1
@@ -904,86 +815,67 @@
         """Pull in all new revisions from other branch.
         """
         from bzrlib.fetch import greedy_fetch
-        from bzrlib.revision import get_intervening_revisions
 
         pb = bzrlib.ui.ui_factory.progress_bar()
         pb.update('comparing histories')
-        if stop_revision is None:
-            other_revision = other.last_patch()
+
+        revision_ids = self.missing_revisions(other, stop_revision)
+
+        if len(revision_ids) > 0:
+            count = greedy_fetch(self, other, revision_ids[-1], pb)[0]
         else:
-            other_revision = other.lookup_revision(stop_revision)
-        count = greedy_fetch(self, other, other_revision, pb)[0]
-        try:
-            revision_ids = self.missing_revisions(other, stop_revision)
-        except DivergedBranches, e:
-            try:
-                revision_ids = get_intervening_revisions(self.last_patch(), 
-                                                         other_revision, self)
-                assert self.last_patch() not in revision_ids
-            except bzrlib.errors.NotAncestor:
-                raise e
-
+            count = 0
         self.append_revision(*revision_ids)
+        ## note("Added %d revisions." % count)
         pb.clear()
 
+        
+        
     def install_revisions(self, other, revision_ids, pb):
-        # We are going to iterate this many times, so make sure
-        # that it is a list, and not a generator
-        revision_ids = list(revision_ids)
         if hasattr(other.revision_store, "prefetch"):
             other.revision_store.prefetch(revision_ids)
         if hasattr(other.inventory_store, "prefetch"):
+            inventory_ids = [other.get_revision(r).inventory_id
+                             for r in revision_ids]
             other.inventory_store.prefetch(inventory_ids)
 
         if pb is None:
             pb = bzrlib.ui.ui_factory.progress_bar()
                 
-        # This entire next section is generally done
-        # with either generators, or bulk updates
-        inventories = other.get_inventories(revision_ids, ignore_missing=True)
+        revisions = []
         needed_texts = set()
+        i = 0
 
         failures = set()
-        good_revisions = set()
-        for i, (inv, rev_id) in enumerate(zip(inventories, revision_ids)):
+        for i, rev_id in enumerate(revision_ids):
             pb.update('fetching revision', i+1, len(revision_ids))
-
-            # We don't really need to get the revision here, because
-            # the only thing we needed was the inventory_id, which now
-            # is (by design) identical to the revision_id
-            # try:
-            #     rev = other.get_revision(rev_id)
-            # except bzrlib.errors.NoSuchRevision:
-            #     failures.add(rev_id)
-            #     continue
-
-            if inv is None:
+            try:
+                rev = other.get_revision(rev_id)
+            except bzrlib.errors.NoSuchRevision:
                 failures.add(rev_id)
                 continue
-            else:
-                good_revisions.add(rev_id)
 
-            text_ids = []
+            revisions.append(rev)
+            inv = other.get_inventory(str(rev.inventory_id))
             for key, entry in inv.iter_entries():
                 if entry.text_id is None:
                     continue
-                text_ids.append(entry.text_id)
-
-            has_ids = self.text_store.has(text_ids)
-            for has, text_id in zip(has_ids, text_ids):
-                if not has:
-                    needed_texts.add(text_id)
+                if entry.text_id not in self.text_store:
+                    needed_texts.add(entry.text_id)
 
         pb.clear()
                     
         count, cp_fail = self.text_store.copy_multi(other.text_store, 
                                                     needed_texts)
         #print "Added %d texts." % count 
-        count, cp_fail = self.inventory_store.copy_multi(other.inventory_store,
-                                                         good_revisions)
+        inventory_ids = [ f.inventory_id for f in revisions ]
+        count, cp_fail = self.inventory_store.copy_multi(other.inventory_store, 
+                                                         inventory_ids)
         #print "Added %d inventories." % count 
+        revision_ids = [ f.revision_id for f in revisions]
+
         count, cp_fail = self.revision_store.copy_multi(other.revision_store, 
-                                                          good_revisions,
+                                                          revision_ids,
                                                           permit_failure=True)
         assert len(cp_fail) == 0 
         return count, failures
@@ -996,7 +888,7 @@
 
     def lookup_revision(self, revision):
         """Return the revision identifier for a given revision information."""
-        revno, info = self._get_revision_info(revision)
+        revno, info = self.get_revision_info(revision)
         return info
 
 
@@ -1017,34 +909,6 @@
         revision can also be a string, in which case it is parsed for something like
             'date:' or 'revid:' etc.
         """
-        revno, rev_id = self._get_revision_info(revision)
-        if revno is None:
-            raise bzrlib.errors.NoSuchRevision(self, revision)
-        return revno, rev_id
-
-    def get_rev_id(self, revno, history=None):
-        """Find the revision id of the specified revno."""
-        if revno == 0:
-            return None
-        if history is None:
-            history = self.revision_history()
-        elif revno <= 0 or revno > len(history):
-            raise bzrlib.errors.NoSuchRevision(self, revno)
-        return history[revno - 1]
-
-    def _get_revision_info(self, revision):
-        """Return (revno, revision id) for revision specifier.
-
-        revision can be an integer, in which case it is assumed to be revno
-        (though this will translate negative values into positive ones)
-        revision can also be a string, in which case it is parsed for something
-        like 'date:' or 'revid:' etc.
-
-        A revid is always returned.  If it is None, the specifier referred to
-        the null revision.  If the revid does not occur in the revision
-        history, revno will be None.
-        """
-        
         if revision is None:
             return 0, None
         revno = None
@@ -1054,48 +918,40 @@
             pass
         revs = self.revision_history()
         if isinstance(revision, int):
+            if revision == 0:
+                return 0, None
+            # Mabye we should do this first, but we don't need it if revision == 0
             if revision < 0:
                 revno = len(revs) + revision + 1
             else:
                 revno = revision
-            rev_id = self.get_rev_id(revno, revs)
         elif isinstance(revision, basestring):
             for prefix, func in Branch.REVISION_NAMESPACES.iteritems():
                 if revision.startswith(prefix):
-                    result = func(self, revs, revision)
-                    if len(result) > 1:
-                        revno, rev_id = result
-                    else:
-                        revno = result[0]
-                        rev_id = self.get_rev_id(revno, revs)
+                    revno = func(self, revs, revision)
                     break
             else:
-                raise BzrError('No namespace registered for string: %r' %
-                               revision)
-        else:
-            raise TypeError('Unhandled revision type %s' % revision)
+                raise BzrError('No namespace registered for string: %r' % revision)
 
-        if revno is None:
-            if rev_id is None:
-                raise bzrlib.errors.NoSuchRevision(self, revision)
-        return revno, rev_id
+        if revno is None or revno <= 0 or revno > len(revs):
+            raise BzrError("no such revision %s" % revision)
+        return revno, revs[revno-1]
 
     def _namespace_revno(self, revs, revision):
         """Lookup a revision by revision number"""
         assert revision.startswith('revno:')
         try:
-            return (int(revision[6:]),)
+            return int(revision[6:])
         except ValueError:
             return None
     REVISION_NAMESPACES['revno:'] = _namespace_revno
 
     def _namespace_revid(self, revs, revision):
         assert revision.startswith('revid:')
-        rev_id = revision[len('revid:'):]
         try:
-            return revs.index(rev_id) + 1, rev_id
+            return revs.index(revision[6:]) + 1
         except ValueError:
-            return None, rev_id
+            return None
     REVISION_NAMESPACES['revid:'] = _namespace_revid
 
     def _namespace_last(self, revs, revision):
@@ -1103,11 +959,11 @@
         try:
             offset = int(revision[5:])
         except ValueError:
-            return (None,)
+            return None
         else:
             if offset <= 0:
                 raise BzrError('You must supply a positive value for --revision last:XXX')
-            return (len(revs) - offset + 1,)
+            return len(revs) - offset + 1
     REVISION_NAMESPACES['last:'] = _namespace_last
 
     def _namespace_tag(self, revs, revision):
@@ -1188,36 +1044,16 @@
                 # TODO: Handle timezone.
                 dt = datetime.datetime.fromtimestamp(r.timestamp)
                 if first >= dt and (last is None or dt >= last):
-                    return (i+1,)
+                    return i+1
         else:
             for i in range(len(revs)):
                 r = self.get_revision(revs[i])
                 # TODO: Handle timezone.
                 dt = datetime.datetime.fromtimestamp(r.timestamp)
                 if first <= dt and (last is None or dt <= last):
-                    return (i+1,)
+                    return i+1
     REVISION_NAMESPACES['date:'] = _namespace_date
 
-
-    def _namespace_ancestor(self, revs, revision):
-        from revision import common_ancestor, MultipleRevisionSources
-        other_branch = find_branch(_trim_namespace('ancestor', revision))
-        revision_a = self.last_patch()
-        revision_b = other_branch.last_patch()
-        for r, b in ((revision_a, self), (revision_b, other_branch)):
-            if r is None:
-                raise bzrlib.errors.NoCommits(b)
-        revision_source = MultipleRevisionSources(self, other_branch)
-        result = common_ancestor(revision_a, revision_b, revision_source)
-        try:
-            revno = self.revision_id_to_revno(result)
-        except bzrlib.errors.NoSuchRevision:
-            revno = None
-        return revno,result
-        
-
-    REVISION_NAMESPACES['ancestor:'] = _namespace_ancestor
-
     def revision_tree(self, revision_id):
         """Return Tree for a revision on this branch.
 
@@ -1234,9 +1070,8 @@
 
     def working_tree(self):
         """Return a `Tree` for the working copy."""
-        from bzrlib.workingtree import WorkingTree
-        # TODO: In the future, WorkingTree should utilize Transport
-        return WorkingTree(self._transport.base, self.read_working_inventory())
+        from workingtree import WorkingTree
+        return WorkingTree(self.base, self.read_working_inventory())
 
 
     def basis_tree(self):
@@ -1421,8 +1256,8 @@
         These are revisions that have been merged into the working
         directory but not yet committed.
         """
-        cfn = self._rel_controlfilename('pending-merges')
-        if not self._transport.has(cfn):
+        cfn = self.controlfilename('pending-merges')
+        if not os.path.exists(cfn):
             return []
         p = []
         for l in self.controlfile('pending-merges', 'r').readlines():
@@ -1430,79 +1265,32 @@
         return p
 
 
-    def add_pending_merge(self, *revision_ids):
+    def add_pending_merge(self, revision_id):
         from bzrlib.revision import validate_revision_id
 
-        for rev_id in revision_ids:
-            validate_revision_id(rev_id)
+        validate_revision_id(revision_id)
 
         p = self.pending_merges()
-        updated = False
-        for rev_id in revision_ids:
-            if rev_id in p:
-                continue
-            p.append(rev_id)
-            updated = True
-        if updated:
-            self.set_pending_merges(p)
+        if revision_id in p:
+            return
+        p.append(revision_id)
+        self.set_pending_merges(p)
+
 
     def set_pending_merges(self, rev_list):
-        self.lock_write()
-        try:
-            self.put_controlfile('pending-merges', '\n'.join(rev_list))
-        finally:
-            self.unlock()
-
-
-    def get_parent(self):
-        """Return the parent location of the branch.
-
-        This is the default location for push/pull/missing.  The usual
-        pattern is that the user can override it by specifying a
-        location.
-        """
-        import errno
-        _locs = ['parent', 'pull', 'x-pull']
-        for l in _locs:
-            try:
-                return self.controlfile(l, 'r').read().strip('\n')
-            except IOError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-        return None
-
-
-    def set_parent(self, url):
-        # TODO: Maybe delete old location files?
         from bzrlib.atomicfile import AtomicFile
         self.lock_write()
         try:
-            f = AtomicFile(self.controlfilename('parent'))
+            f = AtomicFile(self.controlfilename('pending-merges'))
             try:
-                f.write(url + '\n')
+                for l in rev_list:
+                    print >>f, l
                 f.commit()
             finally:
                 f.close()
         finally:
             self.unlock()
 
-    def check_revno(self, revno):
-        """\
-        Check whether a revno corresponds to any revision.
-        Zero (the NULL revision) is considered valid.
-        """
-        if revno != 0:
-            self.check_real_revno(revno)
-            
-    def check_real_revno(self, revno):
-        """\
-        Check whether a revno corresponds to a real revision.
-        Zero (the NULL revision) is considered invalid
-        """
-        if revno < 1 or revno > self.revno():
-            raise InvalidRevisionNumber(revno)
-        
-        
 
 
 class ScratchBranch(Branch):
@@ -1530,10 +1318,10 @@
             init = True
         Branch.__init__(self, base, init=init)
         for d in dirs:
-            self._transport.mkdir(d)
+            os.mkdir(self.abspath(d))
             
         for f in files:
-            self._transport.put(f, 'content of %s' % f)
+            file(os.path.join(self.base, f), 'w').write('content of %s' % f)
 
 
     def clone(self):
@@ -1551,8 +1339,6 @@
         os.rmdir(base)
         copytree(self.base, base, symlinks=True)
         return ScratchBranch(base=base)
-
-
         
     def __del__(self):
         self.destroy()
@@ -1572,7 +1358,7 @@
                 for name in files:
                     os.chmod(os.path.join(root, name), 0700)
             rmtree(self.base)
-        self._transport = None
+        self.base = None
 
     
 
@@ -1628,35 +1414,3 @@
     """Return a new tree-root file id."""
     return gen_file_id('TREE_ROOT')
 
-
-def copy_branch(branch_from, to_location, revision=None):
-    """Copy branch_from into the existing directory to_location.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.
-
-    to_location
-        The name of a local directory that exists but is empty.
-    """
-    from bzrlib.merge import merge
-
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    
-    br_to = Branch(to_location, init=True)
-    br_to.set_root_id(branch_from.get_root_id())
-    if revision is None:
-        revno = branch_from.revno()
-    else:
-        revno, rev_id = branch_from.get_revision_info(revision)
-    br_to.update_revisions(branch_from, stop_revision=revno)
-    merge((to_location, -1), (to_location, 0), this_dir=to_location,
-          check_clean=False, ignore_zero=True)
-    br_to.set_parent(branch_from.base)
-    return br_to
-
-def _trim_namespace(namespace, spec):
-    full_namespace = namespace + ':'
-    assert spec.startswith(full_namespace)
-    return spec[len(full_namespace):]

=== removed file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-09-14 17:23:14 +0000
+++ bzrlib/builtins.py	1970-01-01 00:00:00 +0000
@@ -1,1322 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import sys
-import os
-
-import bzrlib
-import bzrlib.trace
-from bzrlib.trace import mutter, note, log_error, warning
-from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
-from bzrlib.branch import find_branch
-from bzrlib import BZRDIR
-from bzrlib.commands import Command
-
-
-class cmd_status(Command):
-    """Display status summary.
-
-    This reports on versioned and unknown files, reporting them
-    grouped by state.  Possible states are:
-
-    added
-        Versioned in the working copy but not in the previous revision.
-
-    removed
-        Versioned in the previous revision but removed or deleted
-        in the working copy.
-
-    renamed
-        Path of this file changed from the previous revision;
-        the text may also have changed.  This includes files whose
-        parent directory was renamed.
-
-    modified
-        Text has changed since the previous revision.
-
-    unchanged
-        Nothing about this file has changed since the previous revision.
-        Only shown with --all.
-
-    unknown
-        Not versioned and not matching an ignore pattern.
-
-    To see ignored files use 'bzr ignored'.  For details in the
-    changes to file texts, use 'bzr diff'.
-
-    If no arguments are specified, the status of the entire working
-    directory is shown.  Otherwise, only the status of the specified
-    files or directories is reported.  If a directory is given, status
-    is reported for everything inside that directory.
-    """
-    # XXX: FIXME: bzr status should accept a -r option to show changes
-    # relative to a revision, or between revisions
-
-    takes_args = ['file*']
-    takes_options = ['all', 'show-ids']
-    aliases = ['st', 'stat']
-    
-    def run(self, all=False, show_ids=False, file_list=None):
-        if file_list:
-            b = find_branch(file_list[0])
-            file_list = [b.relpath(x) for x in file_list]
-            # special case: only one path was given and it's the root
-            # of the branch
-            if file_list == ['']:
-                file_list = None
-        else:
-            b = find_branch('.')
-            
-        from bzrlib.status import show_status
-        show_status(b, show_unchanged=all, show_ids=show_ids,
-                    specific_files=file_list)
-
-
-class cmd_cat_revision(Command):
-    """Write out metadata for a revision."""
-
-    hidden = True
-    takes_args = ['revision_id']
-    
-    def run(self, revision_id):
-        b = find_branch('.')
-        sys.stdout.write(b.get_revision_xml_file(revision_id).read())
-
-
-class cmd_revno(Command):
-    """Show current revision number.
-
-    This is equal to the number of revisions on this branch."""
-    def run(self):
-        print find_branch('.').revno()
-
-
-class cmd_revision_info(Command):
-    """Show revision number and revision id for a given revision identifier.
-    """
-    hidden = True
-    takes_args = ['revision_info*']
-    takes_options = ['revision']
-    def run(self, revision=None, revision_info_list=None):
-        from bzrlib.branch import find_branch
-
-        revs = []
-        if revision is not None:
-            revs.extend(revision)
-        if revision_info_list is not None:
-            revs.extend(revision_info_list)
-        if len(revs) == 0:
-            raise BzrCommandError('You must supply a revision identifier')
-
-        b = find_branch('.')
-
-        for rev in revs:
-            print '%4d %s' % b.get_revision_info(rev)
-
-    
-class cmd_add(Command):
-    """Add specified files or directories.
-
-    In non-recursive mode, all the named items are added, regardless
-    of whether they were previously ignored.  A warning is given if
-    any of the named files are already versioned.
-
-    In recursive mode (the default), files are treated the same way
-    but the behaviour for directories is different.  Directories that
-    are already versioned do not give a warning.  All directories,
-    whether already versioned or not, are searched for files or
-    subdirectories that are neither versioned or ignored, and these
-    are added.  This search proceeds recursively into versioned
-    directories.  If no names are given '.' is assumed.
-
-    Therefore simply saying 'bzr add' will version all files that
-    are currently unknown.
-
-    Adding a file whose parent directory is not versioned will
-    implicitly add the parent, and so on up to the root. This means
-    you should never need to explictly add a directory, they'll just
-    get added when you add a file in the directory.
-    """
-    takes_args = ['file*']
-    takes_options = ['verbose', 'no-recurse']
-    
-    def run(self, file_list, verbose=False, no_recurse=False):
-        # verbose currently has no effect
-        from bzrlib.add import smart_add, add_reporter_print
-        smart_add(file_list, not no_recurse, add_reporter_print)
-
-
-
-class cmd_mkdir(Command):
-    """Create a new versioned directory.
-
-    This is equivalent to creating the directory and then adding it.
-    """
-    takes_args = ['dir+']
-
-    def run(self, dir_list):
-        b = None
-        
-        for d in dir_list:
-            os.mkdir(d)
-            if not b:
-                b = find_branch(d)
-            b.add([d])
-            print 'added', d
-
-
-class cmd_relpath(Command):
-    """Show path of a file relative to root"""
-    takes_args = ['filename']
-    hidden = True
-    
-    def run(self, filename):
-        print find_branch(filename).relpath(filename)
-
-
-
-class cmd_inventory(Command):
-    """Show inventory of the current working copy or a revision."""
-    takes_options = ['revision', 'show-ids']
-    
-    def run(self, revision=None, show_ids=False):
-        b = find_branch('.')
-        if revision == None:
-            inv = b.read_working_inventory()
-        else:
-            if len(revision) > 1:
-                raise BzrCommandError('bzr inventory --revision takes'
-                    ' exactly one revision identifier')
-            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
-
-        for path, entry in inv.entries():
-            if show_ids:
-                print '%-50s %s' % (path, entry.file_id)
-            else:
-                print path
-
-
-class cmd_move(Command):
-    """Move files to a different directory.
-
-    examples:
-        bzr move *.txt doc
-
-    The destination must be a versioned directory in the same branch.
-    """
-    takes_args = ['source$', 'dest']
-    def run(self, source_list, dest):
-        b = find_branch('.')
-
-        # TODO: glob expansion on windows?
-        b.move([b.relpath(s) for s in source_list], b.relpath(dest))
-
-
-class cmd_rename(Command):
-    """Change the name of an entry.
-
-    examples:
-      bzr rename frob.c frobber.c
-      bzr rename src/frob.c lib/frob.c
-
-    It is an error if the destination name exists.
-
-    See also the 'move' command, which moves files into a different
-    directory without changing their name.
-
-    TODO: Some way to rename multiple files without invoking bzr for each
-    one?"""
-    takes_args = ['from_name', 'to_name']
-    
-    def run(self, from_name, to_name):
-        b = find_branch('.')
-        b.rename_one(b.relpath(from_name), b.relpath(to_name))
-
-
-
-class cmd_mv(Command):
-    """Move or rename a file.
-
-    usage:
-        bzr mv OLDNAME NEWNAME
-        bzr mv SOURCE... DESTINATION
-
-    If the last argument is a versioned directory, all the other names
-    are moved into it.  Otherwise, there must be exactly two arguments
-    and the file is changed to a new name, which must not already exist.
-
-    Files cannot be moved between branches.
-    """
-    takes_args = ['names*']
-    def run(self, names_list):
-        if len(names_list) < 2:
-            raise BzrCommandError("missing file argument")
-        b = find_branch(names_list[0])
-
-        rel_names = [b.relpath(x) for x in names_list]
-        
-        if os.path.isdir(names_list[-1]):
-            # move into existing directory
-            for pair in b.move(rel_names[:-1], rel_names[-1]):
-                print "%s => %s" % pair
-        else:
-            if len(names_list) != 2:
-                raise BzrCommandError('to mv multiple files the destination '
-                                      'must be a versioned directory')
-            b.rename_one(rel_names[0], rel_names[1])
-            print "%s => %s" % (rel_names[0], rel_names[1])
-            
-    
-
-
-class cmd_pull(Command):
-    """Pull any changes from another branch into the current one.
-
-    If the location is omitted, the last-used location will be used.
-    Both the revision history and the working directory will be
-    updated.
-
-    This command only works on branches that have not diverged.  Branches are
-    considered diverged if both branches have had commits without first
-    pulling from the other.
-
-    If branches have diverged, you can use 'bzr merge' to pull the text changes
-    from one into the other.
-    """
-    takes_args = ['location?']
-
-    def run(self, location=None):
-        from bzrlib.merge import merge
-        import tempfile
-        from shutil import rmtree
-        import errno
-        
-        br_to = find_branch('.')
-        stored_loc = br_to.get_parent()
-        if location is None:
-            if stored_loc is None:
-                raise BzrCommandError("No pull location known or specified.")
-            else:
-                print "Using last location: %s" % stored_loc
-                location = stored_loc
-        cache_root = tempfile.mkdtemp()
-        from bzrlib.branch import DivergedBranches
-        br_from = find_branch(location)
-        location = br_from.base
-        old_revno = br_to.revno()
-        try:
-            from branch import find_cached_branch, DivergedBranches
-            br_from = find_cached_branch(location, cache_root)
-            location = br_from.base
-            old_revno = br_to.revno()
-            try:
-                br_to.update_revisions(br_from)
-            except DivergedBranches:
-                raise BzrCommandError("These branches have diverged."
-                    "  Try merge.")
-                
-            merge(('.', -1), ('.', old_revno), check_clean=False)
-            if location != stored_loc:
-                br_to.set_parent(location)
-        finally:
-            rmtree(cache_root)
-
-
-
-class cmd_branch(Command):
-    """Create a new copy of a branch.
-
-    If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
-    be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
-
-    To retrieve the branch as of a particular revision, supply the --revision
-    parameter, as in "branch foo/bar -r 5".
-    """
-    takes_args = ['from_location', 'to_location?']
-    takes_options = ['revision']
-    aliases = ['get', 'clone']
-
-    def run(self, from_location, to_location=None, revision=None):
-        from bzrlib.branch import copy_branch, find_cached_branch
-        import tempfile
-        import errno
-        from shutil import rmtree
-        cache_root = tempfile.mkdtemp()
-        try:
-            if revision is None:
-                revision = [None]
-            elif len(revision) > 1:
-                raise BzrCommandError(
-                    'bzr branch --revision takes exactly 1 revision value')
-            try:
-                br_from = find_cached_branch(from_location, cache_root)
-            except OSError, e:
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Source location "%s" does not'
-                                          ' exist.' % to_location)
-                else:
-                    raise
-            if to_location is None:
-                to_location = os.path.basename(from_location.rstrip("/\\"))
-            try:
-                os.mkdir(to_location)
-            except OSError, e:
-                if e.errno == errno.EEXIST:
-                    raise BzrCommandError('Target directory "%s" already'
-                                          ' exists.' % to_location)
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Parent of "%s" does not exist.' %
-                                          to_location)
-                else:
-                    raise
-            try:
-                copy_branch(br_from, to_location, revision[0])
-            except bzrlib.errors.NoSuchRevision:
-                rmtree(to_location)
-                msg = "The branch %s has no revision %d." % (from_location, revision[0])
-                raise BzrCommandError(msg)
-        finally:
-            rmtree(cache_root)
-
-
-class cmd_renames(Command):
-    """Show list of renamed files.
-
-    TODO: Option to show renames between two historical versions.
-
-    TODO: Only show renames under dir, rather than in the whole branch.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        b = find_branch(dir)
-        old_inv = b.basis_tree().inventory
-        new_inv = b.read_working_inventory()
-
-        renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
-        renames.sort()
-        for old_name, new_name in renames:
-            print "%s => %s" % (old_name, new_name)        
-
-
-class cmd_info(Command):
-    """Show statistical information about a branch."""
-    takes_args = ['branch?']
-    
-    def run(self, branch=None):
-        import info
-
-        b = find_branch(branch)
-        info.show_info(b)
-
-
-class cmd_remove(Command):
-    """Make a file unversioned.
-
-    This makes bzr stop tracking changes to a versioned file.  It does
-    not delete the working copy.
-    """
-    takes_args = ['file+']
-    takes_options = ['verbose']
-    
-    def run(self, file_list, verbose=False):
-        b = find_branch(file_list[0])
-        b.remove([b.relpath(f) for f in file_list], verbose=verbose)
-
-
-class cmd_file_id(Command):
-    """Print file_id of a particular file or directory.
-
-    The file_id is assigned when the file is first added and remains the
-    same through all revisions where the file exists, even when it is
-    moved or renamed.
-    """
-    hidden = True
-    takes_args = ['filename']
-    def run(self, filename):
-        b = find_branch(filename)
-        i = b.inventory.path2id(b.relpath(filename))
-        if i == None:
-            raise BzrError("%r is not a versioned file" % filename)
-        else:
-            print i
-
-
-class cmd_file_path(Command):
-    """Print path of file_ids to a file or directory.
-
-    This prints one line for each directory down to the target,
-    starting at the branch root."""
-    hidden = True
-    takes_args = ['filename']
-    def run(self, filename):
-        b = find_branch(filename)
-        inv = b.inventory
-        fid = inv.path2id(b.relpath(filename))
-        if fid == None:
-            raise BzrError("%r is not a versioned file" % filename)
-        for fip in inv.get_idpath(fid):
-            print fip
-
-
-class cmd_revision_history(Command):
-    """Display list of revision ids on this branch."""
-    hidden = True
-    def run(self):
-        for patchid in find_branch('.').revision_history():
-            print patchid
-
-
-class cmd_directories(Command):
-    """Display list of versioned directories in this branch."""
-    def run(self):
-        for name, ie in find_branch('.').read_working_inventory().directories():
-            if name == '':
-                print '.'
-            else:
-                print name
-
-
-class cmd_init(Command):
-    """Make a directory into a versioned branch.
-
-    Use this to create an empty branch, or before importing an
-    existing project.
-
-    Recipe for importing a tree of files:
-        cd ~/project
-        bzr init
-        bzr add -v .
-        bzr status
-        bzr commit -m 'imported project'
-    """
-    def run(self):
-        from bzrlib.branch import Branch
-        Branch('.', init=True)
-
-
-class cmd_diff(Command):
-    """Show differences in working tree.
-    
-    If files are listed, only the changes in those files are listed.
-    Otherwise, all changes for the tree are listed.
-
-    TODO: Allow diff across branches.
-
-    TODO: Option to use external diff command; could be GNU diff, wdiff,
-          or a graphical diff.
-
-    TODO: Python difflib is not exactly the same as unidiff; should
-          either fix it up or prefer to use an external diff.
-
-    TODO: If a directory is given, diff everything under that.
-
-    TODO: Selected-file diff is inefficient and doesn't show you
-          deleted files.
-
-    TODO: This probably handles non-Unix newlines poorly.
-
-    examples:
-        bzr diff
-        bzr diff -r1
-        bzr diff -r1..2
-    """
-    
-    takes_args = ['file*']
-    takes_options = ['revision', 'diff-options']
-    aliases = ['di', 'dif']
-
-    def run(self, revision=None, file_list=None, diff_options=None):
-        from bzrlib.diff import show_diff
-
-        if file_list:
-            b = find_branch(file_list[0])
-            file_list = [b.relpath(f) for f in file_list]
-            if file_list == ['']:
-                # just pointing to top-of-tree
-                file_list = None
-        else:
-            b = find_branch('.')
-
-        if revision is not None:
-            if len(revision) == 1:
-                show_diff(b, revision[0], specific_files=file_list,
-                          external_diff_options=diff_options)
-            elif len(revision) == 2:
-                show_diff(b, revision[0], specific_files=file_list,
-                          external_diff_options=diff_options,
-                          revision2=revision[1])
-            else:
-                raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
-        else:
-            show_diff(b, None, specific_files=file_list,
-                      external_diff_options=diff_options)
-
-        
-
-
-class cmd_deleted(Command):
-    """List files deleted in the working tree.
-
-    TODO: Show files deleted since a previous revision, or between two revisions.
-    """
-    def run(self, show_ids=False):
-        b = find_branch('.')
-        old = b.basis_tree()
-        new = b.working_tree()
-
-        ## TODO: Much more efficient way to do this: read in new
-        ## directories with readdir, rather than stating each one.  Same
-        ## level of effort but possibly much less IO.  (Or possibly not,
-        ## if the directories are very large...)
-
-        for path, ie in old.inventory.iter_entries():
-            if not new.has_id(ie.file_id):
-                if show_ids:
-                    print '%-50s %s' % (path, ie.file_id)
-                else:
-                    print path
-
-
-class cmd_modified(Command):
-    """List files modified in working tree."""
-    hidden = True
-    def run(self):
-        from bzrlib.delta import compare_trees
-
-        b = find_branch('.')
-        td = compare_trees(b.basis_tree(), b.working_tree())
-
-        for path, id, kind in td.modified:
-            print path
-
-
-
-class cmd_added(Command):
-    """List files added in working tree."""
-    hidden = True
-    def run(self):
-        b = find_branch('.')
-        wt = b.working_tree()
-        basis_inv = b.basis_tree().inventory
-        inv = wt.inventory
-        for file_id in inv:
-            if file_id in basis_inv:
-                continue
-            path = inv.id2path(file_id)
-            if not os.access(b.abspath(path), os.F_OK):
-                continue
-            print path
-                
-        
-
-class cmd_root(Command):
-    """Show the tree root directory.
-
-    The root is the nearest enclosing directory with a .bzr control
-    directory."""
-    takes_args = ['filename?']
-    def run(self, filename=None):
-        """Print the branch root."""
-        b = find_branch(filename)
-        print b.base
-
-
-class cmd_log(Command):
-    """Show log of this branch.
-
-    To request a range of logs, you can use the command -r begin:end
-    -r revision requests a specific revision, -r :end or -r begin: are
-    also valid.
-
-    --message allows you to give a regular expression, which will be evaluated
-    so that only matching entries will be displayed.
-
-    TODO: Make --revision support uuid: and hash: [future tag:] notation.
-  
-    """
-
-    takes_args = ['filename?']
-    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
-                     'long', 'message', 'short',]
-    
-    def run(self, filename=None, timezone='original',
-            verbose=False,
-            show_ids=False,
-            forward=False,
-            revision=None,
-            message=None,
-            long=False,
-            short=False):
-        from bzrlib.log import log_formatter, show_log
-        import codecs
-
-        direction = (forward and 'forward') or 'reverse'
-        
-        if filename:
-            b = find_branch(filename)
-            fp = b.relpath(filename)
-            if fp:
-                file_id = b.read_working_inventory().path2id(fp)
-            else:
-                file_id = None  # points to branch root
-        else:
-            b = find_branch('.')
-            file_id = None
-
-        if revision is None:
-            rev1 = None
-            rev2 = None
-        elif len(revision) == 1:
-            rev1 = rev2 = b.get_revision_info(revision[0])[0]
-        elif len(revision) == 2:
-            rev1 = b.get_revision_info(revision[0])[0]
-            rev2 = b.get_revision_info(revision[1])[0]
-        else:
-            raise BzrCommandError('bzr log --revision takes one or two values.')
-
-        if rev1 == 0:
-            rev1 = None
-        if rev2 == 0:
-            rev2 = None
-
-        mutter('encoding log as %r' % bzrlib.user_encoding)
-
-        # use 'replace' so that we don't abort if trying to write out
-        # in e.g. the default C locale.
-        outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
-
-        if not short:
-            log_format = 'long'
-        else:
-            log_format = 'short'
-        lf = log_formatter(log_format,
-                           show_ids=show_ids,
-                           to_file=outf,
-                           show_timezone=timezone)
-
-        show_log(b,
-                 lf,
-                 file_id,
-                 verbose=verbose,
-                 direction=direction,
-                 start_revision=rev1,
-                 end_revision=rev2,
-                 search=message)
-
-
-
-class cmd_touching_revisions(Command):
-    """Return revision-ids which affected a particular file.
-
-    A more user-friendly interface is "bzr log FILE"."""
-    hidden = True
-    takes_args = ["filename"]
-    def run(self, filename):
-        b = find_branch(filename)
-        inv = b.read_working_inventory()
-        file_id = inv.path2id(b.relpath(filename))
-        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
-            print "%6d %s" % (revno, what)
-
-
-class cmd_ls(Command):
-    """List files in a tree.
-
-    TODO: Take a revision or remote path and list that tree instead.
-    """
-    hidden = True
-    def run(self, revision=None, verbose=False):
-        b = find_branch('.')
-        if revision == None:
-            tree = b.working_tree()
-        else:
-            tree = b.revision_tree(b.lookup_revision(revision))
-
-        for fp, fc, kind, fid in tree.list_files():
-            if verbose:
-                if kind == 'directory':
-                    kindch = '/'
-                elif kind == 'file':
-                    kindch = ''
-                else:
-                    kindch = '???'
-
-                print '%-8s %s%s' % (fc, fp, kindch)
-            else:
-                print fp
-
-
-
-class cmd_unknowns(Command):
-    """List unknown files."""
-    def run(self):
-        from bzrlib.osutils import quotefn
-        for f in find_branch('.').unknowns():
-            print quotefn(f)
-
-
-
-class cmd_ignore(Command):
-    """Ignore a command or pattern.
-
-    To remove patterns from the ignore list, edit the .bzrignore file.
-
-    If the pattern contains a slash, it is compared to the whole path
-    from the branch root.  Otherwise, it is comapred to only the last
-    component of the path.
-
-    Ignore patterns are case-insensitive on case-insensitive systems.
-
-    Note: wildcards must be quoted from the shell on Unix.
-
-    examples:
-        bzr ignore ./Makefile
-        bzr ignore '*.class'
-    """
-    takes_args = ['name_pattern']
-    
-    def run(self, name_pattern):
-        from bzrlib.atomicfile import AtomicFile
-        import os.path
-
-        b = find_branch('.')
-        ifn = b.abspath('.bzrignore')
-
-        if os.path.exists(ifn):
-            f = open(ifn, 'rt')
-            try:
-                igns = f.read().decode('utf-8')
-            finally:
-                f.close()
-        else:
-            igns = ''
-
-        # TODO: If the file already uses crlf-style termination, maybe
-        # we should use that for the newly added lines?
-
-        if igns and igns[-1] != '\n':
-            igns += '\n'
-        igns += name_pattern + '\n'
-
-        try:
-            f = AtomicFile(ifn, 'wt')
-            f.write(igns.encode('utf-8'))
-            f.commit()
-        finally:
-            f.close()
-
-        inv = b.working_tree().inventory
-        if inv.path2id('.bzrignore'):
-            mutter('.bzrignore is already versioned')
-        else:
-            mutter('need to make new .bzrignore file versioned')
-            b.add(['.bzrignore'])
-
-
-
-class cmd_ignored(Command):
-    """List ignored files and the patterns that matched them.
-
-    See also: bzr ignore"""
-    def run(self):
-        tree = find_branch('.').working_tree()
-        for path, file_class, kind, file_id in tree.list_files():
-            if file_class != 'I':
-                continue
-            ## XXX: Slightly inefficient since this was already calculated
-            pat = tree.is_ignored(path)
-            print '%-50s %s' % (path, pat)
-
-
-class cmd_lookup_revision(Command):
-    """Lookup the revision-id from a revision-number
-
-    example:
-        bzr lookup-revision 33
-    """
-    hidden = True
-    takes_args = ['revno']
-    
-    def run(self, revno):
-        try:
-            revno = int(revno)
-        except ValueError:
-            raise BzrCommandError("not a valid revision-number: %r" % revno)
-
-        print find_branch('.').lookup_revision(revno)
-
-
-class cmd_export(Command):
-    """Export past revision to destination directory.
-
-    If no revision is specified this exports the last committed revision.
-
-    Format may be an "exporter" name, such as tar, tgz, tbz2.  If none is
-    given, try to find the format with the extension. If no extension
-    is found exports to a directory (equivalent to --format=dir).
-
-    Root may be the top directory for tar, tgz and tbz2 formats. If none
-    is given, the top directory will be the root name of the file."""
-    # TODO: list known exporters
-    takes_args = ['dest']
-    takes_options = ['revision', 'format', 'root']
-    def run(self, dest, revision=None, format=None, root=None):
-        import os.path
-        b = find_branch('.')
-        if revision is None:
-            rev_id = b.last_patch()
-        else:
-            if len(revision) != 1:
-                raise BzrError('bzr export --revision takes exactly 1 argument')
-            revno, rev_id = b.get_revision_info(revision[0])
-        t = b.revision_tree(rev_id)
-        root, ext = os.path.splitext(dest)
-        if not format:
-            if ext in (".tar",):
-                format = "tar"
-            elif ext in (".gz", ".tgz"):
-                format = "tgz"
-            elif ext in (".bz2", ".tbz2"):
-                format = "tbz2"
-            else:
-                format = "dir"
-        t.export(dest, format, root)
-
-
-class cmd_cat(Command):
-    """Write a file's text from a previous revision."""
-
-    takes_options = ['revision']
-    takes_args = ['filename']
-
-    def run(self, filename, revision=None):
-        if revision == None:
-            raise BzrCommandError("bzr cat requires a revision number")
-        elif len(revision) != 1:
-            raise BzrCommandError("bzr cat --revision takes exactly one number")
-        b = find_branch('.')
-        b.print_file(b.relpath(filename), revision[0])
-
-
-class cmd_local_time_offset(Command):
-    """Show the offset in seconds from GMT to local time."""
-    hidden = True    
-    def run(self):
-        print bzrlib.osutils.local_time_offset()
-
-
-
-class cmd_commit(Command):
-    """Commit changes into a new revision.
-    
-    If no arguments are given, the entire tree is committed.
-
-    If selected files are specified, only changes to those files are
-    committed.  If a directory is specified then the directory and everything 
-    within it is committed.
-
-    A selected-file commit may fail in some cases where the committed
-    tree would be invalid, such as trying to commit a file in a
-    newly-added directory that is not itself committed.
-
-    TODO: Run hooks on tree to-be-committed, and after commit.
-
-    TODO: Strict commit that fails if there are unknown or deleted files.
-    """
-    takes_args = ['selected*']
-    takes_options = ['message', 'file', 'verbose', 'unchanged']
-    aliases = ['ci', 'checkin']
-
-    # TODO: Give better message for -s, --summary, used by tla people
-    
-    def run(self, message=None, file=None, verbose=True, selected_list=None,
-            unchanged=False):
-        from bzrlib.errors import PointlessCommit
-        from bzrlib.msgeditor import edit_commit_message
-        from bzrlib.status import show_status
-        from cStringIO import StringIO
-
-        b = find_branch('.')
-        if selected_list:
-            selected_list = [b.relpath(s) for s in selected_list]
-            
-        if not message and not file:
-            catcher = StringIO()
-            show_status(b, specific_files=selected_list,
-                        to_file=catcher)
-            message = edit_commit_message(catcher.getvalue())
-            
-            if message is None:
-                raise BzrCommandError("please specify a commit message"
-                                      " with either --message or --file")
-        elif message and file:
-            raise BzrCommandError("please specify either --message or --file")
-        
-        if file:
-            import codecs
-            message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
-
-        try:
-            b.commit(message, verbose=verbose,
-                     specific_files=selected_list,
-                     allow_pointless=unchanged)
-        except PointlessCommit:
-            # FIXME: This should really happen before the file is read in;
-            # perhaps prepare the commit; get the message; then actually commit
-            raise BzrCommandError("no changes to commit",
-                                  ["use --unchanged to commit anyhow"])
-
-
-class cmd_check(Command):
-    """Validate consistency of branch history.
-
-    This command checks various invariants about the branch storage to
-    detect data corruption or bzr bugs.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        from bzrlib.check import check
-
-        check(find_branch(dir))
-
-
-class cmd_scan_cache(Command):
-    hidden = True
-    def run(self):
-        from bzrlib.hashcache import HashCache
-
-        c = HashCache('.')
-        c.read()
-        c.scan()
-            
-        print '%6d stats' % c.stat_count
-        print '%6d in hashcache' % len(c._cache)
-        print '%6d files removed from cache' % c.removed_count
-        print '%6d hashes updated' % c.update_count
-        print '%6d files changed too recently to cache' % c.danger_count
-
-        if c.needs_write:
-            c.write()
-            
-
-
-class cmd_upgrade(Command):
-    """Upgrade branch storage to current format.
-
-    The check command or bzr developers may sometimes advise you to run
-    this command.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        from bzrlib.upgrade import upgrade
-        upgrade(find_branch(dir))
-
-
-
-class cmd_whoami(Command):
-    """Show bzr user id."""
-    takes_options = ['email']
-    
-    def run(self, email=False):
-        try:
-            b = bzrlib.branch.find_branch('.')
-        except:
-            b = None
-        
-        if email:
-            print bzrlib.osutils.user_email(b)
-        else:
-            print bzrlib.osutils.username(b)
-
-
-class cmd_selftest(Command):
-    """Run internal test suite"""
-    hidden = True
-    takes_options = ['verbose', 'pattern']
-    def run(self, verbose=False, pattern=".*"):
-        import bzrlib.ui
-        from bzrlib.selftest import selftest
-        # we don't want progress meters from the tests to go to the
-        # real output; and we don't want log messages cluttering up
-        # the real logs.
-        save_ui = bzrlib.ui.ui_factory
-        bzrlib.trace.info('running tests...')
-        try:
-            bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
-            result = selftest(verbose=verbose, pattern=pattern)
-            if result:
-                bzrlib.trace.info('tests passed')
-            else:
-                bzrlib.trace.info('tests failed')
-            return int(not result)
-        finally:
-            bzrlib.ui.ui_factory = save_ui
-
-
-def show_version():
-    print "bzr (bazaar-ng) %s" % bzrlib.__version__
-    # is bzrlib itself in a branch?
-    bzrrev = bzrlib.get_bzr_revision()
-    if bzrrev:
-        print "  (bzr checkout, revision %d {%s})" % bzrrev
-    print bzrlib.__copyright__
-    print "http://bazaar-ng.org/"
-    print
-    print "bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and"
-    print "you may use, modify and redistribute it under the terms of the GNU"
-    print "General Public License version 2 or later."
-
-
-class cmd_version(Command):
-    """Show version of bzr."""
-    def run(self):
-        show_version()
-
-class cmd_rocks(Command):
-    """Statement of optimism."""
-    hidden = True
-    def run(self):
-        print "it sure does!"
-
-
-class cmd_find_merge_base(Command):
-    """Find and print a base revision for merging two branches.
-
-    TODO: Options to specify revisions on either side, as if
-          merging only part of the history.
-    """
-    takes_args = ['branch', 'other']
-    hidden = True
-    
-    def run(self, branch, other):
-        from bzrlib.revision import common_ancestor, MultipleRevisionSources
-        
-        branch1 = find_branch(branch)
-        branch2 = find_branch(other)
-
-        history_1 = branch1.revision_history()
-        history_2 = branch2.revision_history()
-
-        last1 = branch1.last_patch()
-        last2 = branch2.last_patch()
-
-        source = MultipleRevisionSources(branch1, branch2)
-        
-        base_rev_id = common_ancestor(last1, last2, source)
-
-        print 'merge base is revision %s' % base_rev_id
-        
-        return
-
-        if base_revno is None:
-            raise bzrlib.errors.UnrelatedBranches()
-
-        print ' r%-6d in %s' % (base_revno, branch)
-
-        other_revno = branch2.revision_id_to_revno(base_revid)
-        
-        print ' r%-6d in %s' % (other_revno, other)
-
-
-
-class cmd_merge(Command):
-    """Perform a three-way merge.
-    
-    The branch is the branch you will merge from.  By default, it will
-    merge the latest revision.  If you specify a revision, that
-    revision will be merged.  If you specify two revisions, the first
-    will be used as a BASE, and the second one as OTHER.  Revision
-    numbers are always relative to the specified branch.
-
-    By default bzr will try to merge in all new work from the other
-    branch, automatically determining an appropriate base.  If this
-    fails, you may need to give an explicit base.
-    
-    Examples:
-
-    To merge the latest revision from bzr.dev
-    bzr merge ../bzr.dev
-
-    To merge changes up to and including revision 82 from bzr.dev
-    bzr merge -r 82 ../bzr.dev
-
-    To merge the changes introduced by 82, without previous changes:
-    bzr merge -r 81..82 ../bzr.dev
-    
-    merge refuses to run if there are any uncommitted changes, unless
-    --force is given.
-    """
-    takes_args = ['branch?']
-    takes_options = ['revision', 'force', 'merge-type']
-
-    def run(self, branch='.', revision=None, force=False, 
-            merge_type=None):
-        from bzrlib.merge import merge
-        from bzrlib.merge_core import ApplyMerge3
-        if merge_type is None:
-            merge_type = ApplyMerge3
-
-        if revision is None or len(revision) < 1:
-            base = [None, None]
-            other = [branch, -1]
-        else:
-            if len(revision) == 1:
-                other = [branch, revision[0]]
-                base = [None, None]
-            else:
-                assert len(revision) == 2
-                if None in revision:
-                    raise BzrCommandError(
-                        "Merge doesn't permit that revision specifier.")
-                base = [branch, revision[0]]
-                other = [branch, revision[1]]
-
-        try:
-            merge(other, base, check_clean=(not force), merge_type=merge_type)
-        except bzrlib.errors.AmbiguousBase, e:
-            m = ("sorry, bzr can't determine the right merge base yet\n"
-                 "candidates are:\n  "
-                 + "\n  ".join(e.bases)
-                 + "\n"
-                 "please specify an explicit base with -r,\n"
-                 "and (if you want) report this to the bzr developers\n")
-            log_error(m)
-
-
-class cmd_revert(Command):
-    """Reverse all changes since the last commit.
-
-    Only versioned files are affected.  Specify filenames to revert only 
-    those files.  By default, any files that are changed will be backed up
-    first.  Backup files have a '~' appended to their name.
-    """
-    takes_options = ['revision', 'no-backup']
-    takes_args = ['file*']
-    aliases = ['merge-revert']
-
-    def run(self, revision=None, no_backup=False, file_list=None):
-        from bzrlib.merge import merge
-        from bzrlib.branch import Branch
-        from bzrlib.commands import parse_spec
-
-        if file_list is not None:
-            if len(file_list) == 0:
-                raise BzrCommandError("No files specified")
-        if revision is None:
-            revision = [-1]
-        elif len(revision) != 1:
-            raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
-        merge(('.', revision[0]), parse_spec('.'),
-              check_clean=False,
-              ignore_zero=True,
-              backup_files=not no_backup,
-              file_list=file_list)
-        if not file_list:
-            Branch('.').set_pending_merges([])
-
-
-class cmd_assert_fail(Command):
-    """Test reporting of assertion failures"""
-    hidden = True
-    def run(self):
-        assert False, "always fails"
-
-
-class cmd_help(Command):
-    """Show help on a command or other topic.
-
-    For a list of all available commands, say 'bzr help commands'."""
-    takes_options = ['long']
-    takes_args = ['topic?']
-    aliases = ['?']
-    
-    def run(self, topic=None, long=False):
-        import help
-        if topic is None and long:
-            topic = "commands"
-        help.help(topic)
-
-
-class cmd_shell_complete(Command):
-    """Show appropriate completions for context.
-
-    For a list of all available commands, say 'bzr shell-complete'."""
-    takes_args = ['context?']
-    aliases = ['s-c']
-    hidden = True
-    
-    def run(self, context=None):
-        import shellcomplete
-        shellcomplete.shellcomplete(context)
-
-
-class cmd_missing(Command):
-    """What is missing in this branch relative to other branch.
-    """
-    takes_args = ['remote?']
-    aliases = ['mis', 'miss']
-    # We don't have to add quiet to the list, because 
-    # unknown options are parsed as booleans
-    takes_options = ['verbose', 'quiet']
-
-    def run(self, remote=None, verbose=False, quiet=False):
-        from bzrlib.errors import BzrCommandError
-        from bzrlib.missing import show_missing
-
-        if verbose and quiet:
-            raise BzrCommandError('Cannot pass both quiet and verbose')
-
-        b = find_branch('.')
-        parent = b.get_parent()
-        if remote is None:
-            if parent is None:
-                raise BzrCommandError("No missing location known or specified.")
-            else:
-                if not quiet:
-                    print "Using last location: %s" % parent
-                remote = parent
-        elif parent is None:
-            # We only update parent if it did not exist, missing should not change the parent
-            b.set_parent(remote)
-        br_remote = find_branch(remote)
-
-        return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
-
-
-
-class cmd_plugins(Command):
-    """List plugins"""
-    hidden = True
-    def run(self):
-        import bzrlib.plugin
-        from inspect import getdoc
-        for plugin in bzrlib.plugin.all_plugins:
-            if hasattr(plugin, '__path__'):
-                print plugin.__path__[0]
-            elif hasattr(plugin, '__file__'):
-                print plugin.__file__
-            else:
-                print `plugin`
-                
-            d = getdoc(plugin)
-            if d:
-                print '\t', d.split('\n')[0]
-
-

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-09-06 11:09:03 +0000
+++ bzrlib/check.py	2005-08-29 04:17:33 +0000
@@ -239,9 +239,6 @@
     if missing_revision_cnt:
         note('%d revisions are mentioned but not present' % missing_revision_cnt)
 
-    if missing_revision_cnt:
-        print '%d revisions are mentioned but not present' % missing_revision_cnt
-
     # stub this out for now because the main bzr branch has references
     # to revisions that aren't present in the store -- mbp 20050804
 #    if (missing_inventory_sha_cnt

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-09-15 21:35:53 +0000
+++ bzrlib/commands.py	2005-08-29 05:06:32 +0000
@@ -15,6 +15,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+# TODO: Split the command framework away from the actual commands.
+
 # TODO: probably should say which arguments are candidates for glob
 # expansion on windows and do that at the command level.
 
@@ -25,26 +27,17 @@
 # would help with validation and shell completion.
 
 
-# TODO: Help messages for options.
-
-# TODO: Define arguments by objects, rather than just using names.
-# Those objects can specify the expected type of the argument, which
-# would help with validation and shell completion.
-
-
-
 import sys
 import os
-from warnings import warn
-from inspect import getdoc
 
 import bzrlib
 import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning
-from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError, NotBranchError
+from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
 from bzrlib.branch import find_branch
 from bzrlib import BZRDIR
 
+
 plugin_cmds = {}
 
 
@@ -58,7 +51,6 @@
         k_unsquished = k
     if not plugin_cmds.has_key(k_unsquished):
         plugin_cmds[k_unsquished] = cmd
-        mutter('registered plugin command %s', k_unsquished)      
     else:
         log_error('Two plugins defined the same command: %r' % k)
         log_error('Not loading the one in %r' % sys.modules[cmd.__module__])
@@ -155,34 +147,35 @@
         msg = "No known merge type %s. Supported types are:\n%s" %\
             (typestring, type_list)
         raise BzrCommandError(msg)
-
-
-def _builtin_commands():
-    import bzrlib.builtins
-    r = {}
-    builtins = bzrlib.builtins.__dict__
-    for name in builtins:
-        if name.startswith("cmd_"):
-            real_name = _unsquish_command_name(name)        
-            r[real_name] = builtins[name]
-    return r
-
-            
-
-def builtin_command_names():
-    """Return list of builtin command names."""
-    return _builtin_commands().keys()
-    
-
-def plugin_command_names():
-    return plugin_cmds.keys()
+    
+
+def get_merge_type(typestring):
+    """Attempt to find the merge class/factory associated with a string."""
+    from merge import merge_types
+    try:
+        return merge_types[typestring][0]
+    except KeyError:
+        templ = '%s%%7s: %%s' % (' '*12)
+        lines = [templ % (f[0], f[1][1]) for f in merge_types.iteritems()]
+        type_list = '\n'.join(lines)
+        msg = "No known merge type %s. Supported types are:\n%s" %\
+            (typestring, type_list)
+        raise BzrCommandError(msg)
+    
 
 
 def _get_cmd_dict(plugins_override=True):
-    """Return name->class mapping for all commands."""
-    d = _builtin_commands()
+    d = {}
+    for k, v in globals().iteritems():
+        if k.startswith("cmd_"):
+            d[_unsquish_command_name(k)] = v
+    # If we didn't load plugins, the plugin_cmds dict will be empty
     if plugins_override:
         d.update(plugin_cmds)
+    else:
+        d2 = plugin_cmds.copy()
+        d2.update(d)
+        d = d2
     return d
 
     
@@ -192,56 +185,37 @@
         yield k,v
 
 
-def get_cmd_object(cmd_name, plugins_override=True):
+def get_cmd_class(cmd, plugins_override=True):
     """Return the canonical name and command class for a command.
-
-    plugins_override
-        If true, plugin commands can override builtins.
     """
-    from bzrlib.externalcommand import ExternalCommand
-
-    cmd_name = str(cmd_name)            # not unicode
+    cmd = str(cmd)                      # not unicode
 
     # first look up this command under the specified name
     cmds = _get_cmd_dict(plugins_override=plugins_override)
     try:
-        return cmds[cmd_name]()
+        return cmd, cmds[cmd]
     except KeyError:
         pass
 
     # look for any command which claims this as an alias
-    for real_cmd_name, cmd_class in cmds.iteritems():
-        if cmd_name in cmd_class.aliases:
-            return cmd_class()
-
-    cmd_obj = ExternalCommand.find_command(cmd_name)
-    if cmd_obj:
-        return cmd_obj
-
-    raise BzrCommandError("unknown command %r" % cmd_name)
+    for cmdname, cmdclass in cmds.iteritems():
+        if cmd in cmdclass.aliases:
+            return cmdname, cmdclass
+
+    cmdclass = ExternalCommand.find_command(cmd)
+    if cmdclass:
+        return cmd, cmdclass
+
+    raise BzrCommandError("unknown command %r" % cmd)
 
 
 class Command(object):
     """Base class for commands.
 
-    Commands are the heart of the command-line bzr interface.
-
-    The command object mostly handles the mapping of command-line
-    parameters into one or more bzrlib operations, and of the results
-    into textual output.
-
-    Commands normally don't have any state.  All their arguments are
-    passed in to the run method.  (Subclasses may take a different
-    policy if the behaviour of the instance needs to depend on e.g. a
-    shell plugin and not just its Python class.)
-
     The docstring for an actual command should give a single-line
     summary, then a complete description of the command.  A grammar
     description will be inserted.
 
-    aliases
-        Other accepted names for this command.
-
     takes_args
         List of argument forms, marked with whether they are optional,
         repeated, etc.
@@ -250,8 +224,7 @@
         List of options that may be given for this command.
 
     hidden
-        If true, this command isn't advertised.  This is typically
-        for commands intended for expert users.
+        If true, this command isn't advertised.
     """
     aliases = []
     
@@ -260,62 +233,1229 @@
 
     hidden = False
     
-    def __init__(self):
-        """Construct an instance of this command."""
+    def __init__(self, options, arguments):
+        """Construct and run the command.
+
+        Sets self.status to the return value of run()."""
+        assert isinstance(options, dict)
+        assert isinstance(arguments, dict)
+        cmdargs = options.copy()
+        cmdargs.update(arguments)
         if self.__doc__ == Command.__doc__:
+            from warnings import warn
             warn("No help message set for %r" % self)
-
-
-    def run_argv(self, argv):
-        """Parse command line and run."""
-        args, opts = parse_args(argv)
-
-        if 'help' in opts:  # e.g. bzr add --help
-            from bzrlib.help import help_on_command
-            help_on_command(self.name())
-            return 0
-
-        # check options are reasonable
-        allowed = self.takes_options
-        for oname in opts:
-            if oname not in allowed:
-                raise BzrCommandError("option '--%s' is not allowed for command %r"
-                                      % (oname, self.name()))
-
-        # mix arguments and options into one dictionary
-        cmdargs = _match_argform(self.name(), self.takes_args, args)
-        cmdopts = {}
-        for k, v in opts.items():
-            cmdopts[k.replace('-', '_')] = v
-
-        all_cmd_args = cmdargs.copy()
-        all_cmd_args.update(cmdopts)
-
-        return self.run(**all_cmd_args)
+        self.status = self.run(**cmdargs)
+        if self.status is None:
+            self.status = 0
 
     
     def run(self):
-        """Actually run the command.
+        """Override this in sub-classes.
 
         This is invoked with the options and arguments bound to
         keyword parameters.
 
-        Return 0 or None if the command was successful, or a non-zero
-        shell error code if not.  It's OK for this method to allow
-        an exception to raise up.
+        Return 0 or None if the command was successful, or a shell
+        error code if not.
         """
-        raise NotImplementedError()
-
-
-    def help(self):
-        """Return help message for this class."""
-        if self.__doc__ is Command.__doc__:
-            return None
-        return getdoc(self)
-
-    def name(self):
-        return _unsquish_command_name(self.__class__.__name__)
-
+        return 0
+
+
+class ExternalCommand(Command):
+    """Class to wrap external commands.
+
+    We cheat a little here, when get_cmd_class() calls us we actually
+    give it back an object we construct that has the appropriate path,
+    help, options etc for the specified command.
+
+    When run_bzr() tries to instantiate that 'class' it gets caught by
+    the __call__ method, which we override to call the Command.__init__
+    method. That then calls our run method which is pretty straight
+    forward.
+
+    The only wrinkle is that we have to map bzr's dictionary of options
+    and arguments back into command line options and arguments for the
+    script.
+    """
+
+    def find_command(cls, cmd):
+        import os.path
+        bzrpath = os.environ.get('BZRPATH', '')
+
+        for dir in bzrpath.split(os.pathsep):
+            path = os.path.join(dir, cmd)
+            if os.path.isfile(path):
+                return ExternalCommand(path)
+
+        return None
+
+    find_command = classmethod(find_command)
+
+    def __init__(self, path):
+        self.path = path
+
+        pipe = os.popen('%s --bzr-usage' % path, 'r')
+        self.takes_options = pipe.readline().split()
+
+        for opt in self.takes_options:
+            if not opt in OPTIONS:
+                raise BzrError("Unknown option '%s' returned by external command %s"
+                               % (opt, path))
+
+        # TODO: Is there any way to check takes_args is valid here?
+        self.takes_args = pipe.readline().split()
+
+        if pipe.close() is not None:
+            raise BzrError("Failed funning '%s --bzr-usage'" % path)
+
+        pipe = os.popen('%s --bzr-help' % path, 'r')
+        self.__doc__ = pipe.read()
+        if pipe.close() is not None:
+            raise BzrError("Failed funning '%s --bzr-help'" % path)
+
+    def __call__(self, options, arguments):
+        Command.__init__(self, options, arguments)
+        return self
+
+    def run(self, **kargs):
+        opts = []
+        args = []
+
+        keys = kargs.keys()
+        keys.sort()
+        for name in keys:
+            optname = name.replace('_','-')
+            value = kargs[name]
+            if OPTIONS.has_key(optname):
+                # it's an option
+                opts.append('--%s' % optname)
+                if value is not None and value is not True:
+                    opts.append(str(value))
+            else:
+                # it's an arg, or arg list
+                if type(value) is not list:
+                    value = [value]
+                for v in value:
+                    if v is not None:
+                        args.append(str(v))
+
+        self.status = os.spawnv(os.P_WAIT, self.path, [self.path] + opts + args)
+        return self.status
+
+
+class cmd_status(Command):
+    """Display status summary.
+
+    This reports on versioned and unknown files, reporting them
+    grouped by state.  Possible states are:
+
+    added
+        Versioned in the working copy but not in the previous revision.
+
+    removed
+        Versioned in the previous revision but removed or deleted
+        in the working copy.
+
+    renamed
+        Path of this file changed from the previous revision;
+        the text may also have changed.  This includes files whose
+        parent directory was renamed.
+
+    modified
+        Text has changed since the previous revision.
+
+    unchanged
+        Nothing about this file has changed since the previous revision.
+        Only shown with --all.
+
+    unknown
+        Not versioned and not matching an ignore pattern.
+
+    To see ignored files use 'bzr ignored'.  For details in the
+    changes to file texts, use 'bzr diff'.
+
+    If no arguments are specified, the status of the entire working
+    directory is shown.  Otherwise, only the status of the specified
+    files or directories is reported.  If a directory is given, status
+    is reported for everything inside that directory.
+
+    If a revision is specified, the changes since that revision are shown.
+    """
+    takes_args = ['file*']
+    takes_options = ['all', 'show-ids', 'revision']
+    aliases = ['st', 'stat']
+    
+    def run(self, all=False, show_ids=False, file_list=None):
+        if file_list:
+            b = find_branch(file_list[0])
+            file_list = [b.relpath(x) for x in file_list]
+            # special case: only one path was given and it's the root
+            # of the branch
+            if file_list == ['']:
+                file_list = None
+        else:
+            b = find_branch('.')
+            
+        from bzrlib.status import show_status
+        show_status(b, show_unchanged=all, show_ids=show_ids,
+                    specific_files=file_list)
+
+
+class cmd_cat_revision(Command):
+    """Write out metadata for a revision."""
+
+    hidden = True
+    takes_args = ['revision_id']
+    
+    def run(self, revision_id):
+        from bzrlib.xml import pack_xml
+        pack_xml(find_branch('.').get_revision(revision_id), sys.stdout)
+
+
+class cmd_revno(Command):
+    """Show current revision number.
+
+    This is equal to the number of revisions on this branch."""
+    def run(self):
+        print find_branch('.').revno()
+
+class cmd_revision_info(Command):
+    """Show revision number and revision id for a given revision identifier.
+    """
+    hidden = True
+    takes_args = ['revision_info*']
+    takes_options = ['revision']
+    def run(self, revision=None, revision_info_list=None):
+        from bzrlib.branch import find_branch
+
+        revs = []
+        if revision is not None:
+            revs.extend(revision)
+        if revision_info_list is not None:
+            revs.extend(revision_info_list)
+        if len(revs) == 0:
+            raise BzrCommandError('You must supply a revision identifier')
+
+        b = find_branch('.')
+
+        for rev in revs:
+            print '%4d %s' % b.get_revision_info(rev)
+
+    
+class cmd_add(Command):
+    """Add specified files or directories.
+
+    In non-recursive mode, all the named items are added, regardless
+    of whether they were previously ignored.  A warning is given if
+    any of the named files are already versioned.
+
+    In recursive mode (the default), files are treated the same way
+    but the behaviour for directories is different.  Directories that
+    are already versioned do not give a warning.  All directories,
+    whether already versioned or not, are searched for files or
+    subdirectories that are neither versioned or ignored, and these
+    are added.  This search proceeds recursively into versioned
+    directories.  If no names are given '.' is assumed.
+
+    Therefore simply saying 'bzr add' will version all files that
+    are currently unknown.
+
+    TODO: Perhaps adding a file whose directly is not versioned should
+    recursively add that parent, rather than giving an error?
+    """
+    takes_args = ['file*']
+    takes_options = ['verbose', 'no-recurse']
+    
+    def run(self, file_list, verbose=False, no_recurse=False):
+        from bzrlib.add import smart_add
+
+        recurse = not no_recurse
+        for path, kind, file_id in smart_add(file_list, verbose, recurse):
+            print 'added', path
+
+
+
+class cmd_mkdir(Command):
+    """Create a new versioned directory.
+
+    This is equivalent to creating the directory and then adding it.
+    """
+    takes_args = ['dir+']
+
+    def run(self, dir_list):
+        b = None
+        
+        for d in dir_list:
+            os.mkdir(d)
+            if not b:
+                b = find_branch(d)
+            b.add([d])
+            print 'added', d
+
+
+class cmd_relpath(Command):
+    """Show path of a file relative to root"""
+    takes_args = ['filename']
+    hidden = True
+    
+    def run(self, filename):
+        print find_branch(filename).relpath(filename)
+
+
+
+class cmd_inventory(Command):
+    """Show inventory of the current working copy or a revision."""
+    takes_options = ['revision', 'show-ids']
+    
+    def run(self, revision=None, show_ids=False):
+        b = find_branch('.')
+        if revision == None:
+            inv = b.read_working_inventory()
+        else:
+            if len(revision) > 1:
+                raise BzrCommandError('bzr inventory --revision takes'
+                    ' exactly one revision identifier')
+            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
+
+        for path, entry in inv.entries():
+            if show_ids:
+                print '%-50s %s' % (path, entry.file_id)
+            else:
+                print path
+
+
+class cmd_move(Command):
+    """Move files to a different directory.
+
+    examples:
+        bzr move *.txt doc
+
+    The destination must be a versioned directory in the same branch.
+    """
+    takes_args = ['source$', 'dest']
+    def run(self, source_list, dest):
+        b = find_branch('.')
+
+        # TODO: glob expansion on windows?
+        b.move([b.relpath(s) for s in source_list], b.relpath(dest))
+
+
+class cmd_rename(Command):
+    """Change the name of an entry.
+
+    examples:
+      bzr rename frob.c frobber.c
+      bzr rename src/frob.c lib/frob.c
+
+    It is an error if the destination name exists.
+
+    See also the 'move' command, which moves files into a different
+    directory without changing their name.
+
+    TODO: Some way to rename multiple files without invoking bzr for each
+    one?"""
+    takes_args = ['from_name', 'to_name']
+    
+    def run(self, from_name, to_name):
+        b = find_branch('.')
+        b.rename_one(b.relpath(from_name), b.relpath(to_name))
+
+
+
+class cmd_mv(Command):
+    """Move or rename a file.
+
+    usage:
+        bzr mv OLDNAME NEWNAME
+        bzr mv SOURCE... DESTINATION
+
+    If the last argument is a versioned directory, all the other names
+    are moved into it.  Otherwise, there must be exactly two arguments
+    and the file is changed to a new name, which must not already exist.
+
+    Files cannot be moved between branches.
+    """
+    takes_args = ['names*']
+    def run(self, names_list):
+        if len(names_list) < 2:
+            raise BzrCommandError("missing file argument")
+        b = find_branch(names_list[0])
+
+        rel_names = [b.relpath(x) for x in names_list]
+        
+        if os.path.isdir(names_list[-1]):
+            # move into existing directory
+            for pair in b.move(rel_names[:-1], rel_names[-1]):
+                print "%s => %s" % pair
+        else:
+            if len(names_list) != 2:
+                raise BzrCommandError('to mv multiple files the destination '
+                                      'must be a versioned directory')
+            for pair in b.move(rel_names[0], rel_names[1]):
+                print "%s => %s" % pair
+            
+    
+
+
+class cmd_pull(Command):
+    """Pull any changes from another branch into the current one.
+
+    If the location is omitted, the last-used location will be used.
+    Both the revision history and the working directory will be
+    updated.
+
+    This command only works on branches that have not diverged.  Branches are
+    considered diverged if both branches have had commits without first
+    pulling from the other.
+
+    If branches have diverged, you can use 'bzr merge' to pull the text changes
+    from one into the other.
+    """
+    takes_args = ['location?']
+
+    def run(self, location=None):
+        from bzrlib.merge import merge
+        import tempfile
+        from shutil import rmtree
+        import errno
+        
+        br_to = find_branch('.')
+        stored_loc = None
+        try:
+            stored_loc = br_to.controlfile("x-pull", "rb").read().rstrip('\n')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+        if location is None:
+            if stored_loc is None:
+                raise BzrCommandError("No pull location known or specified.")
+            else:
+                print "Using last location: %s" % stored_loc
+                location = stored_loc
+        cache_root = tempfile.mkdtemp()
+        from bzrlib.branch import DivergedBranches
+        br_from = find_branch(location)
+        location = pull_loc(br_from)
+        old_revno = br_to.revno()
+        try:
+            from branch import find_cached_branch, DivergedBranches
+            br_from = find_cached_branch(location, cache_root)
+            location = pull_loc(br_from)
+            old_revno = br_to.revno()
+            try:
+                br_to.update_revisions(br_from)
+            except DivergedBranches:
+                raise BzrCommandError("These branches have diverged."
+                    "  Try merge.")
+                
+            merge(('.', -1), ('.', old_revno), check_clean=False)
+            if location != stored_loc:
+                br_to.controlfile("x-pull", "wb").write(location + "\n")
+        finally:
+            rmtree(cache_root)
+
+
+
+class cmd_branch(Command):
+    """Create a new copy of a branch.
+
+    If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
+    be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
+
+    To retrieve the branch as of a particular revision, supply the --revision
+    parameter, as in "branch foo/bar -r 5".
+    """
+    takes_args = ['from_location', 'to_location?']
+    takes_options = ['revision']
+    aliases = ['get', 'clone']
+
+    def run(self, from_location, to_location=None, revision=None):
+        import errno
+        from bzrlib.merge import merge
+        from bzrlib.branch import DivergedBranches, \
+             find_cached_branch, Branch
+        from shutil import rmtree
+        from meta_store import CachedStore
+        import tempfile
+        cache_root = tempfile.mkdtemp()
+
+        if revision is None:
+            revision = [None]
+        elif len(revision) > 1:
+            raise BzrCommandError('bzr branch --revision takes exactly 1 revision value')
+
+        try:
+            try:
+                br_from = find_cached_branch(from_location, cache_root)
+            except OSError, e:
+                if e.errno == errno.ENOENT:
+                    raise BzrCommandError('Source location "%s" does not'
+                                          ' exist.' % to_location)
+                else:
+                    raise
+
+            if to_location is None:
+                to_location = os.path.basename(from_location.rstrip("/\\"))
+
+            try:
+                os.mkdir(to_location)
+            except OSError, e:
+                if e.errno == errno.EEXIST:
+                    raise BzrCommandError('Target directory "%s" already'
+                                          ' exists.' % to_location)
+                if e.errno == errno.ENOENT:
+                    raise BzrCommandError('Parent of "%s" does not exist.' %
+                                          to_location)
+                else:
+                    raise
+            br_to = Branch(to_location, init=True)
+
+            br_to.set_root_id(br_from.get_root_id())
+
+            if revision:
+                if revision[0] is None:
+                    revno = br_from.revno()
+                else:
+                    revno, rev_id = br_from.get_revision_info(revision[0])
+                try:
+                    br_to.update_revisions(br_from, stop_revision=revno)
+                except bzrlib.errors.NoSuchRevision:
+                    rmtree(to_location)
+                    msg = "The branch %s has no revision %d." % (from_location,
+                                                                 revno)
+                    raise BzrCommandError(msg)
+
+            merge((to_location, -1), (to_location, 0), this_dir=to_location,
+                  check_clean=False, ignore_zero=True)
+            from_location = pull_loc(br_from)
+            br_to.controlfile("x-pull", "wb").write(from_location + "\n")
+        finally:
+            rmtree(cache_root)
+
+
+def pull_loc(branch):
+    # TODO: Should perhaps just make attribute be 'base' in
+    # RemoteBranch and Branch?
+    if hasattr(branch, "baseurl"):
+        return branch.baseurl
+    else:
+        return branch.base
+
+
+
+class cmd_renames(Command):
+    """Show list of renamed files.
+
+    TODO: Option to show renames between two historical versions.
+
+    TODO: Only show renames under dir, rather than in the whole branch.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        b = find_branch(dir)
+        old_inv = b.basis_tree().inventory
+        new_inv = b.read_working_inventory()
+
+        renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
+        renames.sort()
+        for old_name, new_name in renames:
+            print "%s => %s" % (old_name, new_name)        
+
+
+class cmd_info(Command):
+    """Show statistical information about a branch."""
+    takes_args = ['branch?']
+    
+    def run(self, branch=None):
+        import info
+
+        b = find_branch(branch)
+        info.show_info(b)
+
+
+class cmd_remove(Command):
+    """Make a file unversioned.
+
+    This makes bzr stop tracking changes to a versioned file.  It does
+    not delete the working copy.
+    """
+    takes_args = ['file+']
+    takes_options = ['verbose']
+    
+    def run(self, file_list, verbose=False):
+        b = find_branch(file_list[0])
+        b.remove([b.relpath(f) for f in file_list], verbose=verbose)
+
+
+class cmd_file_id(Command):
+    """Print file_id of a particular file or directory.
+
+    The file_id is assigned when the file is first added and remains the
+    same through all revisions where the file exists, even when it is
+    moved or renamed.
+    """
+    hidden = True
+    takes_args = ['filename']
+    def run(self, filename):
+        b = find_branch(filename)
+        i = b.inventory.path2id(b.relpath(filename))
+        if i == None:
+            raise BzrError("%r is not a versioned file" % filename)
+        else:
+            print i
+
+
+class cmd_file_path(Command):
+    """Print path of file_ids to a file or directory.
+
+    This prints one line for each directory down to the target,
+    starting at the branch root."""
+    hidden = True
+    takes_args = ['filename']
+    def run(self, filename):
+        b = find_branch(filename)
+        inv = b.inventory
+        fid = inv.path2id(b.relpath(filename))
+        if fid == None:
+            raise BzrError("%r is not a versioned file" % filename)
+        for fip in inv.get_idpath(fid):
+            print fip
+
+
+class cmd_revision_history(Command):
+    """Display list of revision ids on this branch."""
+    hidden = True
+    def run(self):
+        for patchid in find_branch('.').revision_history():
+            print patchid
+
+
+class cmd_directories(Command):
+    """Display list of versioned directories in this branch."""
+    def run(self):
+        for name, ie in find_branch('.').read_working_inventory().directories():
+            if name == '':
+                print '.'
+            else:
+                print name
+
+
+class cmd_init(Command):
+    """Make a directory into a versioned branch.
+
+    Use this to create an empty branch, or before importing an
+    existing project.
+
+    Recipe for importing a tree of files:
+        cd ~/project
+        bzr init
+        bzr add -v .
+        bzr status
+        bzr commit -m 'imported project'
+    """
+    def run(self):
+        from bzrlib.branch import Branch
+        Branch('.', init=True)
+
+
+class cmd_diff(Command):
+    """Show differences in working tree.
+    
+    If files are listed, only the changes in those files are listed.
+    Otherwise, all changes for the tree are listed.
+
+    TODO: Allow diff across branches.
+
+    TODO: Option to use external diff command; could be GNU diff, wdiff,
+          or a graphical diff.
+
+    TODO: Python difflib is not exactly the same as unidiff; should
+          either fix it up or prefer to use an external diff.
+
+    TODO: If a directory is given, diff everything under that.
+
+    TODO: Selected-file diff is inefficient and doesn't show you
+          deleted files.
+
+    TODO: This probably handles non-Unix newlines poorly.
+
+    examples:
+        bzr diff
+        bzr diff -r1
+        bzr diff -r1:2
+    """
+    
+    takes_args = ['file*']
+    takes_options = ['revision', 'diff-options']
+    aliases = ['di', 'dif']
+
+    def run(self, revision=None, file_list=None, diff_options=None):
+        from bzrlib.diff import show_diff
+
+        if file_list:
+            b = find_branch(file_list[0])
+            file_list = [b.relpath(f) for f in file_list]
+            if file_list == ['']:
+                # just pointing to top-of-tree
+                file_list = None
+        else:
+            b = find_branch('.')
+
+        if revision is not None:
+            if len(revision) == 1:
+                show_diff(b, revision[0], specific_files=file_list,
+                          external_diff_options=diff_options)
+            elif len(revision) == 2:
+                show_diff(b, revision[0], specific_files=file_list,
+                          external_diff_options=diff_options,
+                          revision2=revision[1])
+            else:
+                raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
+        else:
+            show_diff(b, None, specific_files=file_list,
+                      external_diff_options=diff_options)
+
+        
+
+
+class cmd_deleted(Command):
+    """List files deleted in the working tree.
+
+    TODO: Show files deleted since a previous revision, or between two revisions.
+    """
+    def run(self, show_ids=False):
+        b = find_branch('.')
+        old = b.basis_tree()
+        new = b.working_tree()
+
+        ## TODO: Much more efficient way to do this: read in new
+        ## directories with readdir, rather than stating each one.  Same
+        ## level of effort but possibly much less IO.  (Or possibly not,
+        ## if the directories are very large...)
+
+        for path, ie in old.inventory.iter_entries():
+            if not new.has_id(ie.file_id):
+                if show_ids:
+                    print '%-50s %s' % (path, ie.file_id)
+                else:
+                    print path
+
+
+class cmd_modified(Command):
+    """List files modified in working tree."""
+    hidden = True
+    def run(self):
+        from bzrlib.delta import compare_trees
+
+        b = find_branch('.')
+        td = compare_trees(b.basis_tree(), b.working_tree())
+
+        for path, id, kind in td.modified:
+            print path
+
+
+
+class cmd_added(Command):
+    """List files added in working tree."""
+    hidden = True
+    def run(self):
+        b = find_branch('.')
+        wt = b.working_tree()
+        basis_inv = b.basis_tree().inventory
+        inv = wt.inventory
+        for file_id in inv:
+            if file_id in basis_inv:
+                continue
+            path = inv.id2path(file_id)
+            if not os.access(b.abspath(path), os.F_OK):
+                continue
+            print path
+                
+        
+
+class cmd_root(Command):
+    """Show the tree root directory.
+
+    The root is the nearest enclosing directory with a .bzr control
+    directory."""
+    takes_args = ['filename?']
+    def run(self, filename=None):
+        """Print the branch root."""
+        b = find_branch(filename)
+        print getattr(b, 'base', None) or getattr(b, 'baseurl')
+
+
+class cmd_log(Command):
+    """Show log of this branch.
+
+    To request a range of logs, you can use the command -r begin:end
+    -r revision requests a specific revision, -r :end or -r begin: are
+    also valid.
+
+    --message allows you to give a regular expression, which will be evaluated
+    so that only matching entries will be displayed.
+
+    TODO: Make --revision support uuid: and hash: [future tag:] notation.
+  
+    """
+
+    takes_args = ['filename?']
+    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
+                     'long', 'message', 'short',]
+    
+    def run(self, filename=None, timezone='original',
+            verbose=False,
+            show_ids=False,
+            forward=False,
+            revision=None,
+            message=None,
+            long=False,
+            short=False):
+        from bzrlib.branch import find_branch
+        from bzrlib.log import log_formatter, show_log
+        import codecs
+
+        direction = (forward and 'forward') or 'reverse'
+        
+        if filename:
+            b = find_branch(filename)
+            fp = b.relpath(filename)
+            if fp:
+                file_id = b.read_working_inventory().path2id(fp)
+            else:
+                file_id = None  # points to branch root
+        else:
+            b = find_branch('.')
+            file_id = None
+
+        if revision is None:
+            rev1 = None
+            rev2 = None
+        elif len(revision) == 1:
+            rev1 = rev2 = b.get_revision_info(revision[0])[0]
+        elif len(revision) == 2:
+            rev1 = b.get_revision_info(revision[0])[0]
+            rev2 = b.get_revision_info(revision[1])[0]
+        else:
+            raise BzrCommandError('bzr log --revision takes one or two values.')
+
+        if rev1 == 0:
+            rev1 = None
+        if rev2 == 0:
+            rev2 = None
+
+        mutter('encoding log as %r' % bzrlib.user_encoding)
+
+        # use 'replace' so that we don't abort if trying to write out
+        # in e.g. the default C locale.
+        outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
+
+        if not short:
+            log_format = 'long'
+        else:
+            log_format = 'short'
+        lf = log_formatter(log_format,
+                           show_ids=show_ids,
+                           to_file=outf,
+                           show_timezone=timezone)
+
+        show_log(b,
+                 lf,
+                 file_id,
+                 verbose=verbose,
+                 direction=direction,
+                 start_revision=rev1,
+                 end_revision=rev2,
+                 search=message)
+
+
+
+class cmd_touching_revisions(Command):
+    """Return revision-ids which affected a particular file.
+
+    A more user-friendly interface is "bzr log FILE"."""
+    hidden = True
+    takes_args = ["filename"]
+    def run(self, filename):
+        b = find_branch(filename)
+        inv = b.read_working_inventory()
+        file_id = inv.path2id(b.relpath(filename))
+        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
+            print "%6d %s" % (revno, what)
+
+
+class cmd_ls(Command):
+    """List files in a tree.
+
+    TODO: Take a revision or remote path and list that tree instead.
+    """
+    hidden = True
+    def run(self, revision=None, verbose=False):
+        b = find_branch('.')
+        if revision == None:
+            tree = b.working_tree()
+        else:
+            tree = b.revision_tree(b.lookup_revision(revision))
+
+        for fp, fc, kind, fid in tree.list_files():
+            if verbose:
+                if kind == 'directory':
+                    kindch = '/'
+                elif kind == 'file':
+                    kindch = ''
+                else:
+                    kindch = '???'
+
+                print '%-8s %s%s' % (fc, fp, kindch)
+            else:
+                print fp
+
+
+
+class cmd_unknowns(Command):
+    """List unknown files."""
+    def run(self):
+        from bzrlib.osutils import quotefn
+        for f in find_branch('.').unknowns():
+            print quotefn(f)
+
+
+
+class cmd_ignore(Command):
+    """Ignore a command or pattern.
+
+    To remove patterns from the ignore list, edit the .bzrignore file.
+
+    If the pattern contains a slash, it is compared to the whole path
+    from the branch root.  Otherwise, it is comapred to only the last
+    component of the path.
+
+    Ignore patterns are case-insensitive on case-insensitive systems.
+
+    Note: wildcards must be quoted from the shell on Unix.
+
+    examples:
+        bzr ignore ./Makefile
+        bzr ignore '*.class'
+    """
+    takes_args = ['name_pattern']
+    
+    def run(self, name_pattern):
+        from bzrlib.atomicfile import AtomicFile
+        import os.path
+
+        b = find_branch('.')
+        ifn = b.abspath('.bzrignore')
+
+        if os.path.exists(ifn):
+            f = open(ifn, 'rt')
+            try:
+                igns = f.read().decode('utf-8')
+            finally:
+                f.close()
+        else:
+            igns = ''
+
+        # TODO: If the file already uses crlf-style termination, maybe
+        # we should use that for the newly added lines?
+
+        if igns and igns[-1] != '\n':
+            igns += '\n'
+        igns += name_pattern + '\n'
+
+        try:
+            f = AtomicFile(ifn, 'wt')
+            f.write(igns.encode('utf-8'))
+            f.commit()
+        finally:
+            f.close()
+
+        inv = b.working_tree().inventory
+        if inv.path2id('.bzrignore'):
+            mutter('.bzrignore is already versioned')
+        else:
+            mutter('need to make new .bzrignore file versioned')
+            b.add(['.bzrignore'])
+
+
+
+class cmd_ignored(Command):
+    """List ignored files and the patterns that matched them.
+
+    See also: bzr ignore"""
+    def run(self):
+        tree = find_branch('.').working_tree()
+        for path, file_class, kind, file_id in tree.list_files():
+            if file_class != 'I':
+                continue
+            ## XXX: Slightly inefficient since this was already calculated
+            pat = tree.is_ignored(path)
+            print '%-50s %s' % (path, pat)
+
+
+class cmd_lookup_revision(Command):
+    """Lookup the revision-id from a revision-number
+
+    example:
+        bzr lookup-revision 33
+    """
+    hidden = True
+    takes_args = ['revno']
+    
+    def run(self, revno):
+        try:
+            revno = int(revno)
+        except ValueError:
+            raise BzrCommandError("not a valid revision-number: %r" % revno)
+
+        print find_branch('.').lookup_revision(revno)
+
+
+class cmd_export(Command):
+    """Export past revision to destination directory.
+
+    If no revision is specified this exports the last committed revision.
+
+    Format may be an "exporter" name, such as tar, tgz, tbz2.  If none is
+    given, try to find the format with the extension. If no extension
+    is found exports to a directory (equivalent to --format=dir).
+
+    Root may be the top directory for tar, tgz and tbz2 formats. If none
+    is given, the top directory will be the root name of the file."""
+    # TODO: list known exporters
+    takes_args = ['dest']
+    takes_options = ['revision', 'format', 'root']
+    def run(self, dest, revision=None, format=None, root=None):
+        import os.path
+        b = find_branch('.')
+        if revision is None:
+            rev_id = b.last_patch()
+        else:
+            if len(revision) != 1:
+                raise BzrError('bzr export --revision takes exactly 1 argument')
+            revno, rev_id = b.get_revision_info(revision[0])
+        t = b.revision_tree(rev_id)
+        root, ext = os.path.splitext(dest)
+        if not format:
+            if ext in (".tar",):
+                format = "tar"
+            elif ext in (".gz", ".tgz"):
+                format = "tgz"
+            elif ext in (".bz2", ".tbz2"):
+                format = "tbz2"
+            else:
+                format = "dir"
+        t.export(dest, format, root)
+
+
+class cmd_cat(Command):
+    """Write a file's text from a previous revision."""
+
+    takes_options = ['revision']
+    takes_args = ['filename']
+
+    def run(self, filename, revision=None):
+        if revision == None:
+            raise BzrCommandError("bzr cat requires a revision number")
+        elif len(revision) != 1:
+            raise BzrCommandError("bzr cat --revision takes exactly one number")
+        b = find_branch('.')
+        b.print_file(b.relpath(filename), revision[0])
+
+
+class cmd_local_time_offset(Command):
+    """Show the offset in seconds from GMT to local time."""
+    hidden = True    
+    def run(self):
+        print bzrlib.osutils.local_time_offset()
+
+
+
+class cmd_commit(Command):
+    """Commit changes into a new revision.
+    
+    If no arguments are given, the entire tree is committed.
+
+    If selected files are specified, only changes to those files are
+    committed.  If a directory is specified then the directory and everything 
+    within it is committed.
+
+    A selected-file commit may fail in some cases where the committed
+    tree would be invalid, such as trying to commit a file in a
+    newly-added directory that is not itself committed.
+
+    TODO: Run hooks on tree to-be-committed, and after commit.
+
+    TODO: Strict commit that fails if there are unknown or deleted files.
+    """
+    takes_args = ['selected*']
+    takes_options = ['message', 'file', 'verbose', 'unchanged']
+    aliases = ['ci', 'checkin']
+
+    # TODO: Give better message for -s, --summary, used by tla people
+    
+    def run(self, message=None, file=None, verbose=True, selected_list=None,
+            unchanged=False):
+        from bzrlib.errors import PointlessCommit
+        from bzrlib.osutils import get_text_message
+
+        ## Warning: shadows builtin file()
+        if not message and not file:
+            # FIXME: Ugly; change status code to send to a provided function?
+            
+            import cStringIO
+            stdout = sys.stdout
+            catcher = cStringIO.StringIO()
+            sys.stdout = catcher
+            cmd_status({"file_list":selected_list}, {})
+            info = catcher.getvalue()
+            sys.stdout = stdout
+            message = get_text_message(info)
+            
+            if message is None:
+                raise BzrCommandError("please specify a commit message",
+                                      ["use either --message or --file"])
+        elif message and file:
+            raise BzrCommandError("please specify either --message or --file")
+        
+        if file:
+            import codecs
+            message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
+
+        b = find_branch('.')
+        if selected_list:
+            selected_list = [b.relpath(s) for s in selected_list]
+            
+        try:
+            b.commit(message, verbose=verbose,
+                     specific_files=selected_list,
+                     allow_pointless=unchanged)
+        except PointlessCommit:
+            # FIXME: This should really happen before the file is read in;
+            # perhaps prepare the commit; get the message; then actually commit
+            raise BzrCommandError("no changes to commit",
+                                  ["use --unchanged to commit anyhow"])
+
+
+class cmd_check(Command):
+    """Validate consistency of branch history.
+
+    This command checks various invariants about the branch storage to
+    detect data corruption or bzr bugs.
+
+    If given the --update flag, it will update some optional fields
+    to help ensure data consistency.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        from bzrlib.check import check
+
+        check(find_branch(dir))
+
+
+class cmd_scan_cache(Command):
+    hidden = True
+    def run(self):
+        from bzrlib.hashcache import HashCache
+        import os
+
+        c = HashCache('.')
+        c.read()
+        c.scan()
+            
+        print '%6d stats' % c.stat_count
+        print '%6d in hashcache' % len(c._cache)
+        print '%6d files removed from cache' % c.removed_count
+        print '%6d hashes updated' % c.update_count
+        print '%6d files changed too recently to cache' % c.danger_count
+
+        if c.needs_write:
+            c.write()
+            
+
+
+class cmd_upgrade(Command):
+    """Upgrade branch storage to current format.
+
+    The check command or bzr developers may sometimes advise you to run
+    this command.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        from bzrlib.upgrade import upgrade
+        upgrade(find_branch(dir))
+
+
+
+class cmd_whoami(Command):
+    """Show bzr user id."""
+    takes_options = ['email']
+    
+    def run(self, email=False):
+        try:
+            b = bzrlib.branch.find_branch('.')
+        except:
+            b = None
+        
+        if email:
+            print bzrlib.osutils.user_email(b)
+        else:
+            print bzrlib.osutils.username(b)
+
+
+class cmd_selftest(Command):
+    """Run internal test suite"""
+    hidden = True
+    takes_options = ['verbose']
+    def run(self, verbose=False):
+        import bzrlib.ui
+        from bzrlib.selftest import selftest
+
+        # we don't want progress meters from the tests to go to the
+        # real output; and we don't want log messages cluttering up
+        # the real logs.
+
+        save_ui = bzrlib.ui.ui_factory
+        bzrlib.trace.info('running tests...')
+        try:
+            bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
+            result = selftest(verbose=verbose)
+            if result:
+                bzrlib.trace.info('tests passed')
+            else:
+                bzrlib.trace.info('tests failed')
+            return int(not result)
+        finally:
+            bzrlib.ui.ui_factory = save_ui
+
+
+class cmd_version(Command):
+    """Show version of bzr."""
+    def run(self):
+        show_version()
+
+def show_version():
+    print "bzr (bazaar-ng) %s" % bzrlib.__version__
+    # is bzrlib itself in a branch?
+    bzrrev = bzrlib.get_bzr_revision()
+    if bzrrev:
+        print "  (bzr checkout, revision %d {%s})" % bzrrev
+    print bzrlib.__copyright__
+    print "http://bazaar-ng.org/"
+    print
+    print "bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and"
+    print "you may use, modify and redistribute it under the terms of the GNU"
+    print "General Public License version 2 or later."
+
+
+class cmd_rocks(Command):
+    """Statement of optimism."""
+    hidden = True
+    def run(self):
+        print "it sure does!"
 
 def parse_spec(spec):
     """
@@ -349,6 +1489,202 @@
     return parsed
 
 
+
+class cmd_find_merge_base(Command):
+    """Find and print a base revision for merging two branches.
+
+    TODO: Options to specify revisions on either side, as if
+          merging only part of the history.
+    """
+    takes_args = ['branch', 'other']
+    hidden = True
+    
+    def run(self, branch, other):
+        branch1 = find_branch(branch)
+        branch2 = find_branch(other)
+
+        base_revno, base_revid = branch1.common_ancestor(branch2)
+
+        if base_revno is None:
+            raise bzrlib.errors.UnrelatedBranches()
+
+        print 'merge base is revision %s' % base_revid
+        print ' r%-6d in %s' % (base_revno, branch)
+
+        other_revno = branch2.revision_id_to_revno(base_revid)
+        
+        print ' r%-6d in %s' % (other_revno, other)
+
+
+
+class cmd_merge(Command):
+    """Perform a three-way merge.
+    
+    The branch is the branch you will merge from.  By default, it will merge
+    the latest revision.  If you specify a revision, that revision will be
+    merged.  If you specify two revisions, the first will be used as a BASE, 
+    and the second one as OTHER.  Revision numbers are always relative to the
+    specified branch.
+    
+    Examples:
+
+    To merge the latest revision from bzr.dev
+    bzr merge ../bzr.dev
+
+    To merge changes up to and including revision 82 from bzr.dev
+    bzr merge -r 82 ../bzr.dev
+
+    To merge the changes introduced by 82, without previous changes:
+    bzr merge -r 81..82 ../bzr.dev
+    
+    merge refuses to run if there are any uncommitted changes, unless
+    --force is given.
+    """
+    takes_args = ['branch?']
+    takes_options = ['revision', 'force', 'merge-type']
+
+    def run(self, branch='.', revision=None, force=False, 
+            merge_type=None):
+        from bzrlib.merge import merge
+        from bzrlib.merge_core import ApplyMerge3
+        if merge_type is None:
+            merge_type = ApplyMerge3
+
+        if revision is None or len(revision) < 1:
+            base = (None, None)
+            other = (branch, -1)
+        else:
+            if len(revision) == 1:
+                other = (branch, revision[0])
+                base = (None, None)
+            else:
+                assert len(revision) == 2
+                if None in revision:
+                    raise BzrCommandError(
+                        "Merge doesn't permit that revision specifier.")
+                base = (branch, revision[0])
+                other = (branch, revision[1])
+            
+        merge(other, base, check_clean=(not force), merge_type=merge_type)
+
+
+class cmd_revert(Command):
+    """Reverse all changes since the last commit.
+
+    Only versioned files are affected.  Specify filenames to revert only 
+    those files.  By default, any files that are changed will be backed up
+    first.  Backup files have a '~' appended to their name.
+    """
+    takes_options = ['revision', 'no-backup']
+    takes_args = ['file*']
+    aliases = ['merge-revert']
+
+    def run(self, revision=None, no_backup=False, file_list=None):
+        from bzrlib.merge import merge
+        if file_list is not None:
+            if len(file_list) == 0:
+                raise BzrCommandError("No files specified")
+        if revision is None:
+            revision = [-1]
+        elif len(revision) != 1:
+            raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
+        merge(('.', revision[0]), parse_spec('.'),
+              check_clean=False,
+              ignore_zero=True,
+              backup_files=not no_backup,
+              file_list=file_list)
+
+
+class cmd_assert_fail(Command):
+    """Test reporting of assertion failures"""
+    hidden = True
+    def run(self):
+        assert False, "always fails"
+
+
+class cmd_help(Command):
+    """Show help on a command or other topic.
+
+    For a list of all available commands, say 'bzr help commands'."""
+    takes_options = ['long']
+    takes_args = ['topic?']
+    aliases = ['?']
+    
+    def run(self, topic=None, long=False):
+        import help
+        if topic is None and long:
+            topic = "commands"
+        help.help(topic)
+
+
+class cmd_shell_complete(Command):
+    """Show appropriate completions for context.
+
+    For a list of all available commands, say 'bzr shell-complete'."""
+    takes_args = ['context?']
+    aliases = ['s-c']
+    hidden = True
+    
+    def run(self, context=None):
+        import shellcomplete
+        shellcomplete.shellcomplete(context)
+
+
+class cmd_missing(Command):
+    """What is missing in this branch relative to other branch.
+    """
+    takes_args = ['remote?']
+    aliases = ['mis', 'miss']
+    # We don't have to add quiet to the list, because 
+    # unknown options are parsed as booleans
+    takes_options = ['verbose', 'quiet']
+
+    def run(self, remote=None, verbose=False, quiet=False):
+        from bzrlib.branch import find_branch, DivergedBranches
+        from bzrlib.errors import BzrCommandError
+        from bzrlib.missing import get_parent, show_missing
+
+        if verbose and quiet:
+            raise BzrCommandError('Cannot pass both quiet and verbose')
+
+        b = find_branch('.')
+        parent = get_parent(b)
+        if remote is None:
+            if parent is None:
+                raise BzrCommandError("No missing location known or specified.")
+            else:
+                if not quiet:
+                    print "Using last location: %s" % parent
+                remote = parent
+        elif parent is None:
+            # We only update x-pull if it did not exist, missing should not change the parent
+            b.controlfile('x-pull', 'wb').write(remote + '\n')
+        br_remote = find_branch(remote)
+
+        return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
+
+
+
+class cmd_plugins(Command):
+    """List plugins"""
+    hidden = True
+    def run(self):
+        import bzrlib.plugin
+        from inspect import getdoc
+        from pprint import pprint
+        for plugin in bzrlib.plugin.all_plugins:
+            if hasattr(plugin, '__path__'):
+                print plugin.__path__[0]
+            else:
+                print `plugin`
+            d = getdoc(plugin)
+            if d:
+                print '\t', d.split('\n')[0]
+
+        #pprint(bzrlib.plugin.all_plugins)
+
+
+
 # list of all available options; the rhs can be either None for an
 # option that takes no argument, or a constructor function that checks
 # the type.
@@ -376,7 +1712,6 @@
     'root':                   str,
     'no-backup':              None,
     'merge-type':             get_merge_type,
-    'pattern':                str,
     }
 
 SHORT_OPTIONS = {
@@ -399,8 +1734,6 @@
 
     >>> parse_args('--help'.split())
     ([], {'help': True})
-    >>> parse_args('help -- --invalidcmd'.split())
-    (['help', '--invalidcmd'], {})
     >>> parse_args('--version'.split())
     ([], {'version': True})
     >>> parse_args('status --all'.split())
@@ -419,18 +1752,15 @@
     args = []
     opts = {}
 
-    argsover = False
+    # TODO: Maybe handle '--' to end options?
+
     while argv:
         a = argv.pop(0)
-        if not argsover and a[0] == '-':
+        if a[0] == '-':
             # option names must not be unicode
             a = str(a)
             optarg = None
             if a[1] == '-':
-                if a == '--':
-                    # We've received a standalone -- No more flags
-                    argsover = True
-                    continue
                 mutter("  got option %r" % a)
                 if '=' in a:
                     optname, optarg = a[2:].split('=', 1)
@@ -538,31 +1868,6 @@
 
 
 
-def apply_profiled(the_callable, *args, **kwargs):
-    import hotshot
-    import tempfile
-    pffileno, pfname = tempfile.mkstemp()
-    try:
-        prof = hotshot.Profile(pfname)
-        try:
-            ret = prof.runcall(the_callable, *args, **kwargs) or 0
-        finally:
-            prof.close()
-
-        import hotshot.stats
-        stats = hotshot.stats.load(pfname)
-        #stats.strip_dirs()
-        stats.sort_stats('time')
-        ## XXX: Might like to write to stderr or the trace file instead but
-        ## print_stats seems hardcoded to stdout
-        stats.print_stats(20)
-
-        return ret
-    finally:
-        os.close(pffileno)
-        os.remove(pfname)
-
-
 def run_bzr(argv):
     """Execute a command.
 
@@ -587,8 +1892,6 @@
     --profile
         Run under the Python profiler.
     """
-    # Load all of the transport methods
-    import bzrlib.transport.local, bzrlib.transport.http
     
     argv = [a.decode(bzrlib.user_encoding) for a in argv]
 
@@ -598,7 +1901,7 @@
     # to load plugins before doing other command parsing so that they
     # can override commands, but this needs to happen first.
 
-    for a in argv:
+    for a in argv[:]:
         if a == '--profile':
             opt_profile = True
         elif a == '--no-plugins':
@@ -609,49 +1912,85 @@
             break
         argv.remove(a)
 
-    if (not argv) or (argv[0] == '--help'):
-        from bzrlib.help import help
-        if len(argv) > 1:
-            help(argv[1])
-        else:
-            help()
-        return 0
-
-    if argv[0] == '--version':
-        from bzrlib.builtins import show_version
-        show_version()
-        return 0
-        
     if not opt_no_plugins:
         from bzrlib.plugin import load_plugins
         load_plugins()
 
-    cmd = str(argv.pop(0))
-
-    cmd_obj = get_cmd_object(cmd, plugins_override=not opt_builtin)
+    args, opts = parse_args(argv)
+
+    if 'help' in opts:
+        from bzrlib.help import help
+        if args:
+            help(args[0])
+        else:
+            help()
+        return 0            
+        
+    if 'version' in opts:
+        show_version()
+        return 0
+    
+    if not args:
+        from bzrlib.help import help
+        help(None)
+        return 0
+    
+    cmd = str(args.pop(0))
+
+    canonical_cmd, cmd_class = \
+                   get_cmd_class(cmd, plugins_override=not opt_builtin)
+
+    # check options are reasonable
+    allowed = cmd_class.takes_options
+    for oname in opts:
+        if oname not in allowed:
+            raise BzrCommandError("option '--%s' is not allowed for command %r"
+                                  % (oname, cmd))
+
+    # mix arguments and options into one dictionary
+    cmdargs = _match_argform(cmd, cmd_class.takes_args, args)
+    cmdopts = {}
+    for k, v in opts.items():
+        cmdopts[k.replace('-', '_')] = v
 
     if opt_profile:
-        ret = apply_profiled(cmd_obj.run_argv, argv)
+        import hotshot, tempfile
+        pffileno, pfname = tempfile.mkstemp()
+        try:
+            prof = hotshot.Profile(pfname)
+            ret = prof.runcall(cmd_class, cmdopts, cmdargs) or 0
+            prof.close()
+
+            import hotshot.stats
+            stats = hotshot.stats.load(pfname)
+            #stats.strip_dirs()
+            stats.sort_stats('time')
+            ## XXX: Might like to write to stderr or the trace file instead but
+            ## print_stats seems hardcoded to stdout
+            stats.print_stats(20)
+            
+            return ret.status
+
+        finally:
+            os.close(pffileno)
+            os.remove(pfname)
     else:
-        ret = cmd_obj.run_argv(argv)
-    return ret or 0
+        return cmd_class(cmdopts, cmdargs).status 
 
 
 def main(argv):
     import bzrlib.ui
+    
     bzrlib.trace.log_startup(argv)
+
     bzrlib.ui.ui_factory = bzrlib.ui.TextUIFactory()
 
     try:
         try:
-            try:
-                return run_bzr(argv[1:])
-            finally:
-                # do this here inside the exception wrappers to catch EPIPE
-                sys.stdout.flush()
-        #wrap common errors as CommandErrors.
-        except (NotBranchError,), e:
-            raise BzrCommandError(str(e))
+            return run_bzr(argv[1:])
+        finally:
+            # do this here inside the exception wrappers to catch EPIPE
+            sys.stdout.flush()
     except BzrCommandError, e:
         # command line syntax error, etc
         log_error(str(e))
@@ -676,5 +2015,6 @@
             bzrlib.trace.log_exception()
             return 2
 
+
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-09-15 21:35:53 +0000
+++ bzrlib/commit.py	2005-08-24 00:34:21 +0000
@@ -16,6 +16,8 @@
 
 
 
+# FIXME: "bzr commit doc/format" commits doc/format.txt!
+
 def commit(branch, message,
            timestamp=None,
            timezone=None,
@@ -64,7 +66,7 @@
     from bzrlib.errors import BzrError, PointlessCommit
     from bzrlib.revision import Revision, RevisionReference
     from bzrlib.trace import mutter, note
-    from bzrlib.xml import serializer_v4
+    from bzrlib.xml import pack_xml
 
     branch.lock_write()
 
@@ -121,8 +123,7 @@
         inv_id = rev_id
 
         inv_tmp = tempfile.TemporaryFile()
-        
-        serializer_v4.write_inventory(new_inv, inv_tmp)
+        pack_xml(new_inv, inv_tmp)
         inv_tmp.seek(0)
         branch.inventory_store.add(inv_tmp, inv_id)
         mutter('new inventory_id is {%s}' % inv_id)
@@ -161,7 +162,7 @@
             rev.parents.append(RevisionReference(merge_rev))            
 
         rev_tmp = tempfile.TemporaryFile()
-        serializer_v4.write_revision(rev, rev_tmp)
+        pack_xml(rev, rev_tmp)
         rev_tmp.seek(0)
         branch.revision_store.add(rev_tmp, rev_id)
         mutter("new revision_id is {%s}" % rev_id)
@@ -248,7 +249,7 @@
         if not work_tree.has_id(file_id):
             if verbose:
                 print('deleted %s%s' % (path, kind_marker(entry.kind)))
-            any_changes = True
+                any_changes = True
             mutter("    file is missing, removing from inventory")
             missing_ids.append(file_id)
             continue
@@ -310,9 +311,7 @@
             else:
                 print 'renamed', marked
                 any_changes = True
-        elif old_ie != entry:
-            any_changes = True
-
+                        
     return missing_ids, inv, any_changes
 
 

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2005-09-15 13:32:36 +0000
+++ bzrlib/delta.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-09-15 13:11:01 +0000
+++ bzrlib/diff.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -44,16 +45,14 @@
     ud = difflib.unified_diff(oldlines, newlines,
                               fromfile=old_label, tofile=new_label)
 
-    ud = list(ud)
     # work-around for difflib being too smart for its own good
     # if /dev/null is "1,0", patch won't recognize it as /dev/null
     if not oldlines:
+        ud = list(ud)
         ud[2] = ud[2].replace('-1,0', '-0,0')
     elif not newlines:
+        ud = list(ud)
         ud[2] = ud[2].replace('+1,0', '+0,0')
-    # work around for difflib emitting random spaces after the label
-    ud[0] = ud[0][:-2] + '\n'
-    ud[1] = ud[1][:-2] + '\n'
 
     for line in ud:
         to_file.write(line)
@@ -145,7 +144,7 @@
 
 
 def show_diff(b, revision, specific_files, external_diff_options=None,
-              revision2=None, output=None):
+              revision2=None):
     """Shortcut for showing the diff to the working tree.
 
     b
@@ -157,9 +156,7 @@
     The more general form is show_diff_trees(), where the caller
     supplies any two trees.
     """
-    if output is None:
-        import sys
-        output = sys.stdout
+    import sys
 
     if revision == None:
         old_tree = b.basis_tree()
@@ -171,7 +168,7 @@
     else:
         new_tree = b.revision_tree(b.lookup_revision(revision2))
 
-    show_diff_trees(old_tree, new_tree, output, specific_files,
+    show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
                     external_diff_options)
 
 
@@ -212,7 +209,7 @@
                           specific_files=specific_files)
 
     for path, file_id, kind in delta.removed:
-        print >>to_file, '=== removed %s %r' % (kind, path)
+        print >>to_file, '*** removed %s %r' % (kind, path)
         if kind == 'file':
             diff_file(old_label + path,
                       old_tree.get_file(file_id).readlines(),
@@ -221,7 +218,7 @@
                       to_file)
 
     for path, file_id, kind in delta.added:
-        print >>to_file, '=== added %s %r' % (kind, path)
+        print >>to_file, '*** added %s %r' % (kind, path)
         if kind == 'file':
             diff_file(DEVNULL,
                       [],
@@ -230,7 +227,7 @@
                       to_file)
 
     for old_path, new_path, file_id, kind, text_modified in delta.renamed:
-        print >>to_file, '=== renamed %s %r => %r' % (kind, old_path, new_path)
+        print >>to_file, '*** renamed %s %r => %r' % (kind, old_path, new_path)
         if text_modified:
             diff_file(old_label + old_path,
                       old_tree.get_file(file_id).readlines(),
@@ -239,7 +236,7 @@
                       to_file)
 
     for path, file_id, kind in delta.modified:
-        print >>to_file, '=== modified %s %r' % (kind, path)
+        print >>to_file, '*** modified %s %r' % (kind, path)
         if kind == 'file':
             diff_file(old_label + path,
                       old_tree.get_file(file_id).readlines(),

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-09-15 13:32:36 +0000
+++ bzrlib/errors.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -24,7 +25,6 @@
 class BzrError(StandardError):
     pass
 
-
 class BzrCheckError(BzrError):
     pass
 
@@ -92,54 +92,15 @@
         BzrError.__init__(self, msg)
 
 
-class DivergedBranches(BzrError):
-    def __init__(self, branch1, branch2):
-        BzrError.__init__(self, "These branches have diverged.")
-        self.branch1 = branch1
-        self.branch2 = branch2
-
 class UnrelatedBranches(BzrCommandError):
     def __init__(self):
         msg = "Branches have no common ancestor, and no base revision"\
             " specified."
         BzrCommandError.__init__(self, msg)
 
-class NoCommonAncestor(BzrError):
-    def __init__(self, revision_a, revision_b):
-        msg = "Revisions have no common ancestor: %s %s." \
-            % (revision_a, revision_b) 
-        BzrError.__init__(self, msg)
-
-class NoCommonRoot(BzrError):
-    def __init__(self, revision_a, revision_b):
-        msg = "Revisions are not derived from the same root: %s %s." \
-            % (revision_a, revision_b) 
-        BzrError.__init__(self, msg)
-
-class NotAncestor(BzrError):
-    def __init__(self, rev_id, not_ancestor_id):
-        msg = "Revision %s is not an ancestor of %s" % (not_ancestor_id, 
-                                                        rev_id)
-        BzrError.__init__(self, msg)
-        self.rev_id = rev_id
-        self.not_ancestor_id = not_ancestor_id
-
 
 class InstallFailed(BzrError):
     def __init__(self, revisions):
+        self.revisions = revisions
         msg = "Could not install revisions:\n%s" % " ,".join(revisions)
         BzrError.__init__(self, msg)
-        self.revisions = revisions
-
-
-class AmbiguousBase(BzrError):
-    def __init__(self, bases):
-        msg = "The correct base is unclear, becase %s are all equally close" %\
-            ", ".join(bases)
-        BzrError.__init__(self, msg)
-        self.bases = bases
-
-class NoCommits(BzrError):
-    def __init__(self, branch):
-        msg = "Branch %s has no commits." % branch
-        BzrError.__init__(self, msg)

=== removed file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2005-09-01 11:53:02 +0000
+++ bzrlib/externalcommand.py	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# TODO: Perhaps rather than mapping options and arguments back and
-# forth, we should just pass in the whole argv, and allow
-# ExternalCommands to handle it differently to internal commands?
-
-
-import os
-import sys
-from bzrlib.commands import Command
-
-
-class ExternalCommand(Command):
-    """Class to wrap external commands."""
-
-    @classmethod
-    def find_command(cls, cmd):
-        import os.path
-        bzrpath = os.environ.get('BZRPATH', '')
-
-        for dir in bzrpath.split(os.pathsep):
-            path = os.path.join(dir, cmd)
-            if os.path.isfile(path):
-                return ExternalCommand(path)
-
-        return None
-
-
-    def __init__(self, path):
-        self.path = path
-
- 
-    def name(self):
-        return self.path.split(os.sep)[-1]
-
-
-    def run(self, *args, **kwargs):
-        raise NotImplementedError('should not be called on %r' % self)
-
-
-    def run_argv(self, argv):
-        return os.spawnv(os.P_WAIT, self.path, [self.path] + argv)
-
-
-    def help(self):
-        m = 'external command from %s\n\n' % self.path
-        pipe = os.popen('%s --help' % self.path)
-        return m + pipe.read()

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-09-04 02:59:56 +0000
+++ bzrlib/fetch.py	2005-08-25 09:07:41 +0000
@@ -64,7 +64,7 @@
         for rev_id in failed:
             note("Failed to install %s" % rev_id)
         all_failed.update(failed)
-        new_missing = set() 
+        new_missing = []
         for rev_id in missing:
             try:
                 revision = from_branch.get_revision(rev_id)
@@ -75,7 +75,7 @@
                     continue
             for parent in [p.revision_id for p in revision.parents]:
                 if not has_revision(to_branch, parent):
-                    new_missing.add(parent)
+                    new_missing.append(parent)
         missing = new_missing
     return count, all_failed
 

=== removed file 'bzrlib/graph.py'
--- bzrlib/graph.py	2005-09-12 02:53:07 +0000
+++ bzrlib/graph.py	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-# (C) 2005 Canonical
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-def max_distance(node, ancestors, distances, root_descendants):
-    """Calculate the max distance to an ancestor.  
-    Return None if not all possible ancestors have known distances"""
-    best = None
-    if node in distances:
-        best = distances[node]
-    for ancestor in ancestors[node]:
-        # skip ancestors we will never traverse:
-        if root_descendants is not None and ancestor not in root_descendants:
-            continue
-        # An ancestor which is not listed in ancestors will never be in
-        # distances, so we pretend it never existed.
-        if ancestor not in ancestors:
-            continue
-        if ancestor not in distances:
-            return None
-        if best is None or distances[ancestor] > best:
-            best = distances[ancestor] + 1
-    return best
-
-    
-def node_distances(graph, ancestors, start, root_descendants=None):
-    """Produce a list of nodes, sorted by distance from a start node.
-    This is an algorithm devised by Aaron Bentley, because applying Dijkstra
-    backwards seemed too complicated.
-
-    For each node, we walk its descendants.  If all the descendant's ancestors
-    have a max-distance-to-start, (excluding ones that can never reach start),
-    we calculate their max-distance-to-start, and schedule their descendants.
-
-    So when a node's last parent acquires a distance, it will acquire a
-    distance on the next iteration.
-
-    Once we know the max distances for all nodes, we can return a list sorted
-    by distance, farthest first.
-    """
-    distances = {start: 0}
-    lines = set([start])
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            line_descendants = graph[line]
-            assert line not in line_descendants, "%s refers to itself" % line
-            for descendant in line_descendants:
-                distance = max_distance(descendant, ancestors, distances,
-                                        root_descendants)
-                if distance is None:
-                    continue
-                distances[descendant] = distance
-                new_lines.add(descendant)
-        lines = new_lines
-    return distances
-
-def farthest_nodes(graph, ancestors, start):
-    def by_distance(n):
-        return distances[n],n
-
-    distances = node_distances(graph, ancestors, start)
-    node_list = distances.keys()
-    node_list.sort(key=by_distance, reverse=True)
-    return node_list
-
-def all_descendants(descendants, start):
-    result = set()
-    lines = set([start])
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            if line not in descendants:
-                continue
-            for descendant in descendants[line]:
-                if descendant in result:
-                    continue
-                result.add(descendant)
-                new_lines.add(descendant)
-        lines = new_lines
-    return result

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2005-09-12 09:47:33 +0000
+++ bzrlib/hashcache.py	2005-07-22 18:49:46 +0000
@@ -222,8 +222,6 @@
             inf = file(fn, 'rb', buffering=65000)
         except IOError, e:
             mutter("failed to open %s: %s" % (fn, e))
-            # better write it now so it is valid
-            self.needs_write = True
             return
 
 
@@ -231,7 +229,6 @@
         if hdr != CACHE_HEADER:
             mutter('cache header marker not found at top of %s; discarding cache'
                    % fn)
-            self.needs_write = True
             return
 
         for l in inf:

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2005-09-06 11:09:03 +0000
+++ bzrlib/help.py	2005-08-25 05:58:05 +0000
@@ -14,13 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-# TODO: Some way to get a list of external commands (defined by shell
-# scripts) so that they can be included in the help listing as well.
-# It should be enough to just list the plugin directory and look for
-# executable files with reasonable names.
-
-# TODO: `help commands --all` should show hidden commands
-
 global_help = \
 """Bazaar-NG -- a free distributed version-control tool
 http://bazaar-ng.org/
@@ -41,7 +34,7 @@
   bzr diff      show detailed diffs
 
   bzr merge     pull in changes from another branch
-  bzr commit    save some or all changes
+  bzr commit    
 
   bzr log       show history of changes
   bzr check     validate storage
@@ -65,13 +58,13 @@
         help_on_command(topic, outfile = outfile)
 
 
-def command_usage(cmd_object):
+def command_usage(cmdname, cmdclass):
     """Return single-line grammar for command.
 
     Only describes arguments, not options.
     """
-    s = 'bzr ' + cmd_object.name() + ' '
-    for aname in cmd_object.takes_args:
+    s = cmdname + ' '
+    for aname in cmdclass.takes_args:
         aname = aname.upper()
         if aname[-1] in ['$', '+']:
             aname = aname[:-1] + '...'
@@ -87,37 +80,34 @@
     return s
 
 
-def help_on_command(cmdname, outfile=None):
-    from bzrlib.commands import get_cmd_object
-
+def help_on_command(cmdname, outfile = None):
     cmdname = str(cmdname)
 
     if outfile == None:
         outfile = sys.stdout
 
-    cmd_object = get_cmd_object(cmdname)
+    from inspect import getdoc
+    import commands
+    topic, cmdclass = commands.get_cmd_class(cmdname)
 
-    doc = cmd_object.help()
+    doc = getdoc(cmdclass)
     if doc == None:
         raise NotImplementedError("sorry, no detailed help yet for %r" % cmdname)
 
-    print >>outfile, 'usage:', command_usage(cmd_object) 
-
-    if cmd_object.aliases:
-        print >>outfile, 'aliases:',
-        print >>outfile, ', '.join(cmd_object.aliases)
-
-    print >>outfile
-
+    outfile.write('usage: ' + command_usage(topic, cmdclass) + '\n')
+
+    if cmdclass.aliases:
+        outfile.write('aliases: ' + ', '.join(cmdclass.aliases) + '\n')
+    
     outfile.write(doc)
     if doc[-1] != '\n':
         outfile.write('\n')
     
-    help_on_options(cmd_object.takes_options, outfile=None)
-
-
-def help_on_options(options, outfile=None):
-    from bzrlib.commands import SHORT_OPTIONS
+    help_on_option(cmdclass.takes_options, outfile = None)
+
+
+def help_on_option(options, outfile = None):
+    import commands
     
     if not options:
         return
@@ -128,35 +118,32 @@
     outfile.write('\noptions:\n')
     for on in options:
         l = '    --' + on
-        for shortname, longname in SHORT_OPTIONS.items():
+        for shortname, longname in commands.SHORT_OPTIONS.items():
             if longname == on:
                 l += ', -' + shortname
                 break
         outfile.write(l + '\n')
 
 
-def help_commands(outfile=None):
+def help_commands(outfile = None):
     """List all commands"""
-    from bzrlib.commands import (builtin_command_names,
-                                 plugin_command_names,
-                                 get_cmd_object)
+    import inspect
+    import commands
 
     if outfile == None:
         outfile = sys.stdout
-
-    names = set()                       # to eliminate duplicates
-    names.update(builtin_command_names())
-    names.update(plugin_command_names())
-    names = list(names)
-    names.sort()
-
-    for cmd_name in names:
-        cmd_object = get_cmd_object(cmd_name)
-        if cmd_object.hidden:
+    
+    accu = []
+    for cmdname, cmdclass in commands.get_all_cmds():
+        accu.append((cmdname, cmdclass))
+    accu.sort()
+    for cmdname, cmdclass in accu:
+        if cmdclass.hidden:
             continue
-        print >>outfile, command_usage(cmd_object)
-        cmd_help = cmd_object.help()
-        if cmd_help:
-            firstline = cmd_help.split('\n', 1)[0]
-            print >>outfile, '    ' + firstline
-        
+        outfile.write(command_usage(cmdname, cmdclass) + '\n')
+        help = inspect.getdoc(cmdclass)
+        if help:
+            outfile.write("    " + help.split('\n', 1)[0] + '\n')
+
+            
+

=== modified file 'bzrlib/intset.py'
--- bzrlib/intset.py	2005-09-15 13:32:36 +0000
+++ bzrlib/intset.py	2005-07-17 18:26:45 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
@@ -208,3 +210,12 @@
         if not self._val & m:
             raise KeyError(to_remove)
         self._val ^= m
+        
+        
+            
+    
+
+if __name__ == '__main__':
+    import doctest
+    doctest.testmod()
+    

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-09-06 07:26:13 +0000
+++ bzrlib/inventory.py	2005-08-25 05:58:05 +0000
@@ -55,9 +55,7 @@
     >>> i.path2id('')
     'TREE_ROOT'
     >>> i.add(InventoryEntry('123', 'src', 'directory', ROOT_ID))
-    InventoryEntry('123', 'src', kind='directory', parent_id='TREE_ROOT')
     >>> i.add(InventoryEntry('2323', 'hello.c', 'file', parent_id='123'))
-    InventoryEntry('2323', 'hello.c', kind='file', parent_id='123')
     >>> for j in i.iter_entries():
     ...   print j
     ... 
@@ -68,15 +66,12 @@
     ...
     BzrError: inventory already contains entry with id {2323}
     >>> i.add(InventoryEntry('2324', 'bye.c', 'file', '123'))
-    InventoryEntry('2324', 'bye.c', kind='file', parent_id='123')
     >>> i.add(InventoryEntry('2325', 'wibble', 'directory', '123'))
-    InventoryEntry('2325', 'wibble', kind='directory', parent_id='123')
     >>> i.path2id('src/wibble')
     '2325'
     >>> '2325' in i
     True
     >>> i.add(InventoryEntry('2326', 'wibble.c', 'file', '2325'))
-    InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> i['2326']
     InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> for j in i.iter_entries():
@@ -100,9 +95,7 @@
     # directories, etc etc.
 
     __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children',
-                 'text_version', 'entry_version', ]
-
+                 'text_id', 'parent_id', 'children', ]
 
     def __init__(self, file_id, name, kind, parent_id, text_id=None):
         """Create an InventoryEntry
@@ -119,14 +112,12 @@
         Traceback (most recent call last):
         BzrCheckError: InventoryEntry name 'src/hello.c' is invalid
         """
-        assert isinstance(name, basestring), name
         if '/' in name or '\\' in name:
             raise BzrCheckError('InventoryEntry name %r is invalid' % name)
         
-        self.text_version = None
-        self.entry_version = None
         self.text_sha1 = None
         self.text_size = None
+    
         self.file_id = file_id
         self.name = name
         self.kind = kind
@@ -166,6 +157,60 @@
                    self.parent_id))
 
     
+    def to_element(self):
+        """Convert to XML element"""
+        from bzrlib.xml import Element
+        
+        e = Element('entry')
+
+        e.set('name', self.name)
+        e.set('file_id', self.file_id)
+        e.set('kind', self.kind)
+
+        if self.text_size != None:
+            e.set('text_size', '%d' % self.text_size)
+            
+        for f in ['text_id', 'text_sha1']:
+            v = getattr(self, f)
+            if v != None:
+                e.set(f, v)
+
+        # to be conservative, we don't externalize the root pointers
+        # for now, leaving them as null in the xml form.  in a future
+        # version it will be implied by nested elements.
+        if self.parent_id != ROOT_ID:
+            assert isinstance(self.parent_id, basestring)
+            e.set('parent_id', self.parent_id)
+
+        e.tail = '\n'
+            
+        return e
+
+
+    def from_element(cls, elt):
+        assert elt.tag == 'entry'
+
+        ## original format inventories don't have a parent_id for
+        ## nodes in the root directory, but it's cleaner to use one
+        ## internally.
+        parent_id = elt.get('parent_id')
+        if parent_id == None:
+            parent_id = ROOT_ID
+
+        self = cls(elt.get('file_id'), elt.get('name'), elt.get('kind'), parent_id)
+        self.text_id = elt.get('text_id')
+        self.text_sha1 = elt.get('text_sha1')
+        
+        ## mutter("read inventoryentry: %r" % (elt.attrib))
+
+        v = elt.get('text_size')
+        self.text_size = v and int(v)
+
+        return self
+            
+
+    from_element = classmethod(from_element)
+
     def __eq__(self, other):
         if not isinstance(other, InventoryEntry):
             return NotImplemented
@@ -176,9 +221,7 @@
                and (self.text_size == other.text_size) \
                and (self.text_id == other.text_id) \
                and (self.parent_id == other.parent_id) \
-               and (self.kind == other.kind) \
-               and (self.text_version == other.text_version) \
-               and (self.entry_version == other.entry_version)
+               and (self.kind == other.kind)
 
 
     def __ne__(self, other):
@@ -225,7 +268,6 @@
 
     >>> inv = Inventory()
     >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
-    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT')
     >>> inv['123-123'].name
     'hello.c'
 
@@ -242,7 +284,6 @@
     ['hello.c']
     >>> inv = Inventory('TREE_ROOT-12345678-12345678')
     >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
-    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT-12345678-12345678')
     """
     def __init__(self, root_id=ROOT_ID):
         """Create or read an inventory.
@@ -330,7 +371,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> '456' in inv
@@ -344,7 +384,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123123', 'hello.c', 'file', ROOT_ID))
-        InventoryEntry('123123', 'hello.c', kind='file', parent_id='TREE_ROOT')
         >>> inv['123123'].name
         'hello.c'
         """
@@ -368,10 +407,7 @@
         """Add entry to inventory.
 
         To add  a file to a branch ready to be committed, use Branch.add,
-        which calls this.
-
-        Returns the new entry object.
-        """
+        which calls this."""
         if entry.file_id in self._byid:
             raise BzrError("inventory already contains entry with id {%s}" % entry.file_id)
 
@@ -389,15 +425,12 @@
 
         self._byid[entry.file_id] = entry
         parent.children[entry.name] = entry
-        return entry
 
 
     def add_path(self, relpath, kind, file_id=None):
         """Add entry from a path.
 
-        The immediate parent must already be versioned.
-
-        Returns the new entry object."""
+        The immediate parent must already be versioned"""
         from bzrlib.branch import gen_file_id
         
         parts = bzrlib.osutils.splitpath(relpath)
@@ -422,7 +455,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> del inv['123']
@@ -444,6 +476,43 @@
         del self[ie.parent_id].children[ie.name]
 
 
+    def to_element(self):
+        """Convert to XML Element"""
+        from bzrlib.xml import Element
+        
+        e = Element('inventory')
+        e.text = '\n'
+        if self.root.file_id not in (None, ROOT_ID):
+            e.set('file_id', self.root.file_id)
+        for path, ie in self.iter_entries():
+            e.append(ie.to_element())
+        return e
+    
+
+    def from_element(cls, elt):
+        """Construct from XML Element
+        
+        >>> inv = Inventory()
+        >>> inv.add(InventoryEntry('foo.c-123981239', 'foo.c', 'file', ROOT_ID))
+        >>> elt = inv.to_element()
+        >>> inv2 = Inventory.from_element(elt)
+        >>> inv2 == inv
+        True
+        """
+        # XXXX: doctest doesn't run this properly under python2.3
+        assert elt.tag == 'inventory'
+        root_id = elt.get('file_id') or ROOT_ID
+        o = cls(root_id)
+        for e in elt:
+            ie = InventoryEntry.from_element(e)
+            if ie.parent_id == ROOT_ID:
+                ie.parent_id = root_id
+            o.add(ie)
+        return o
+        
+    from_element = classmethod(from_element)
+
+
     def __eq__(self, other):
         """Compare two sets by comparing their contents.
 
@@ -452,11 +521,9 @@
         >>> i1 == i2
         True
         >>> i1.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         False
         >>> i2.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         True
         """
@@ -478,6 +545,7 @@
         raise ValueError('not hashable')
 
 
+
     def get_idpath(self, file_id):
         """Return a list of file_ids for the path to an entry.
 

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-09-05 05:35:25 +0000
+++ bzrlib/log.py	2005-08-25 05:58:05 +0000
@@ -53,6 +53,7 @@
 from bzrlib.tree import EmptyTree
 from bzrlib.delta import compare_trees
 from bzrlib.trace import mutter
+from bzrlib.errors import InvalidRevisionNumber
 
 
 def find_touching_revisions(branch, file_id):
@@ -161,13 +162,13 @@
     
     if start_revision is None:
         start_revision = 1
-    else:
-        branch.check_real_revno(start_revision)
+    elif start_revision < 1 or start_revision >= len(which_revs):
+        raise InvalidRevisionNumber(start_revision)
     
     if end_revision is None:
         end_revision = len(which_revs)
-    else:
-        branch.check_real_revno(end_revision)
+    elif end_revision < 1 or end_revision >= len(which_revs):
+        raise InvalidRevisionNumber(end_revision)
 
     # list indexes are 0-based; revisions are 1-based
     cut_revs = which_revs[(start_revision-1):(end_revision)]
@@ -309,10 +310,6 @@
         print >>to_file,  'revno:', revno
         if self.show_ids:
             print >>to_file,  'revision-id:', rev.revision_id
-
-            for parent in rev.parents:
-                print >>to_file, 'parent:', parent.revision_id
-            
         print >>to_file,  'committer:', rev.committer
 
         date_str = format_date(rev.timestamp,

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-09-14 16:35:46 +0000
+++ bzrlib/merge.py	2005-08-25 09:17:19 +0000
@@ -15,11 +15,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-import os
+import os.path
 import tempfile
 import shutil
 import errno
-from fetch import greedy_fetch
 
 import bzrlib.osutils
 import bzrlib.revision
@@ -27,8 +26,7 @@
 from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
 from bzrlib.changeset import Inventory, Diff3Merge
 from bzrlib.branch import find_branch
-from bzrlib.errors import BzrCommandError, UnrelatedBranches, NoCommonAncestor
-from bzrlib.errors import NoCommits
+from bzrlib.errors import BzrCommandError, UnrelatedBranches
 from bzrlib.delta import compare_trees
 from bzrlib.trace import mutter, warning
 from bzrlib.fetch import greedy_fetch
@@ -197,11 +195,6 @@
             return True
         return self.tree.inventory.has_id(file_id)
 
-    def has_or_had_id(self, file_id):
-        if file_id == self.tree.inventory.root.file_id:
-            return True
-        return self.tree.inventory.has_id(file_id)
-
     def readonly_path(self, id):
         if id not in self.tree:
             return None
@@ -227,9 +220,9 @@
     """Merge changes into a tree.
 
     base_revision
-        tuple(path, revision) Base for three-way merge.
+        Base for three-way merge.
     other_revision
-        tuple(path, revision) Other revision for three-way merge.
+        Other revision for three-way merge.
     this_dir
         Directory to merge changes into; '.' by default.
     check_clean
@@ -257,8 +250,6 @@
                                             this_branch)
         if other_revision[1] == -1:
             other_rev_id = other_branch.last_patch()
-            if other_rev_id is None:
-                raise NoCommits(other_branch)
             other_basis = other_rev_id
         elif other_revision[1] is not None:
             other_rev_id = other_branch.lookup_revision(other_revision[1])
@@ -266,16 +257,19 @@
         else:
             other_rev_id = None
             other_basis = other_branch.last_patch()
-            if other_basis is None:
-                raise NoCommits(other_branch)
         if base_revision == [None, None]:
+            if other_revision[1] == -1:
+                o_revno = None
+            else:
+                o_revno = other_revision[1]
+                raise UnrelatedBranches()
             try:
-                base_rev_id = common_ancestor(this_rev_id, other_basis, 
-                                              this_branch)
-            except NoCommonAncestor:
-                raise UnrelatedBranches()
-            base_tree = get_revid_tree(this_branch, base_rev_id, tempdir, 
-                                       "base", None)
+                base_revision = this_branch.get_revision(base_rev_id)
+                base_branch = this_branch
+            except NoSuchRevision:
+                base_branch = other_branch
+            base_tree = get_revid_tree(base_branch, base_rev_id, tempdir, 
+                                       "base")
             base_is_ancestor = True
         else:
             base_branch, base_tree = get_tree(base_revision, tempdir, "base")
@@ -310,8 +304,7 @@
         merge_inner(this_branch, other_tree, base_tree, tempdir, 
                     ignore_zero=ignore_zero, backup_files=backup_files, 
                     merge_type=merge_type, interesting_ids=interesting_ids)
-        if base_is_ancestor and other_rev_id is not None\
-            and other_rev_id not in this_branch.revision_history():
+        if base_is_ancestor and other_rev_id is not None:
             this_branch.add_pending_merge(other_rev_id)
     finally:
         shutil.rmtree(tempdir)
@@ -363,7 +356,7 @@
             if path == '.':
                 path = ''
             else:
-                assert path.startswith('.' + os.sep), "path is %s" % path
+                assert path.startswith('./'), "path is %s" % path
             path = path[2:]
         adjust_ids.append((path, id))
     if len(adjust_ids) > 0:

=== modified file 'bzrlib/merge3.py'
--- bzrlib/merge3.py	2005-09-04 02:59:56 +0000
+++ bzrlib/merge3.py	2005-07-06 04:09:02 +0000
@@ -76,9 +76,9 @@
     def merge_lines(self,
                     name_a=None,
                     name_b=None,
-                    start_marker='<<<<<<<',
-                    mid_marker='=======',
-                    end_marker='>>>>>>>',
+                    start_marker='<<<<<<<<',
+                    mid_marker='========',
+                    end_marker='>>>>>>>>',
                     show_base=False):
         """Return merge in cvs-like form.
         """

=== modified file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2005-08-27 04:42:41 +0000
+++ bzrlib/merge_core.py	2005-08-25 05:58:05 +0000
@@ -45,7 +45,7 @@
                        start_marker=start_marker):
             if line.startswith(start_marker):
                 new_conflicts = True
-                output_file.write(line.replace(start_marker, '<' * 7))
+                output_file.write(line.replace(start_marker, '<<<<<<<<'))
             else:
                 output_file.write(line)
         output_file.close()
@@ -275,3 +275,474 @@
             os.chmod(filename, other_stat)
         else:
             conflict_handler.permission_conflict(filename, base, other)
+
+
+import unittest
+import tempfile
+import shutil
+from bzrlib.inventory import InventoryEntry, RootEntry
+from osutils import file_kind
+class FalseTree(object):
+    def __init__(self, realtree):
+        self._realtree = realtree
+        self.inventory = self
+
+    def __getitem__(self, file_id):
+        entry = self.make_inventory_entry(file_id)
+        if entry is None:
+            raise KeyError(file_id)
+        return entry
+        
+    def make_inventory_entry(self, file_id):
+        path = self._realtree.inventory.get(file_id)
+        if path is None:
+            return None
+        if path == "":
+            return RootEntry(file_id)
+        dir, name = os.path.split(path)
+        kind = file_kind(self._realtree.abs_path(path))
+        for parent_id, path in self._realtree.inventory.iteritems():
+            if path == dir:
+                break
+        if path != dir:
+            raise Exception("Can't find parent for %s" % name)
+        return InventoryEntry(file_id, name, kind, parent_id)
+
+
+class MergeTree(object):
+    def __init__(self, dir):
+        self.dir = dir;
+        os.mkdir(dir)
+        self.inventory = {'0': ""}
+        self.tree = FalseTree(self)
+    
+    def child_path(self, parent, name):
+        return os.path.join(self.inventory[parent], name)
+
+    def add_file(self, id, parent, name, contents, mode):
+        path = self.child_path(parent, name)
+        full_path = self.abs_path(path)
+        assert not os.path.exists(full_path)
+        file(full_path, "wb").write(contents)
+        os.chmod(self.abs_path(path), mode)
+        self.inventory[id] = path
+
+    def remove_file(self, id):
+        os.unlink(self.full_path(id))
+        del self.inventory[id]
+
+    def add_dir(self, id, parent, name, mode):
+        path = self.child_path(parent, name)
+        full_path = self.abs_path(path)
+        assert not os.path.exists(full_path)
+        os.mkdir(self.abs_path(path))
+        os.chmod(self.abs_path(path), mode)
+        self.inventory[id] = path
+
+    def abs_path(self, path):
+        return os.path.join(self.dir, path)
+
+    def full_path(self, id):
+        try:
+            tree_path = self.inventory[id]
+        except KeyError:
+            return None
+        return self.abs_path(tree_path)
+
+    def readonly_path(self, id):
+        return self.full_path(id)
+
+    def __contains__(self, file_id):
+        return file_id in self.inventory
+
+    def has_or_had_id(self, file_id):
+        return file_id in self
+
+    def get_file(self, file_id):
+        path = self.readonly_path(file_id)
+        return file(path, "rb")
+
+    def id2path(self, file_id):
+        return self.inventory[file_id]
+
+    def change_path(self, id, path):
+        new = os.path.join(self.dir, self.inventory[id])
+        os.rename(self.abs_path(self.inventory[id]), self.abs_path(path))
+        self.inventory[id] = path
+
+class MergeBuilder(object):
+    def __init__(self):
+        self.dir = tempfile.mkdtemp(prefix="BaZing")
+        self.base = MergeTree(os.path.join(self.dir, "base"))
+        self.this = MergeTree(os.path.join(self.dir, "this"))
+        self.other = MergeTree(os.path.join(self.dir, "other"))
+        
+        self.cset = changeset.Changeset()
+        self.cset.add_entry(changeset.ChangesetEntry("0", 
+                                                     changeset.NULL_ID, "./."))
+    def get_cset_path(self, parent, name):
+        if name is None:
+            assert (parent is None)
+            return None
+        return os.path.join(self.cset.entries[parent].path, name)
+
+    def add_file(self, id, parent, name, contents, mode):
+        self.base.add_file(id, parent, name, contents, mode)
+        self.this.add_file(id, parent, name, contents, mode)
+        self.other.add_file(id, parent, name, contents, mode)
+        path = self.get_cset_path(parent, name)
+        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
+
+    def remove_file(self, id, base=False, this=False, other=False):
+        for option, tree in ((base, self.base), (this, self.this), 
+                             (other, self.other)):
+            if option:
+                tree.remove_file(id)
+            if other or base:
+                change = self.cset.entries[id].contents_change
+                if change is None:
+                    change = changeset.ReplaceContents(None, None)
+                    self.cset.entries[id].contents_change = change
+                    def create_file(tree):
+                        return changeset.FileCreate(tree.get_file(id).read())
+                    if not other:
+                        change.new_contents = create_file(self.other)
+                    if not base:
+                        change.old_contents = create_file(self.base)
+                else:
+                    assert isinstance(change, changeset.ReplaceContents)
+                if other:
+                    change.new_contents=None
+                if base:
+                    change.old_contents=None
+                if change.old_contents is None and change.new_contents is None:
+                    change = None
+
+
+    def add_dir(self, id, parent, name, mode):
+        path = self.get_cset_path(parent, name)
+        self.base.add_dir(id, parent, name, mode)
+        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
+        self.this.add_dir(id, parent, name, mode)
+        self.other.add_dir(id, parent, name, mode)
+
+
+    def change_name(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_name_tree(id, self.base, base)
+            self.cset.entries[id].name = base
+
+        if this is not None:
+            self.change_name_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_name_tree(id, self.other, other)
+            self.cset.entries[id].new_name = other
+
+    def change_parent(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_parent_tree(id, self.base, base)
+            self.cset.entries[id].parent = base
+            self.cset.entries[id].dir = self.cset.entries[base].path
+
+        if this is not None:
+            self.change_parent_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_parent_tree(id, self.other, other)
+            self.cset.entries[id].new_parent = other
+            self.cset.entries[id].new_dir = \
+                self.cset.entries[other].new_path
+
+    def change_contents(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_contents_tree(id, self.base, base)
+
+        if this is not None:
+            self.change_contents_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_contents_tree(id, self.other, other)
+
+        if base is not None or other is not None:
+            old_contents = file(self.base.full_path(id)).read()
+            new_contents = file(self.other.full_path(id)).read()
+            contents = changeset.ReplaceFileContents(old_contents, 
+                                                     new_contents)
+            self.cset.entries[id].contents_change = contents
+
+    def change_perms(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_perms_tree(id, self.base, base)
+
+        if this is not None:
+            self.change_perms_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_perms_tree(id, self.other, other)
+
+        if base is not None or other is not None:
+            old_perms = os.stat(self.base.full_path(id)).st_mode &077
+            new_perms = os.stat(self.other.full_path(id)).st_mode &077
+            contents = changeset.ChangeUnixPermissions(old_perms, 
+                                                       new_perms)
+            self.cset.entries[id].metadata_change = contents
+
+    def change_name_tree(self, id, tree, name):
+        new_path = tree.child_path(self.cset.entries[id].parent, name)
+        tree.change_path(id, new_path)
+
+    def change_parent_tree(self, id, tree, parent):
+        new_path = tree.child_path(parent, self.cset.entries[id].name)
+        tree.change_path(id, new_path)
+
+    def change_contents_tree(self, id, tree, contents):
+        path = tree.full_path(id)
+        mode = os.stat(path).st_mode
+        file(path, "w").write(contents)
+        os.chmod(path, mode)
+
+    def change_perms_tree(self, id, tree, mode):
+        os.chmod(tree.full_path(id), mode)
+
+    def merge_changeset(self, merge_factory):
+        conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
+        return make_merge_changeset(self.cset, self.this, self.base,
+                                    self.other, conflict_handler,
+                                    merge_factory)
+
+    def apply_inv_change(self, inventory_change, orig_inventory):
+        orig_inventory_by_path = {}
+        for file_id, path in orig_inventory.iteritems():
+            orig_inventory_by_path[path] = file_id
+
+        def parent_id(file_id):
+            try:
+                parent_dir = os.path.dirname(orig_inventory[file_id])
+            except:
+                print file_id
+                raise
+            if parent_dir == "":
+                return None
+            return orig_inventory_by_path[parent_dir]
+        
+        def new_path(file_id):
+            if inventory_change.has_key(file_id):
+                return inventory_change[file_id]
+            else:
+                parent = parent_id(file_id)
+                if parent is None:
+                    return orig_inventory[file_id]
+                dirname = new_path(parent)
+                return os.path.join(dirname, orig_inventory[file_id])
+
+        new_inventory = {}
+        for file_id in orig_inventory.iterkeys():
+            path = new_path(file_id)
+            if path is None:
+                continue
+            new_inventory[file_id] = path
+
+        for file_id, path in inventory_change.iteritems():
+            if orig_inventory.has_key(file_id):
+                continue
+            new_inventory[file_id] = path
+        return new_inventory
+
+        
+
+    def apply_changeset(self, cset, conflict_handler=None, reverse=False):
+        inventory_change = changeset.apply_changeset(cset,
+                                                     self.this.inventory,
+                                                     self.this.dir,
+                                                     conflict_handler, reverse)
+        self.this.inventory =  self.apply_inv_change(inventory_change, 
+                                                     self.this.inventory)
+
+                    
+        
+
+        
+    def cleanup(self):
+        shutil.rmtree(self.dir)
+
+
+class MergeTest(unittest.TestCase):
+    def test_change_name(self):
+        """Test renames"""
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "hello1", 0755)
+        builder.change_name("1", other="name2")
+        builder.add_file("2", "0", "name3", "hello2", 0755)
+        builder.change_name("2", base="name4")
+        builder.add_file("3", "0", "name5", "hello3", 0755)
+        builder.change_name("3", this="name6")
+        cset = builder.merge_changeset(ApplyMerge3)
+        assert(cset.entries["2"].is_boring())
+        assert(cset.entries["1"].name == "name1")
+        assert(cset.entries["1"].new_name == "name2")
+        assert(cset.entries["3"].is_boring())
+        for tree in (builder.this, builder.other, builder.base):
+            assert(tree.dir != builder.dir and 
+                   tree.dir.startswith(builder.dir))
+            for path in tree.inventory.itervalues():
+                fullpath = tree.abs_path(path)
+                assert(fullpath.startswith(tree.dir))
+                assert(not path.startswith(tree.dir))
+                assert os.path.exists(fullpath)
+        builder.apply_changeset(cset)
+        builder.cleanup()
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "hello1", 0644)
+        builder.change_name("1", other="name2", this="name3")
+        self.assertRaises(changeset.RenameConflict, 
+                          builder.merge_changeset, ApplyMerge3)
+        builder.cleanup()
+        
+    def test_file_moves(self):
+        """Test moves"""
+        builder = MergeBuilder()
+        builder.add_dir("1", "0", "dir1", 0755)
+        builder.add_dir("2", "0", "dir2", 0755)
+        builder.add_file("3", "1", "file1", "hello1", 0644)
+        builder.add_file("4", "1", "file2", "hello2", 0644)
+        builder.add_file("5", "1", "file3", "hello3", 0644)
+        builder.change_parent("3", other="2")
+        assert(Inventory(builder.other.inventory).get_parent("3") == "2")
+        builder.change_parent("4", this="2")
+        assert(Inventory(builder.this.inventory).get_parent("4") == "2")
+        builder.change_parent("5", base="2")
+        assert(Inventory(builder.base.inventory).get_parent("5") == "2")
+        cset = builder.merge_changeset(ApplyMerge3)
+        for id in ("1", "2", "4", "5"):
+            assert(cset.entries[id].is_boring())
+        assert(cset.entries["3"].parent == "1")
+        assert(cset.entries["3"].new_parent == "2")
+        builder.apply_changeset(cset)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_dir("1", "0", "dir1", 0755)
+        builder.add_dir("2", "0", "dir2", 0755)
+        builder.add_dir("3", "0", "dir3", 0755)
+        builder.add_file("4", "1", "file1", "hello1", 0644)
+        builder.change_parent("4", other="2", this="3")
+        self.assertRaises(changeset.MoveConflict, 
+                          builder.merge_changeset, ApplyMerge3)
+        builder.cleanup()
+
+    def test_contents_merge(self):
+        """Test merge3 merging"""
+        self.do_contents_test(ApplyMerge3)
+
+    def test_contents_merge2(self):
+        """Test diff3 merging"""
+        self.do_contents_test(changeset.Diff3Merge)
+
+    def test_contents_merge3(self):
+        """Test diff3 merging"""
+        def backup_merge(file_id, base, other):
+            return BackupBeforeChange(ApplyMerge3(file_id, base, other))
+        builder = self.contents_test_success(backup_merge)
+        def backup_exists(file_id):
+            return os.path.exists(builder.this.full_path(file_id)+"~")
+        assert backup_exists("1")
+        assert backup_exists("2")
+        assert not backup_exists("3")
+        builder.cleanup()
+
+    def do_contents_test(self, merge_factory):
+        """Test merging with specified ContentsChange factory"""
+        builder = self.contents_test_success(merge_factory)
+        builder.cleanup()
+        self.contents_test_conflicts(merge_factory)
+
+    def contents_test_success(self, merge_factory):
+        from inspect import isclass
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4")
+        builder.add_file("2", "0", "name3", "text2", 0655)
+        builder.change_contents("2", base="text5")
+        builder.add_file("3", "0", "name5", "text3", 0744)
+        builder.add_file("4", "0", "name6", "text4", 0744)
+        builder.remove_file("4", base=True)
+        assert not builder.cset.entries["4"].is_boring()
+        builder.change_contents("3", this="text6")
+        cset = builder.merge_changeset(merge_factory)
+        assert(cset.entries["1"].contents_change is not None)
+        if isclass(merge_factory):
+            assert(isinstance(cset.entries["1"].contents_change,
+                          merge_factory))
+            assert(isinstance(cset.entries["2"].contents_change,
+                          merge_factory))
+        assert(cset.entries["3"].is_boring())
+        assert(cset.entries["4"].is_boring())
+        builder.apply_changeset(cset)
+        assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
+        assert(file(builder.this.full_path("2"), "rb").read() == "text2" )
+        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
+        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
+        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
+        return builder
+
+    def contents_test_conflicts(self, merge_factory):
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", this="text3")
+        cset = builder.merge_changeset(merge_factory)
+        self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
+                          cset)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", base="text3")
+        builder.remove_file("1", base=True)
+        self.assertRaises(changeset.NewContentsConflict,
+                          builder.merge_changeset, merge_factory)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", base="text3")
+        builder.remove_file("1", this=True)
+        self.assertRaises(changeset.MissingForMerge, builder.merge_changeset, 
+                          merge_factory)
+        builder.cleanup()
+
+    def test_perms_merge(self):
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_perms("1", other=0655)
+        builder.add_file("2", "0", "name2", "text2", 0755)
+        builder.change_perms("2", base=0655)
+        builder.add_file("3", "0", "name3", "text3", 0755)
+        builder.change_perms("3", this=0655)
+        cset = builder.merge_changeset(ApplyMerge3)
+        assert(cset.entries["1"].metadata_change is not None)
+        assert(isinstance(cset.entries["1"].metadata_change,
+                          PermissionsMerge))
+        assert(isinstance(cset.entries["2"].metadata_change,
+                          PermissionsMerge))
+        assert(cset.entries["3"].is_boring())
+        builder.apply_changeset(cset)
+        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0655)
+        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0755)
+        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0655)
+        builder.cleanup();
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_perms("1", other=0655, base=0555)
+        cset = builder.merge_changeset(ApplyMerge3)
+        self.assertRaises(changeset.MergePermissionConflict, 
+                     builder.apply_changeset, cset)
+        builder.cleanup()
+
+def test():        
+    changeset_suite = unittest.makeSuite(MergeTest, 'test_')
+    runner = unittest.TextTestRunner()
+    runner.run(changeset_suite)
+        
+if __name__ == "__main__":
+    test()

=== modified file 'bzrlib/meta_store.py'
--- bzrlib/meta_store.py	2005-09-15 21:35:53 +0000
+++ bzrlib/meta_store.py	2005-06-27 01:36:22 +0000
@@ -15,22 +15,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from trace import mutter
-from bzrlib.store import Storage, CompressedTextStore
-from bzrlib.local_transport import LocalTransport
-
-try:
-    set
-except NameError:
-    from sets import Set as set
-
-class CachedStore(Storage):
+from bzrlib.store import ImmutableStore
+
+class CachedStore:
     """A store that caches data locally, to avoid repeated downloads.
     The precacache method should be used to avoid server round-trips for
     every piece of data.
     """
     def __init__(self, store, cache_dir):
         self.source_store = store
-        self.cache_store = CompressedTextStore(LocalTransport(cache_dir))
+        self.cache_store = ImmutableStore(cache_dir)
 
     def __getitem__(self, id):
         mutter("Cache add %s" % id)
@@ -38,32 +32,10 @@
             self.cache_store.add(self.source_store[id], id)
         return self.cache_store[id]
 
-    def __contains__(self, fileid):
-        if fileid in self.cache_store:
-            return True
-        if fileid in self.source_store:
-            # We could copy at this time
-            return True
-        return False
-
-    def get(self, fileids, pb=None):
-        fileids = list(fileids)
-        hasids = self.cache_store.has(fileids)
-        needs = set()
-        for has, fileid in zip(hasids, fileids):
-            if not has:
-                needs.add(fileid)
-        if needs:
-            self.cache_store.copy_multi(self.source_store, needs)
-        return self.cache_store.get(fileids, pb=pb)
-
     def prefetch(self, ids):
         """Copy a series of ids into the cache, before they are used.
         For remote stores that support pipelining or async downloads, this can
         increase speed considerably.
-
-        Failures while prefetching are ignored.
         """
         mutter("Prefetch of ids %s" % ",".join(ids))
-        self.cache_store.copy_multi(self.source_store, ids, 
-                                    permit_failure=True)
+        self.cache_store.copy_multi(self.source_store, ids)

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-09-15 13:32:36 +0000
+++ bzrlib/missing.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#!/usr/bin/env python
 """\
 A plugin for displaying what revisions are in 'other' but not in local.
 """
@@ -10,6 +11,24 @@
     from sets import Set as set
 
 
+def get_parent(branch):
+    """Get the last pull/push location.
+
+    TODO: This should probably be part of a Branch object.
+    """
+    import errno
+    _locs = ['parent', 'pull', 'x-pull']
+    loc = None
+    for l in _locs:
+        try:
+            stored_loc = branch.controlfile(l, 'rb').read().strip('\n')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+        else:
+            return stored_loc
+
+
 def show_missing(br_local, br_remote, verbose=False, quiet=False):
     """Show the revisions which exist in br_remote, that 
     do not exist in br_local.

=== removed file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2005-09-07 01:34:07 +0000
+++ bzrlib/msgeditor.py	1970-01-01 00:00:00 +0000
@@ -1,122 +0,0 @@
-# Bazaar-NG -- distributed version control
-
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Commit message editor support."""
-
-import os
-from subprocess import call
-from bzrlib.errors import BzrError
-
-def _get_editor():
-    """Return a sequence of possible editor binaries for the current platform"""
-    from bzrlib.osutils import _read_config_value
-    
-    e = _read_config_value("editor")
-    if e is not None:
-        yield e
-        
-    try:
-        yield os.environ["EDITOR"]
-    except KeyError:
-        if os.name == "nt":
-            yield "notepad.exe"
-        elif os.name == "posix":
-            yield "/usr/bin/vi"
-
-
-def _run_editor(filename):
-    """Try to execute an editor to edit the commit message."""
-    for e in _get_editor():
-        edargs = e.split(' ')
-        x = call(edargs + [filename])
-        if x == 0:
-            return True
-        elif x == 127:
-            continue
-        else:
-            break
-    raise BzrError("Could not start any editor. "
-                   "Please specify $EDITOR or use ~/.bzr.conf/editor")
-                          
-
-def edit_commit_message(infotext, ignoreline=None):
-    """Let the user edit a commit message in a temp file.
-
-    This is run if they don't give a message or
-    message-containing file on the command line.
-
-    infotext:
-        Text to be displayed at bottom of message for
-        the user's reference; currently similar to
-        'bzr status'.
-    """
-    import tempfile
-    
-    if ignoreline is None:
-        ignoreline = "-- This line and the following will be ignored --"
-        
-    try:
-        tmp_fileno, msgfilename = tempfile.mkstemp()
-        msgfile = os.close(tmp_fileno)
-        if infotext is not None and infotext != "":
-            hasinfo = True
-            msgfile = file(msgfilename, "w")
-            msgfile.write("\n\n%s\n\n%s" % (ignoreline, infotext))
-            msgfile.close()
-        else:
-            hasinfo = False
-
-        if not _run_editor(msgfilename):
-            return None
-        
-        started = False
-        msg = []
-        lastline, nlines = 0, 0
-        for line in file(msgfilename, "r"):
-            stripped_line = line.strip()
-            # strip empty line before the log message starts
-            if not started:
-                if stripped_line != "":
-                    started = True
-                else:
-                    continue
-            # check for the ignore line only if there
-            # is additional information at the end
-            if hasinfo and stripped_line == ignoreline:
-                break
-            nlines += 1
-            # keep track of the last line that had some content
-            if stripped_line != "":
-                lastline = nlines
-            msg.append(line)
-            
-        if len(msg) == 0:
-            return None
-        # delete empty lines at the end
-        del msg[lastline:]
-        # add a newline at the end, if needed
-        if not msg[-1].endswith("\n"):
-            return "%s%s" % ("".join(msg), "\n")
-        else:
-            return "".join(msg)
-    finally:
-        # delete the msg file in any case
-        try: os.unlink(msgfilename)
-        except IOError: pass
-

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2005-09-09 14:17:50 +0000
+++ bzrlib/osutils.py	2005-08-25 05:58:05 +0000
@@ -407,27 +407,21 @@
     """Return size of given open file."""
     return os.fstat(f.fileno())[ST_SIZE]
 
-# Define rand_bytes based on platform.
-try:
-    # Python 2.4 and later have os.urandom,
-    # but it doesn't work on some arches
-    os.urandom(1)
+
+if hasattr(os, 'urandom'): # python 2.4 and later
     rand_bytes = os.urandom
-except (NotImplementedError, AttributeError):
-    # If python doesn't have os.urandom, or it doesn't work,
-    # then try to first pull random data from /dev/urandom
-    if os.path.exists("/dev/urandom"):
-        rand_bytes = file('/dev/urandom', 'rb').read
-    # Otherwise, use this hack as a last resort
-    else:
-        # not well seeded, but better than nothing
-        def rand_bytes(n):
-            import random
-            s = ''
-            while n:
-                s += chr(random.randint(0, 255))
-                n -= 1
-            return s
+elif sys.platform == 'linux2':
+    rand_bytes = file('/dev/urandom', 'rb').read
+else:
+    # not well seeded, but better than nothing
+    def rand_bytes(n):
+        import random
+        s = ''
+        while n:
+            s += chr(random.randint(0, 255))
+            n -= 1
+        return s
+
 
 ## TODO: We could later have path objects that remember their list
 ## decomposition (might be too tricksy though.)
@@ -498,3 +492,87 @@
         raise
 
 
+def _get_editor():
+    """Return a sequence of possible editor binaries for the current platform"""
+    e = _read_config_value("editor")
+    if e is not None:
+        yield e
+        
+    if os.name == "windows":
+        yield "notepad.exe"
+    elif os.name == "posix":
+        try:
+            yield os.environ["EDITOR"]
+        except KeyError:
+            yield "/usr/bin/vi"
+
+
+def _run_editor(filename):
+    """Try to execute an editor to edit the commit message. Returns True on success,
+    False on failure"""
+    for e in _get_editor():
+        x = os.spawnvp(os.P_WAIT, e, (e, filename))
+        if x == 0:
+            return True
+        elif x == 127:
+            continue
+        else:
+            break
+    raise BzrError("Could not start any editor. Please specify $EDITOR or use ~/.bzr.conf/editor")
+    return False
+                          
+
+def get_text_message(infotext, ignoreline = "default"):
+    import tempfile
+    
+    if ignoreline == "default":
+        ignoreline = "-- This line and the following will be ignored --"
+        
+    try:
+        tmp_fileno, msgfilename = tempfile.mkstemp()
+        msgfile = os.close(tmp_fileno)
+        if infotext is not None and infotext != "":
+            hasinfo = True
+            msgfile = file(msgfilename, "w")
+            msgfile.write("\n\n%s\n\n%s" % (ignoreline, infotext))
+            msgfile.close()
+        else:
+            hasinfo = False
+
+        if not _run_editor(msgfilename):
+            return None
+        
+        started = False
+        msg = []
+        lastline, nlines = 0, 0
+        for line in file(msgfilename, "r"):
+            stripped_line = line.strip()
+            # strip empty line before the log message starts
+            if not started:
+                if stripped_line != "":
+                    started = True
+                else:
+                    continue
+            # check for the ignore line only if there
+            # is additional information at the end
+            if hasinfo and stripped_line == ignoreline:
+                break
+            nlines += 1
+            # keep track of the last line that had some content
+            if stripped_line != "":
+                lastline = nlines
+            msg.append(line)
+            
+        if len(msg) == 0:
+            return None
+        # delete empty lines at the end
+        del msg[lastline:]
+        # add a newline at the end, if needed
+        if not msg[-1].endswith("\n"):
+            return "%s%s" % ("".join(msg), "\n")
+        else:
+            return "".join(msg)
+    finally:
+        # delete the msg file in any case
+        try: os.unlink(msgfilename)
+        except IOError: pass

=== modified file 'bzrlib/plugins/__init__.py'
--- bzrlib/plugins/__init__.py	2005-08-30 03:29:32 +0000
+++ bzrlib/plugins/__init__.py	2005-08-25 05:58:05 +0000
@@ -1,1 +0,0 @@
-"""Null placeholder plugin"""

=== added file 'bzrlib/plugins/checkperms'
--- bzrlib/plugins/checkperms	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/checkperms	2005-06-27 05:14:15 +0000
@@ -0,0 +1,5 @@
+#! /bin/sh -ex
+
+root=`bzr root`
+
+find $root \! -perm -0444 
\ No newline at end of file

=== modified file 'bzrlib/remotebranch.py'
--- bzrlib/remotebranch.py	2005-09-15 13:32:36 +0000
+++ bzrlib/remotebranch.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/env python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
@@ -24,19 +26,19 @@
 
 import gzip
 from cStringIO import StringIO
-import os
 import urllib2
-import urlparse
-
-from bzrlib.errors import BzrError, BzrCheckError
-from bzrlib.branch import Branch, BZR_BRANCH_FORMAT
-from bzrlib.trace import mutter
-from bzrlib.xml import serializer_v4
-
-
-ENABLE_URLGRABBER = False
-
-from bzrlib.errors import BzrError, NoSuchRevision
+
+from errors import BzrError, BzrCheckError
+from branch import Branch, BZR_BRANCH_FORMAT
+from trace import mutter
+
+# velocitynet.com.au transparently proxies connections and thereby
+# breaks keep-alive -- sucks!
+
+
+ENABLE_URLGRABBER = True
+
+from bzrlib.errors import BzrError
 
 class GetFailed(BzrError):
     def __init__(self, url, status):
@@ -82,8 +84,8 @@
     orig_url = url
     while True:
         try:
-            fmt_url = url + '/.bzr/branch-format'
-            ff = get_url(fmt_url)
+            ff = get_url(url + '/.bzr/branch-format')
+
             fmt = ff.read()
             ff.close()
 
@@ -96,17 +98,12 @@
         except urllib2.URLError:
             pass
 
-        scheme, host, path = list(urlparse.urlparse(url))[:3]
-        # discard params, query, fragment
-        
-        # strip off one component of the path component
-        idx = path.rfind('/')
-        if idx == -1 or path == '/':
-            raise BzrError('no branch root found for URL %s'
-                           ' or enclosing directories'
-                           % orig_url)
-        path = path[:idx]
-        url = urlparse.urlunparse((scheme, host, path, '', '', ''))
+        try:
+            idx = url.rindex('/')
+        except ValueError:
+            raise BzrError('no branch root found for URL %s' % orig_url)
+
+        url = url[:idx]        
         
 
 
@@ -114,9 +111,9 @@
     def __init__(self, baseurl, find_root=True):
         """Create new proxy for a remote branch."""
         if find_root:
-            self.base = _find_remote_root(baseurl)
+            self.baseurl = _find_remote_root(baseurl)
         else:
-            self.base = baseurl
+            self.baseurl = baseurl
             self._check_format()
 
         self.inventory_store = RemoteStore(baseurl + '/.bzr/inventory-store/')
@@ -132,7 +129,7 @@
     def controlfile(self, filename, mode):
         if mode not in ('rb', 'rt', 'r'):
             raise BzrError("file mode %r not supported for remote branches" % mode)
-        return get_url(self.base + '/.bzr/' + filename, False)
+        return get_url(self.baseurl + '/.bzr/' + filename, False)
 
 
     def lock_read(self):
@@ -142,26 +139,25 @@
     def lock_write(self):
         from errors import LockError
         raise LockError("write lock not supported for remote branch %s"
-                        % self.base)
+                        % self.baseurl)
 
     def unlock(self):
         pass
     
 
     def relpath(self, path):
-        if not path.startswith(self.base):
+        if not path.startswith(self.baseurl):
             raise BzrError('path %r is not under base URL %r'
-                           % (path, self.base))
-        pl = len(self.base)
+                           % (path, self.baseurl))
+        pl = len(self.baseurl)
         return path[pl:].lstrip('/')
 
 
     def get_revision(self, revision_id):
-        try:
-            revf = self.revision_store[revision_id]
-        except KeyError:
-            raise NoSuchRevision(self, revision_id)
-        r = serializer_v4.read_revision(revf)
+        from bzrlib.revision import Revision
+        from bzrlib.xml import unpack_xml
+        revf = self.revision_store[revision_id]
+        r = unpack_xml(Revision, revf)
         if r.revision_id != revision_id:
             raise BzrCheckError('revision stored as {%s} actually contains {%s}'
                                 % (revision_id, r.revision_id))
@@ -182,7 +178,7 @@
         p = self._path(fileid)
         try:
             return get_url(p, compressed=True)
-        except urllib2.URLError:
+        except:
             raise KeyError(fileid)
     
 

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-09-14 17:23:14 +0000
+++ bzrlib/revision.py	2005-08-29 05:05:44 +0000
@@ -16,7 +16,7 @@
 
 
 import bzrlib.errors
-from bzrlib.graph import farthest_nodes, node_distances, all_descendants
+
 
 class RevisionReference(object):
     """
@@ -70,21 +70,90 @@
     def __repr__(self):
         return "<Revision id %s>" % self.revision_id
 
-    def __eq__(self, other):
-        if not isinstance(other, Revision):
-            return False
-        return (self.inventory_id == other.inventory_id
-                and self.inventory_sha1 == other.inventory_sha1
-                and self.revision_id == other.revision_id
-                and self.timestamp == other.timestamp
-                and self.message == other.message
-                and self.timezone == other.timezone
-                and self.committer == other.committer)
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-        
+        
+    def to_element(self):
+        from bzrlib.xml import Element, SubElement
+        
+        root = Element('revision',
+                       committer = self.committer,
+                       timestamp = '%.9f' % self.timestamp,
+                       revision_id = self.revision_id,
+                       inventory_id = self.inventory_id,
+                       inventory_sha1 = self.inventory_sha1,
+                       )
+        if self.timezone:
+            root.set('timezone', str(self.timezone))
+        root.text = '\n'
+        
+        msg = SubElement(root, 'message')
+        msg.text = self.message
+        msg.tail = '\n'
+
+        if self.parents:
+            pelts = SubElement(root, 'parents')
+            pelts.tail = pelts.text = '\n'
+            for rr in self.parents:
+                assert isinstance(rr, RevisionReference)
+                p = SubElement(pelts, 'revision_ref')
+                p.tail = '\n'
+                assert rr.revision_id
+                p.set('revision_id', rr.revision_id)
+                if rr.revision_sha1:
+                    p.set('revision_sha1', rr.revision_sha1)
+
+        return root
+
+
+    def from_element(cls, elt):
+        return unpack_revision(elt)
+
+    from_element = classmethod(from_element)
+
+
+
+def unpack_revision(elt):
+    """Convert XML element into Revision object."""
+    # <changeset> is deprecated...
+    if elt.tag not in ('revision', 'changeset'):
+        raise bzrlib.errors.BzrError("unexpected tag in revision file: %r" % elt)
+
+    rev = Revision(committer = elt.get('committer'),
+                   timestamp = float(elt.get('timestamp')),
+                   revision_id = elt.get('revision_id'),
+                   inventory_id = elt.get('inventory_id'),
+                   inventory_sha1 = elt.get('inventory_sha1')
+                   )
+
+    precursor = elt.get('precursor')
+    precursor_sha1 = elt.get('precursor_sha1')
+
+    pelts = elt.find('parents')
+
+    if pelts:
+        for p in pelts:
+            assert p.tag == 'revision_ref', \
+                   "bad parent node tag %r" % p.tag
+            rev_ref = RevisionReference(p.get('revision_id'),
+                                        p.get('revision_sha1'))
+            rev.parents.append(rev_ref)
+
+        if precursor:
+            # must be consistent
+            prec_parent = rev.parents[0].revision_id
+            assert prec_parent == precursor
+    elif precursor:
+        # revisions written prior to 0.0.5 have a single precursor
+        # give as an attribute
+        rev_ref = RevisionReference(precursor, precursor_sha1)
+        rev.parents.append(rev_ref)
+
+    v = elt.get('timezone')
+    rev.timezone = v and int(v)
+
+    rev.message = elt.findtext('message') # text of <message>
+    return rev
+
+
 
 REVISION_ID_RE = None
 
@@ -142,6 +211,7 @@
 
     """
     found_ancestors = {}
+    count = 0
     anc_iter = enumerate(iter_ancestors(revision_id, revision_source,
                          only_present=True))
     for anc_order, (anc_id, anc_distance) in anc_iter:
@@ -149,17 +219,14 @@
             found_ancestors[anc_id] = (anc_order, anc_distance)
     return found_ancestors
     
-
-def __get_closest(intersection):
-    intersection.sort()
-    matches = [] 
-    for entry in intersection:
-        if entry[0] == intersection[0][0]:
-            matches.append(entry[2])
-    return matches
-
-
-def old_common_ancestor(revision_a, revision_b, revision_source):
+class AmbiguousBase(bzrlib.errors.BzrError):
+    def __init__(self, bases):
+        msg = "The correct base is unclear, becase %s are all equally close" %\
+            ", ".join(bases)
+        bzrlib.errors.BzrError.__init__(self, msg)
+        self.bases = bases
+
+def common_ancestor(revision_a, revision_b, revision_source):
     """Find the ancestor common to both revisions that is closest to both.
     """
     from bzrlib.trace import mutter
@@ -174,11 +241,18 @@
             b_intersection.append((b_ancestors[revision][1], a_order, revision))
     mutter("a intersection: %r" % a_intersection)
     mutter("b intersection: %r" % b_intersection)
+    def get_closest(intersection):
+        intersection.sort()
+        matches = [] 
+        for entry in intersection:
+            if entry[0] == intersection[0][0]:
+                matches.append(entry[2])
+        return matches
 
-    a_closest = __get_closest(a_intersection)
+    a_closest = get_closest(a_intersection)
     if len(a_closest) == 0:
         return None
-    b_closest = __get_closest(b_intersection)
+    b_closest = get_closest(b_intersection)
     assert len(b_closest) != 0
     mutter ("a_closest %r" % a_closest)
     mutter ("b_closest %r" % b_closest)
@@ -187,84 +261,10 @@
     elif b_closest[0] in a_closest:
         return b_closest[0]
     else:
-        raise bzrlib.errors.AmbiguousBase((a_closest[0], b_closest[0]))
+        raise AmbiguousBase((a_closest[0], b_closest[0]))
     return a_closest[0]
 
-def revision_graph(revision, revision_source):
-    """Produce a graph of the ancestry of the specified revision.
-    Return root, ancestors map, descendants map
-
-    TODO: Produce graphs with the NULL revision as root, so that we can find
-    a common even when trees are not branches don't represent a single line
-    of descent.
-    """
-    ancestors = {}
-    descendants = {}
-    lines = [revision]
-    root = None
-    descendants[revision] = {}
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            try:
-                rev = revision_source.get_revision(line)
-                parents = [p.revision_id for p in rev.parents]
-                if len(parents) == 0:
-                    root = line
-            except bzrlib.errors.NoSuchRevision:
-                if line == revision:
-                    raise
-                parents = None
-            if parents is not None:
-                for parent in parents:
-                    if parent not in ancestors:
-                        new_lines.add(parent)
-                    if parent not in descendants:
-                        descendants[parent] = {}
-                    descendants[parent][line] = 1
-            if parents is not None:
-                ancestors[line] = set(parents)
-        lines = new_lines
-    assert root not in descendants[root]
-    assert root not in ancestors[root]
-    return root, ancestors, descendants
-
-def combined_graph(revision_a, revision_b, revision_source):
-    """Produce a combined ancestry graph.
-    Return graph root, ancestors map, descendants map, set of common nodes"""
-    root, ancestors, descendants = revision_graph(revision_a, revision_source)
-    root_b, ancestors_b, descendants_b = revision_graph(revision_b, 
-                                                        revision_source)
-    if root != root_b:
-        raise bzrlib.errors.NoCommonRoot(revision_a, revision_b)
-    common = set()
-    for node, node_anc in ancestors_b.iteritems():
-        if node in ancestors:
-            common.add(node)
-        else:
-            ancestors[node] = set()
-        ancestors[node].update(node_anc)
-    for node, node_dec in descendants_b.iteritems():
-        if node not in descendants:
-            descendants[node] = set()
-        descendants[node].update(node_dec)
-    return root, ancestors, descendants, common
-
-def common_ancestor(revision_a, revision_b, revision_source):
-    try:
-        root, ancestors, descendants, common = \
-            combined_graph(revision_a, revision_b, revision_source)
-    except bzrlib.errors.NoCommonRoot:
-        raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
-        
-    nodes = farthest_nodes(descendants, ancestors, root)
-    for node in nodes:
-        if node in common:
-            return node
-    raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
-
 class MultipleRevisionSources(object):
-    """Proxy that looks in multiple branches for revisions."""
     def __init__(self, *args):
         object.__init__(self)
         assert len(args) != 0
@@ -277,46 +277,3 @@
             except bzrlib.errors.NoSuchRevision, e:
                 pass
         raise e
-
-def get_intervening_revisions(ancestor_id, rev_id, rev_source, 
-                              revision_history=None):
-    """Find the longest line of descent from maybe_ancestor to revision.
-    Revision history is followed where possible.
-
-    If ancestor_id == rev_id, list will be empty.
-    Otherwise, rev_id will be the last entry.  ancestor_id will never appear.
-    If ancestor_id is not an ancestor, NotAncestor will be thrown
-    """
-    root, ancestors, descendants = revision_graph(rev_id, rev_source)
-    if len(descendants) == 0:
-        raise NoSuchRevision(rev_source, rev_id)
-    if ancestor_id not in descendants:
-        rev_source.get_revision(ancestor_id)
-        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
-    root_descendants = all_descendants(descendants, ancestor_id)
-    root_descendants.add(ancestor_id)
-    if rev_id not in root_descendants:
-        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
-    distances = node_distances(descendants, ancestors, ancestor_id,
-                               root_descendants=root_descendants)
-
-    def best_ancestor(rev_id):
-        best = None
-        for anc_id in ancestors[rev_id]:
-            try:
-                distance = distances[anc_id]
-            except KeyError:
-                continue
-            if revision_history is not None and anc_id in revision_history:
-                return anc_id
-            elif best is None or distance > best[1]:
-                best = (anc_id, distance)
-        return best[0]
-
-    next = rev_id
-    path = []
-    while next != ancestor_id:
-        path.append(next)
-        next = best_ancestor(next)
-    path.reverse()
-    return path

=== removed file 'bzrlib/selftest/HTTPTestUtil.py'
--- bzrlib/selftest/HTTPTestUtil.py	2005-09-14 18:07:16 +0000
+++ bzrlib/selftest/HTTPTestUtil.py	1970-01-01 00:00:00 +0000
@@ -1,112 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import BaseHTTPServer, SimpleHTTPServer
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class WebserverNotAvailable(Exception):
-    pass
-
-class BadWebserverPath(ValueError):
-    def __str__(self):
-        return 'path %s is not in %s' % self.args
-
-class TestingHTTPRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
-    def log_message(self, format, *args):
-        self.server.test_case.log("webserver - %s - - [%s] %s\n" %
-                                  (self.address_string(),
-                                   self.log_date_time_string(),
-                                   format%args))
-
-class TestingHTTPServer(BaseHTTPServer.HTTPServer):
-    def __init__(self, server_address, RequestHandlerClass, test_case):
-        BaseHTTPServer.HTTPServer.__init__(self, server_address,
-                                                RequestHandlerClass)
-        self.test_case = test_case
-
-class TestCaseWithWebserver(TestCaseInTempDir):
-    """Derived class that starts a localhost-only webserver
-    (in addition to what TestCaseInTempDir does).
-
-    This is useful for testing RemoteBranch.
-    """
-
-    _HTTP_PORTS = range(13000, 0x8000)
-
-    def _http_start(self):
-        import SimpleHTTPServer, BaseHTTPServer, socket, errno
-        httpd = None
-        for port in self._HTTP_PORTS:
-            try:
-                httpd = TestingHTTPServer(('localhost', port),
-                                          TestingHTTPRequestHandler,
-                                          self)
-            except socket.error, e:
-                if e.args[0] == errno.EADDRINUSE:
-                    continue
-                print >>sys.stderr, "Cannot run webserver :-("
-                raise
-            else:
-                break
-
-        if httpd is None:
-            raise WebserverNotAvailable("Cannot run webserver :-( "
-                                        "no free ports in range %s..%s" %
-                                        (_HTTP_PORTS[0], _HTTP_PORTS[-1]))
-
-        self._http_base_url = 'http://localhost:%s/' % port
-        self._http_starting.release()
-        httpd.socket.settimeout(1)
-
-        while self._http_running:
-            try:
-                httpd.handle_request()
-            except socket.timeout:
-                pass
-
-    def get_remote_url(self, path):
-        import os
-
-        path_parts = path.split(os.path.sep)
-        if os.path.isabs(path):
-            if path_parts[:len(self._local_path_parts)] != \
-                   self._local_path_parts:
-                raise BadWebserverPath(path, self.test_dir)
-            remote_path = '/'.join(path_parts[len(self._local_path_parts):])
-        else:
-            remote_path = '/'.join(path_parts)
-
-        self._http_starting.acquire()
-        self._http_starting.release()
-        return self._http_base_url + remote_path
-
-    def setUp(self):
-        super(TestCaseWithWebserver, self).setUp()
-        import threading, os
-        self._local_path_parts = self.test_dir.split(os.path.sep)
-        self._http_starting = threading.Lock()
-        self._http_starting.acquire()
-        self._http_running = True
-        self._http_base_url = None
-        self._http_thread = threading.Thread(target=self._http_start)
-        self._http_thread.setDaemon(True)
-        self._http_thread.start()
-
-    def tearDown(self):
-        self._http_running = False
-        self._http_thread.join()
-        super(TestCaseWithWebserver, self).tearDown()

=== removed file 'bzrlib/selftest/TestUtil.py'
--- bzrlib/selftest/TestUtil.py	2005-08-24 08:34:10 +0000
+++ bzrlib/selftest/TestUtil.py	1970-01-01 00:00:00 +0000
@@ -1,80 +0,0 @@
-# Copyright (c) 2004 Canonical Limited
-#       Author: Robert Collins <robert.collins@canonical.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-import sys
-import logging
-import unittest
-
-
-class LogCollector(logging.Handler):
-    def __init__(self):
-        logging.Handler.__init__(self)
-        self.records=[]
-    def emit(self, record):
-        self.records.append(record.getMessage())
-
-
-def makeCollectingLogger():
-    """I make a logger instance that collects its logs for programmatic analysis
-    -> (logger, collector)"""
-    logger=logging.Logger("collector")
-    handler=LogCollector()
-    handler.setFormatter(logging.Formatter("%(levelname)s: %(message)s"))
-    logger.addHandler(handler)
-    return logger, handler
-
-
-def visitTests(suite, visitor):
-    """A foreign method for visiting the tests in a test suite."""
-    for test in suite._tests:
-        #Abusing types to avoid monkey patching unittest.TestCase. 
-        # Maybe that would be better?
-        try:
-            test.visit(visitor)
-        except AttributeError:
-            if isinstance(test, unittest.TestCase):
-                visitor.visitCase(test)
-            elif isinstance(test, unittest.TestSuite):
-                visitor.visitSuite(test)
-                visitTests(test, visitor)
-            else:
-                print "unvisitable non-unittest.TestCase element %r (%r)" % (test, test.__class__)
-    
-
-class TestSuite(unittest.TestSuite):
-    """I am an extended TestSuite with a visitor interface.
-    This is primarily to allow filtering of tests - and suites or
-    more in the future. An iterator of just tests wouldn't scale..."""
-
-    def visit(self, visitor):
-        """visit the composite. Visiting is depth-first.
-        current callbacks are visitSuite and visitCase."""
-        visitor.visitSuite(self)
-        visitTests(self, visitor)
-
-
-class TestLoader(unittest.TestLoader):
-    """Custome TestLoader to set the right TestSuite class."""
-    suiteClass = TestSuite
-
-class TestVisitor(object):
-    """A visitor for Tests"""
-    def visitSuite(self, aTestSuite):
-        pass
-    def visitCase(self, aTestCase):
-        pass

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-09-15 21:35:53 +0000
+++ bzrlib/selftest/__init__.py	2005-08-29 01:25:00 +0000
@@ -19,29 +19,23 @@
 import unittest
 import tempfile
 import os
-import sys
-import subprocess
 
 from testsweet import run_suite
+
 import bzrlib.commands
-
 import bzrlib.trace
-import bzrlib.fetch
-
 
 MODULES_TO_TEST = []
 MODULES_TO_DOCTEST = []
 
 from logging import debug, warning, error
 
-class CommandFailed(Exception):
-    pass
 
 class TestCase(unittest.TestCase):
     """Base class for bzr unit tests.
     
     Tests that need access to disk resources should subclass 
-    TestCaseInTempDir not TestCase.
+    FunctionalTestCase not TestCase.
 
     Error and debug log messages are redirected from their usual
     location into a temporary file, the contents of which can be
@@ -74,6 +68,7 @@
         
         self._log_file_name = name
 
+        
     def tearDown(self):
         logging.getLogger('').removeHandler(self._log_hdlr)
         bzrlib.trace.enable_default_logging()
@@ -81,6 +76,7 @@
         self._log_file.close()
         unittest.TestCase.tearDown(self)
 
+
     def log(self, *args):
         logging.debug(*args)
 
@@ -99,10 +95,7 @@
         that is slower, harder to debug, and generally not necessary.
         """
         retcode = kwargs.get('retcode', 0)
-        result = self.apply_redirected(None, None, None,
-                                       bzrlib.commands.run_bzr, args)
-        self.assertEquals(result, retcode)
-        
+        self.assertEquals(bzrlib.commands.run_bzr(args), retcode)
         
     def check_inventory_shape(self, inv, shape):
         """
@@ -125,52 +118,12 @@
         if extras:
             self.fail("unexpected paths found in inventory: %r" % extras)
 
-    def apply_redirected(self, stdin=None, stdout=None, stderr=None,
-                         a_callable=None, *args, **kwargs):
-        """Call callable with redirected std io pipes.
-
-        Returns the return code."""
-        from StringIO import StringIO
-        if not callable(a_callable):
-            raise ValueError("a_callable must be callable.")
-        if stdin is None:
-            stdin = StringIO("")
-        if stdout is None:
-            if hasattr(self, "_log_file"):
-                stdout = self._log_file
-            else:
-                stdout = StringIO()
-        if stderr is None:
-            if hasattr(self, "_log_file"):
-                stderr = self._log_file
-            else:
-                stderr = StringIO()
-        real_stdin = sys.stdin
-        real_stdout = sys.stdout
-        real_stderr = sys.stderr
-        try:
-            sys.stdout = stdout
-            sys.stderr = stderr
-            sys.stdin = stdin
-            return a_callable(*args, **kwargs)
-        finally:
-            sys.stdout = real_stdout
-            sys.stderr = real_stderr
-            sys.stdin = real_stdin
-
-
 BzrTestBase = TestCase
 
      
-class TestCaseInTempDir(TestCase):
-    """Derived class that runs a test within a temporary directory.
-
-    This is useful for tests that need to create a branch, etc.
-
-    The directory is created in a slightly complex way: for each
-    Python invocation, a new temporary top-level directory is created.
-    All test cases create their own directory within that.  If the
-    tests complete successfully, the directory is removed.
+class FunctionalTestCase(TestCase):
+    """Base class for tests that perform function testing - running bzr,
+    using files on disk, and similar activities.
 
     InTempDir is an old alias for FunctionalTestCase.
     """
@@ -192,19 +145,19 @@
         import shutil
         import tempfile
         
-        if TestCaseInTempDir.TEST_ROOT is not None:
+        if FunctionalTestCase.TEST_ROOT is not None:
             return
-        TestCaseInTempDir.TEST_ROOT = os.path.abspath(
+        FunctionalTestCase.TEST_ROOT = os.path.abspath(
                                  tempfile.mkdtemp(suffix='.tmp',
                                                   prefix=self._TEST_NAME + '-',
                                                   dir=os.curdir))
     
         # make a fake bzr directory there to prevent any tests propagating
         # up onto the source directory's real branch
-        os.mkdir(os.path.join(TestCaseInTempDir.TEST_ROOT, '.bzr'))
+        os.mkdir(os.path.join(FunctionalTestCase.TEST_ROOT, '.bzr'))
 
     def setUp(self):
-        super(TestCaseInTempDir, self).setUp()
+        super(FunctionalTestCase, self).setUp()
         import os
         self._make_test_root()
         self._currentdir = os.getcwdu()
@@ -215,7 +168,7 @@
     def tearDown(self):
         import os
         os.chdir(self._currentdir)
-        super(TestCaseInTempDir, self).tearDown()
+        super(FunctionalTestCase, self).tearDown()
 
     def _formcmd(self, cmd):
         if isinstance(cmd, basestring):
@@ -235,18 +188,30 @@
         If a single string is based, it is split into words.
         For commands that are not simple space-separated words, please
         pass a list instead."""
+        try:
+            import shutil
+            from subprocess import call
+        except ImportError, e:
+            _need_subprocess()
+            raise
         cmd = self._formcmd(cmd)
         self.log('$ ' + ' '.join(cmd))
-        actual_retcode = subprocess.call(cmd, stdout=self._log_file,
-                                         stderr=self._log_file)
+        actual_retcode = call(cmd, stdout=self._log_file, stderr=self._log_file)
         if retcode != actual_retcode:
             raise CommandFailed("test failed: %r returned %d, expected %d"
                                 % (cmd, actual_retcode, retcode))
 
     def backtick(self, cmd, retcode=0):
         """Run a command and return its output"""
+        try:
+            import shutil
+            from subprocess import Popen, PIPE
+        except ImportError, e:
+            _need_subprocess()
+            raise
+
         cmd = self._formcmd(cmd)
-        child = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=self._log_file)
+        child = Popen(cmd, stdout=PIPE, stderr=self._log_file)
         outd, errd = child.communicate()
         self.log(outd)
         actual_retcode = child.wait()
@@ -291,12 +256,11 @@
         ##assert 0
 
 
-def selftest(verbose=False, pattern=".*"):
-    return run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern)
-
-
-def test_suite():
-    from bzrlib.selftest.TestUtil import TestLoader, TestSuite
+InTempDir = FunctionalTestCase
+
+
+def selftest(verbose=False):
+    from unittest import TestLoader, TestSuite
     import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
     import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
     from doctest import DocTestSuite
@@ -309,29 +273,20 @@
 
     testmod_names = \
                   ['bzrlib.selftest.MetaTestLog',
-                   'bzrlib.selftest.test_parent',
                    'bzrlib.selftest.testinv',
                    'bzrlib.selftest.testfetch',
                    'bzrlib.selftest.versioning',
                    'bzrlib.selftest.whitebox',
                    'bzrlib.selftest.testmerge3',
-                   'bzrlib.selftest.testmerge',
                    'bzrlib.selftest.testhashcache',
                    'bzrlib.selftest.teststatus',
                    'bzrlib.selftest.testlog',
                    'bzrlib.selftest.blackbox',
                    'bzrlib.selftest.testrevisionnamespaces',
                    'bzrlib.selftest.testbranch',
-                   'bzrlib.selftest.testremotebranch',
                    'bzrlib.selftest.testrevision',
-                   'bzrlib.selftest.test_merge_core',
-                   'bzrlib.selftest.test_smart_add',
+                   'bzrlib.merge_core',
                    'bzrlib.selftest.testdiff',
-                   'bzrlib.selftest.test_xml',
-                   'bzrlib.fetch',
-                   'bzrlib.selftest.teststore',
-                   'bzrlib.selftest.testtransport',
-                   'bzrlib.selftest.testgraph',
                    ]
 
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,
@@ -341,15 +296,27 @@
 
     TestCase.BZRPATH = os.path.join(os.path.realpath(os.path.dirname(bzrlib.__path__[0])), 'bzr')
     print '%-30s %s' % ('bzr binary', TestCase.BZRPATH)
+
     print
+
     suite = TestSuite()
+
     suite.addTest(TestLoader().loadTestsFromNames(testmod_names))
+
     for m in MODULES_TO_TEST:
          suite.addTest(TestLoader().loadTestsFromModule(m))
+
     for m in (MODULES_TO_DOCTEST):
         suite.addTest(DocTestSuite(m))
+
     for p in bzrlib.plugin.all_plugins:
         if hasattr(p, 'test_suite'):
             suite.addTest(p.test_suite())
-    return suite
+
+    import bzrlib.merge_core
+    suite.addTest(unittest.makeSuite(bzrlib.merge_core.MergeTest, 'test_'))
+
+    return run_suite(suite, 'testbzr', verbose=verbose)
+
+
 

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-09-14 17:23:14 +0000
+++ bzrlib/selftest/blackbox.py	2005-08-29 03:54:30 +0000
@@ -27,15 +27,18 @@
 """
 
 import sys
-import os
-
-from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
-from bzrlib.branch import Branch
-from bzrlib.commands import run_bzr
-
-
-class ExternalBase(TestCaseInTempDir):
+from bzrlib.selftest import InTempDir, BzrTestBase
+
+class ExternalBase(InTempDir):
+
     def runbzr(self, args, retcode=0,backtick=False):
+        try:
+            import shutil
+            from subprocess import call
+        except ImportError, e:
+            _need_subprocess()
+            raise
+
         if isinstance(args, basestring):
             args = args.split()
 
@@ -46,7 +49,6 @@
             return self.runcmd(['python', self.BZRPATH,] + args,
                            retcode=retcode)
 
-
 class TestCommands(ExternalBase):
 
     def test_help_commands(self):
@@ -57,6 +59,7 @@
         self.runbzr('commit -h')
 
     def test_init_branch(self):
+        import os
         self.runbzr(['init'])
 
     def test_whoami(self):
@@ -123,6 +126,8 @@
         assert file('.bzrignore', 'rb').read() == '*.blah\ngarh\n'
 
     def test_revert(self):
+        import os
+
         self.runbzr('init')
 
         file('hello', 'wt').write('foo')
@@ -147,19 +152,18 @@
         os.rmdir('revertdir')
         self.runbzr('revert')
 
-    def test_mv_modes(self):
+
+    def skipped_test_mv_modes(self):
         """Test two modes of operation for mv"""
         from bzrlib.branch import Branch
         b = Branch('.', init=True)
         self.build_tree(['a', 'c', 'subdir/'])
-        self.run_bzr('add', self.test_dir)
         self.run_bzr('mv', 'a', 'b')
         self.run_bzr('mv', 'b', 'subdir')
         self.run_bzr('mv', 'subdir/b', 'a')
-        self.run_bzr('mv', 'a', 'c', 'subdir')
+        self.run_bzr('mv', 'a', 'b', 'subdir')
         self.run_bzr('mv', 'subdir/a', 'subdir/newa')
 
-
     def test_main_version(self):
         """Check output from version command and master option is reasonable"""
         # output is intentionally passed through to stdout so that we
@@ -175,116 +179,12 @@
         self.log(tmp_output)
         self.assertEquals(output, tmp_output)
 
-    def example_branch(test):
-        test.runbzr('init')
-        file('hello', 'wt').write('foo')
-        test.runbzr('add hello')
-        test.runbzr('commit -m setup hello')
-        file('goodbye', 'wt').write('baz')
-        test.runbzr('add goodbye')
-        test.runbzr('commit -m setup goodbye')
-
-    def test_revert(self):
-        self.example_branch()
-        file('hello', 'wt').write('bar')
-        file('goodbye', 'wt').write('qux')
-        self.runbzr('revert hello')
-        self.check_file_contents('hello', 'foo')
-        self.check_file_contents('goodbye', 'qux')
-        self.runbzr('revert')
-        self.check_file_contents('goodbye', 'baz')
-
-    def test_merge(self):
-        from bzrlib.branch import Branch
-        
-        os.mkdir('a')
-        os.chdir('a')
-        self.example_branch()
-        os.chdir('..')
-        self.runbzr('branch a b')
-        os.chdir('b')
-        file('goodbye', 'wt').write('quux')
-        self.runbzr(['commit',  '-m',  "more u's are always good"])
-
-        os.chdir('../a')
-        file('hello', 'wt').write('quuux')
-        # We can't merge when there are in-tree changes
-        self.runbzr('merge ../b', retcode=1)
-        self.runbzr(['commit', '-m', "Like an epidemic of u's"])
-        self.runbzr('merge ../b')
-        self.check_file_contents('goodbye', 'quux')
-        # Merging a branch pulls its revision into the tree
-        a = Branch('.')
-        b = Branch('../b')
-        a.get_revision_xml(b.last_patch())
-        self.log('pending merges: %s', a.pending_merges())
-        #        assert a.pending_merges() == [b.last_patch()], "Assertion %s %s" \
-        #        % (a.pending_merges(), b.last_patch())
-
-    def test_pull(self):
-        """Pull changes from one branch to another."""
-        os.mkdir('a')
-        os.chdir('a')
-
-        self.example_branch()
-        self.runbzr('pull', retcode=1)
-        self.runbzr('missing', retcode=1)
-        self.runbzr('missing .')
-        self.runbzr('missing')
-        self.runbzr('pull')
-        self.runbzr('pull /', retcode=1)
-        self.runbzr('pull')
-
-        os.chdir('..')
-        self.runbzr('branch a b')
-        os.chdir('b')
-        self.runbzr('pull')
-        self.runbzr('commit -m blah --unchanged')
-        os.chdir('../a')
-        a = Branch('.')
-        b = Branch('../b')
-        assert a.revision_history() == b.revision_history()[:-1]
-        self.runbzr('pull ../b')
-        assert a.revision_history() == b.revision_history()
-        self.runbzr('commit -m blah2 --unchanged')
-        os.chdir('../b')
-        self.runbzr('commit -m blah3 --unchanged')
-        self.runbzr('pull ../a', retcode=1)
-        os.chdir('../a')
-        self.runbzr('merge ../b')
-        self.runbzr('commit -m blah4 --unchanged')
-        os.chdir('../b')
-        self.runbzr('pull ../a')
-        assert a.revision_history()[-1] == b.revision_history()[-1]
-        
-
-    def test_add_reports(self):
-        """add command prints the names of added files."""
-        b = Branch('.', init=True)
-        self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-
-        from cStringIO import StringIO
-        out = StringIO()
-
-        ret = self.apply_redirected(None, out, None,
-                                    run_bzr,
-                                    ['add'])
-        self.assertEquals(ret, 0)
-
-        # the ordering is not defined at the moment
-        results = sorted(out.getvalue().rstrip('\n').split('\n'))
-        self.assertEquals(['added dir',
-                           'added dir/sub.txt',
-                           'added top.txt',],
-                          results)
-
-
 class OldTests(ExternalBase):
-    """old tests moved from ./testbzr."""
-
+    # old tests moved from ./testbzr
     def test_bzr(self):
         from os import chdir, mkdir
         from os.path import exists
+        import os
 
         runbzr = self.runbzr
         backtick = self.backtick
@@ -449,3 +349,61 @@
 
         runbzr('info')
 
+
+
+def example_branch(test):
+    test.runbzr('init')
+
+    file('hello', 'wt').write('foo')
+    test.runbzr('add hello')
+    test.runbzr('commit -m setup hello')
+
+    file('goodbye', 'wt').write('baz')
+    test.runbzr('add goodbye')
+    test.runbzr('commit -m setup goodbye')
+
+
+class RevertCommand(ExternalBase):
+    def runTest(self):
+        example_branch(self)
+        file('hello', 'wt').write('bar')
+        file('goodbye', 'wt').write('qux')
+        self.runbzr('revert hello')
+        self.check_file_contents('hello', 'foo')
+        self.check_file_contents('goodbye', 'qux')
+        self.runbzr('revert')
+        self.check_file_contents('goodbye', 'baz')
+
+
+class MergeCommand(ExternalBase):
+    def runTest(self):
+        from bzrlib.branch import Branch
+        from bzrlib.commands import run_bzr
+        import os
+        
+        os.mkdir('a')
+        os.chdir('a')
+
+        example_branch(self)
+        os.chdir('..')
+        self.runbzr('branch a b')
+        os.chdir('b')
+        file('goodbye', 'wt').write('quux')
+        self.runbzr(['commit',  '-m',  "more u's are always good"])
+
+        os.chdir('../a')
+        file('hello', 'wt').write('quuux')
+        # We can't merge when there are in-tree changes
+        self.runbzr('merge ../b', retcode=1)
+        self.runbzr(['commit', '-m', "Like an epidemic of u's"])
+        self.runbzr('merge ../b')
+        self.check_file_contents('goodbye', 'quux')
+        # Merging a branch pulls its revision into the tree
+        a = Branch('.')
+        b = Branch('../b')
+        a.get_revision_xml(b.last_patch())
+
+        self.log('pending merges: %s', a.pending_merges())
+#        assert a.pending_merges() == [b.last_patch()], "Assertion %s %s" \
+#        % (a.pending_merges(), b.last_patch())
+

=== modified file 'bzrlib/selftest/plugins.py'
--- bzrlib/selftest/plugins.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/plugins.py	2005-08-25 05:58:05 +0000
@@ -17,23 +17,18 @@
 
 """Tests for plugins"""
 
-
-
-# **************************************************
 # NOT RUN YET
-# **************************************************
-
-
-
-
-
-
-
-
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class PluginTest(TestCaseInTempDir):
+
+
+
+
+
+
+
+from bzrlib.selftest import InTempDir
+
+
+def PluginTest(InTempDir):
     """Create an external plugin and test loading."""
     def test_plugin_loading(self):
         import os

=== removed file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-09-01 06:33:48 +0000
+++ bzrlib/selftest/test_merge_core.py	1970-01-01 00:00:00 +0000
@@ -1,501 +0,0 @@
-import os
-import unittest
-
-from bzrlib.selftest import TestCaseInTempDir, TestCase
-from bzrlib.branch import ScratchBranch, Branch
-from bzrlib.errors import NotBranchError, NotVersionedError
-
-
-import tempfile
-import shutil
-from bzrlib.inventory import InventoryEntry, RootEntry
-from bzrlib.osutils import file_kind
-from bzrlib import changeset
-from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
-                                BackupBeforeChange, PermissionsMerge)
-from bzrlib.changeset import Inventory, apply_changeset, invert_dict
-
-class FalseTree(object):
-    def __init__(self, realtree):
-        self._realtree = realtree
-        self.inventory = self
-
-    def __getitem__(self, file_id):
-        entry = self.make_inventory_entry(file_id)
-        if entry is None:
-            raise KeyError(file_id)
-        return entry
-        
-    def make_inventory_entry(self, file_id):
-        path = self._realtree.inventory.get(file_id)
-        if path is None:
-            return None
-        if path == "":
-            return RootEntry(file_id)
-        dir, name = os.path.split(path)
-        kind = file_kind(self._realtree.abs_path(path))
-        for parent_id, path in self._realtree.inventory.iteritems():
-            if path == dir:
-                break
-        if path != dir:
-            raise Exception("Can't find parent for %s" % name)
-        return InventoryEntry(file_id, name, kind, parent_id)
-
-
-class MergeTree(object):
-    def __init__(self, dir):
-        self.dir = dir;
-        os.mkdir(dir)
-        self.inventory = {'0': ""}
-        self.tree = FalseTree(self)
-    
-    def child_path(self, parent, name):
-        return os.path.join(self.inventory[parent], name)
-
-    def add_file(self, id, parent, name, contents, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        file(full_path, "wb").write(contents)
-        os.chmod(self.abs_path(path), mode)
-        self.inventory[id] = path
-
-    def remove_file(self, id):
-        os.unlink(self.full_path(id))
-        del self.inventory[id]
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        os.mkdir(self.abs_path(path))
-        os.chmod(self.abs_path(path), mode)
-        self.inventory[id] = path
-
-    def abs_path(self, path):
-        return os.path.join(self.dir, path)
-
-    def full_path(self, id):
-        try:
-            tree_path = self.inventory[id]
-        except KeyError:
-            return None
-        return self.abs_path(tree_path)
-
-    def readonly_path(self, id):
-        return self.full_path(id)
-
-    def __contains__(self, file_id):
-        return file_id in self.inventory
-
-    def has_or_had_id(self, file_id):
-        return file_id in self
-
-    def get_file(self, file_id):
-        path = self.readonly_path(file_id)
-        return file(path, "rb")
-
-    def id2path(self, file_id):
-        return self.inventory[file_id]
-
-    def change_path(self, id, path):
-        old_path = os.path.join(self.dir, self.inventory[id])
-        os.rename(old_path, self.abs_path(path))
-        self.inventory[id] = path
-
-
-class MergeBuilder(object):
-    def __init__(self):
-        self.dir = tempfile.mkdtemp(prefix="BaZing")
-        self.base = MergeTree(os.path.join(self.dir, "base"))
-        self.this = MergeTree(os.path.join(self.dir, "this"))
-        self.other = MergeTree(os.path.join(self.dir, "other"))
-        
-        self.cset = changeset.Changeset()
-        self.cset.add_entry(changeset.ChangesetEntry("0", 
-                                                     changeset.NULL_ID, "./."))
-    def get_cset_path(self, parent, name):
-        if name is None:
-            assert (parent is None)
-            return None
-        return os.path.join(self.cset.entries[parent].path, name)
-
-    def add_file(self, id, parent, name, contents, mode):
-        self.base.add_file(id, parent, name, contents, mode)
-        self.this.add_file(id, parent, name, contents, mode)
-        self.other.add_file(id, parent, name, contents, mode)
-        path = self.get_cset_path(parent, name)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-
-    def remove_file(self, id, base=False, this=False, other=False):
-        for option, tree in ((base, self.base), (this, self.this), 
-                             (other, self.other)):
-            if option:
-                tree.remove_file(id)
-            if other or base:
-                change = self.cset.entries[id].contents_change
-                if change is None:
-                    change = changeset.ReplaceContents(None, None)
-                    self.cset.entries[id].contents_change = change
-                    def create_file(tree):
-                        return changeset.FileCreate(tree.get_file(id).read())
-                    if not other:
-                        change.new_contents = create_file(self.other)
-                    if not base:
-                        change.old_contents = create_file(self.base)
-                else:
-                    assert isinstance(change, changeset.ReplaceContents)
-                if other:
-                    change.new_contents=None
-                if base:
-                    change.old_contents=None
-                if change.old_contents is None and change.new_contents is None:
-                    change = None
-
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.get_cset_path(parent, name)
-        self.base.add_dir(id, parent, name, mode)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-        self.this.add_dir(id, parent, name, mode)
-        self.other.add_dir(id, parent, name, mode)
-
-
-    def change_name(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_name_tree(id, self.base, base)
-            self.cset.entries[id].name = base
-
-        if this is not None:
-            self.change_name_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_name_tree(id, self.other, other)
-            self.cset.entries[id].new_name = other
-
-    def change_parent(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_parent_tree(id, self.base, base)
-            self.cset.entries[id].parent = base
-            self.cset.entries[id].dir = self.cset.entries[base].path
-
-        if this is not None:
-            self.change_parent_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_parent_tree(id, self.other, other)
-            self.cset.entries[id].new_parent = other
-            self.cset.entries[id].new_dir = \
-                self.cset.entries[other].new_path
-
-    def change_contents(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_contents_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_contents_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_contents_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_contents = file(self.base.full_path(id)).read()
-            new_contents = file(self.other.full_path(id)).read()
-            contents = changeset.ReplaceFileContents(old_contents, 
-                                                     new_contents)
-            self.cset.entries[id].contents_change = contents
-
-    def change_perms(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_perms_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_perms_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_perms_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_perms = os.stat(self.base.full_path(id)).st_mode &077
-            new_perms = os.stat(self.other.full_path(id)).st_mode &077
-            contents = changeset.ChangeUnixPermissions(old_perms, 
-                                                       new_perms)
-            self.cset.entries[id].metadata_change = contents
-
-    def change_name_tree(self, id, tree, name):
-        new_path = tree.child_path(self.cset.entries[id].parent, name)
-        tree.change_path(id, new_path)
-
-    def change_parent_tree(self, id, tree, parent):
-        new_path = tree.child_path(parent, self.cset.entries[id].name)
-        tree.change_path(id, new_path)
-
-    def change_contents_tree(self, id, tree, contents):
-        path = tree.full_path(id)
-        mode = os.stat(path).st_mode
-        file(path, "w").write(contents)
-        os.chmod(path, mode)
-
-    def change_perms_tree(self, id, tree, mode):
-        os.chmod(tree.full_path(id), mode)
-
-    def merge_changeset(self, merge_factory):
-        conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
-        return make_merge_changeset(self.cset, self.this, self.base,
-                                    self.other, conflict_handler,
-                                    merge_factory)
-
-    def apply_inv_change(self, inventory_change, orig_inventory):
-        orig_inventory_by_path = {}
-        for file_id, path in orig_inventory.iteritems():
-            orig_inventory_by_path[path] = file_id
-
-        def parent_id(file_id):
-            try:
-                parent_dir = os.path.dirname(orig_inventory[file_id])
-            except:
-                print file_id
-                raise
-            if parent_dir == "":
-                return None
-            return orig_inventory_by_path[parent_dir]
-        
-        def new_path(file_id):
-            if inventory_change.has_key(file_id):
-                return inventory_change[file_id]
-            else:
-                parent = parent_id(file_id)
-                if parent is None:
-                    return orig_inventory[file_id]
-                dirname = new_path(parent)
-                return os.path.join(dirname, orig_inventory[file_id])
-
-        new_inventory = {}
-        for file_id in orig_inventory.iterkeys():
-            path = new_path(file_id)
-            if path is None:
-                continue
-            new_inventory[file_id] = path
-
-        for file_id, path in inventory_change.iteritems():
-            if orig_inventory.has_key(file_id):
-                continue
-            new_inventory[file_id] = path
-        return new_inventory
-
-    def apply_changeset(self, cset, conflict_handler=None, reverse=False):
-        inventory_change = changeset.apply_changeset(cset,
-                                                     self.this.inventory,
-                                                     self.this.dir,
-                                                     conflict_handler, reverse)
-        self.this.inventory =  self.apply_inv_change(inventory_change, 
-                                                     self.this.inventory)
-
-    def cleanup(self):
-        shutil.rmtree(self.dir)
-
-class MergeTest(unittest.TestCase):
-    def test_change_name(self):
-        """Test renames"""
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0755)
-        builder.change_name("1", other="name2")
-        builder.add_file("2", "0", "name3", "hello2", 0755)
-        builder.change_name("2", base="name4")
-        builder.add_file("3", "0", "name5", "hello3", 0755)
-        builder.change_name("3", this="name6")
-        cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["2"].is_boring())
-        assert(cset.entries["1"].name == "name1")
-        assert(cset.entries["1"].new_name == "name2")
-        assert(cset.entries["3"].is_boring())
-        for tree in (builder.this, builder.other, builder.base):
-            assert(tree.dir != builder.dir and 
-                   tree.dir.startswith(builder.dir))
-            for path in tree.inventory.itervalues():
-                fullpath = tree.abs_path(path)
-                assert(fullpath.startswith(tree.dir))
-                assert(not path.startswith(tree.dir))
-                assert os.path.exists(fullpath)
-        builder.apply_changeset(cset)
-        builder.cleanup()
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0644)
-        builder.change_name("1", other="name2", this="name3")
-        self.assertRaises(changeset.RenameConflict, 
-                          builder.merge_changeset, ApplyMerge3)
-        builder.cleanup()
-        
-    def test_file_moves(self):
-        """Test moves"""
-        builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_file("3", "1", "file1", "hello1", 0644)
-        builder.add_file("4", "1", "file2", "hello2", 0644)
-        builder.add_file("5", "1", "file3", "hello3", 0644)
-        builder.change_parent("3", other="2")
-        assert(Inventory(builder.other.inventory).get_parent("3") == "2")
-        builder.change_parent("4", this="2")
-        assert(Inventory(builder.this.inventory).get_parent("4") == "2")
-        builder.change_parent("5", base="2")
-        assert(Inventory(builder.base.inventory).get_parent("5") == "2")
-        cset = builder.merge_changeset(ApplyMerge3)
-        for id in ("1", "2", "4", "5"):
-            assert(cset.entries[id].is_boring())
-        assert(cset.entries["3"].parent == "1")
-        assert(cset.entries["3"].new_parent == "2")
-        builder.apply_changeset(cset)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_dir("3", "0", "dir3", 0755)
-        builder.add_file("4", "1", "file1", "hello1", 0644)
-        builder.change_parent("4", other="2", this="3")
-        self.assertRaises(changeset.MoveConflict, 
-                          builder.merge_changeset, ApplyMerge3)
-        builder.cleanup()
-
-    def test_contents_merge(self):
-        """Test merge3 merging"""
-        self.do_contents_test(ApplyMerge3)
-
-    def test_contents_merge2(self):
-        """Test diff3 merging"""
-        self.do_contents_test(changeset.Diff3Merge)
-
-    def test_contents_merge3(self):
-        """Test diff3 merging"""
-        def backup_merge(file_id, base, other):
-            return BackupBeforeChange(ApplyMerge3(file_id, base, other))
-        builder = self.contents_test_success(backup_merge)
-        def backup_exists(file_id):
-            return os.path.exists(builder.this.full_path(file_id)+"~")
-        assert backup_exists("1")
-        assert backup_exists("2")
-        assert not backup_exists("3")
-        builder.cleanup()
-
-    def do_contents_test(self, merge_factory):
-        """Test merging with specified ContentsChange factory"""
-        builder = self.contents_test_success(merge_factory)
-        builder.cleanup()
-        self.contents_test_conflicts(merge_factory)
-
-    def contents_test_success(self, merge_factory):
-        from inspect import isclass
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4")
-        builder.add_file("2", "0", "name3", "text2", 0655)
-        builder.change_contents("2", base="text5")
-        builder.add_file("3", "0", "name5", "text3", 0744)
-        builder.add_file("4", "0", "name6", "text4", 0744)
-        builder.remove_file("4", base=True)
-        assert not builder.cset.entries["4"].is_boring()
-        builder.change_contents("3", this="text6")
-        cset = builder.merge_changeset(merge_factory)
-        assert(cset.entries["1"].contents_change is not None)
-        if isclass(merge_factory):
-            assert(isinstance(cset.entries["1"].contents_change,
-                          merge_factory))
-            assert(isinstance(cset.entries["2"].contents_change,
-                          merge_factory))
-        assert(cset.entries["3"].is_boring())
-        assert(cset.entries["4"].is_boring())
-        builder.apply_changeset(cset)
-        assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
-        assert(file(builder.this.full_path("2"), "rb").read() == "text2" )
-        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
-        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
-        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
-        return builder
-
-    def contents_test_conflicts(self, merge_factory):
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", this="text3")
-        cset = builder.merge_changeset(merge_factory)
-        self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
-                          cset)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", base=True)
-        self.assertRaises(changeset.NewContentsConflict,
-                          builder.merge_changeset, merge_factory)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", this=True)
-        self.assertRaises(changeset.MissingForMerge, builder.merge_changeset, 
-                          merge_factory)
-        builder.cleanup()
-
-    def test_perms_merge(self):
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_perms("1", other=0655)
-        builder.add_file("2", "0", "name2", "text2", 0755)
-        builder.change_perms("2", base=0655)
-        builder.add_file("3", "0", "name3", "text3", 0755)
-        builder.change_perms("3", this=0655)
-        cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["1"].metadata_change is not None)
-        assert(isinstance(cset.entries["1"].metadata_change,
-                          PermissionsMerge))
-        assert(isinstance(cset.entries["2"].metadata_change,
-                          PermissionsMerge))
-        assert(cset.entries["3"].is_boring())
-        builder.apply_changeset(cset)
-        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0655)
-        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0755)
-        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0655)
-        builder.cleanup();
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_perms("1", other=0655, base=0555)
-        cset = builder.merge_changeset(ApplyMerge3)
-        self.assertRaises(changeset.MergePermissionConflict, 
-                     builder.apply_changeset, cset)
-        builder.cleanup()
-
-class FunctionalMergeTest(TestCaseInTempDir):
-
-    def test_trivial_star_merge(self):
-        """Test that merges in a star shape Just Work.""" 
-        from bzrlib.add import smart_add_branch, add_reporter_null
-        from bzrlib.branch import copy_branch
-        from bzrlib.merge import merge
-        # John starts a branch
-        self.build_tree(("original/", "original/file1", "original/file2"))
-        branch = Branch("original", init=True)
-        smart_add_branch(branch, ["original"], True, add_reporter_null)
-        branch.commit("start branch.", verbose=False)
-        # Mary branches it.
-        self.build_tree(("mary/",))
-        copy_branch(branch, "mary")
-        # Now John commits a change
-        file = open("original/file1", "wt")
-        file.write("John\n")
-        file.close()
-        branch.commit("change file1")
-        # Mary does too
-        mary_branch = Branch("mary")
-        file = open("mary/file2", "wt")
-        file.write("Mary\n")
-        file.close()
-        mary_branch.commit("change file2")
-        # john should be able to merge with no conflicts.
-        merge_type = ApplyMerge3
-        base = [None, None]
-        other = ("mary", -1)
-        merge(other, base, check_clean=True, merge_type=merge_type, this_dir="original")
-        self.assertEqual("John\n", open("original/file1", "rt").read())
-        self.assertEqual("Mary\n", open("original/file2", "rt").read())

=== removed file 'bzrlib/selftest/test_parent.py'
--- bzrlib/selftest/test_parent.py	2005-08-30 05:55:13 +0000
+++ bzrlib/selftest/test_parent.py	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.branch import Branch, copy_branch
-
-
-
-class TestParent(TestCaseInTempDir):
-    def test_no_default_parent(self):
-        """Branches should have no parent by default"""
-        b = Branch('.', init=True)
-        self.assertEquals(b.get_parent(), None)
-        
-    
-    def test_set_get_parent(self):
-        """Set and then re-get the parent"""
-        b = Branch('.', init=True)
-        url = 'http://bazaar-ng.org/bzr/bzr.dev'
-        b.set_parent(url)
-        self.assertEquals(b.get_parent(), url)
-
-    def test_branch_sets_parent(self):
-        """The branch command should set the new branch's parent"""
-        from bzrlib.commands import run_bzr
-
-        os.mkdir('from')
-        branch_from = Branch('from', init=True)
-        file('from/foo', 'wt').write('contents of foo')
-        branch_from.add('foo')
-        branch_from.commit('initial commit')
-        
-        os.mkdir('to')
-        copy_branch(branch_from, 'to', None)
-
-        branch_to = Branch('to')
-        abspath = os.path.abspath('from')
-        self.assertEquals(branch_to.get_parent(), abspath)
-        
-

=== removed file 'bzrlib/selftest/test_smart_add.py'
--- bzrlib/selftest/test_smart_add.py	2005-09-01 06:33:48 +0000
+++ bzrlib/selftest/test_smart_add.py	1970-01-01 00:00:00 +0000
@@ -1,160 +0,0 @@
-import os
-import unittest
-
-from bzrlib.selftest import TestCaseInTempDir, TestCase
-from bzrlib.branch import Branch
-from bzrlib.errors import NotBranchError, NotVersionedError
-
-class TestSmartAdd(TestCaseInTempDir):
-
-    def test_add_dot_from_root(self):
-        """Test adding . from the root of the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add((".",), recurse=True)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_dot_from_subdir(self):
-        """Test adding . from a subdir of the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        os.chdir("original")
-        smart_add((".",), recurse=True)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_tree_from_above_tree(self):
-        """Test adding a tree from above the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        branch_paths = ("branch/", "branch/original/", "branch/original/file1",
-                        "branch/original/file2")
-        self.build_tree(branch_paths)
-        branch = Branch("branch", init=True)
-        smart_add(("branch",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_above_tree_preserves_tree(self):
-        """Test nested trees are not affect by an add above them."""
-        from bzrlib.add import smart_add, add_reporter_null
-        
-        paths = ("original/", "original/file1", "original/file2")
-        child_paths = ("path",)
-        full_child_paths = ("original/child", "original/child/path")
-        build_paths = ("original/", "original/file1", "original/file2", 
-                       "original/child/", "original/child/path")
-        
-        self.build_tree(build_paths)
-        branch = Branch(".", init=True)
-        child_branch = Branch("original/child", init=True)
-        smart_add((".",), True, add_reporter_null)
-        for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
-                                (path, None))
-        for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
-                             (path, None))
-        for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
-
-    def test_add_paths(self):
-        """Test smart-adding a list of paths."""
-        from bzrlib.add import smart_add
-        paths = ("file1", "file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add(paths)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-            
-class TestSmartAddBranch(TestCaseInTempDir):
-    """Test smart adds with a specified branch."""
-
-    def test_add_dot_from_root(self):
-        """Test adding . from the root of the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_dot_from_subdir(self):
-        """Test adding . from a subdir of the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        os.chdir("original")
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_tree_from_above_tree(self):
-        """Test adding a tree from above the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        branch_paths = ("branch/", "branch/original/", "branch/original/file1",
-                        "branch/original/file2")
-        self.build_tree(branch_paths)
-        branch = Branch("branch", init=True)
-        smart_add_branch(branch, ("branch",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_above_tree_preserves_tree(self):
-        """Test nested trees are not affect by an add above them."""
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        child_paths = ("path")
-        full_child_paths = ("original/child", "original/child/path")
-        build_paths = ("original/", "original/file1", "original/file2", 
-                       "original/child/", "original/child/path")
-        self.build_tree(build_paths)
-        branch = Branch(".", init=True)
-        child_branch = Branch("original/child", init=True)
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
-                                (path, None))
-        for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
-                             (path, None))
-        for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
-
-    def test_add_paths(self):
-        """Test smart-adding a list of paths."""
-        from bzrlib.add import smart_add_branch
-        paths = ("file1", "file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add_branch(branch, paths)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-class TestAddCallbacks(TestCaseInTempDir):
-
-    def setUp(self):
-        from bzrlib.inventory import InventoryEntry
-        super(TestAddCallbacks, self).setUp()
-        self.entry = InventoryEntry("id", "name", "file", None)
-
-    def test_null_callback(self):
-        from bzrlib.add import add_reporter_null
-        add_reporter_null('path', 'file', self.entry)
-
-    def test_print_callback(self):
-        from bzrlib.add import add_reporter_print
-        from StringIO import StringIO
-        stdout = StringIO()
-        self.apply_redirected(None, stdout, None, add_reporter_print,
-                              'path', 'file', self.entry)
-        self.assertEqual(stdout.getvalue(), "added path\n")

=== removed file 'bzrlib/selftest/test_xml.py'
--- bzrlib/selftest/test_xml.py	2005-09-06 07:26:13 +0000
+++ bzrlib/selftest/test_xml.py	1970-01-01 00:00:00 +0000
@@ -1,140 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from cStringIO import StringIO
-
-from bzrlib.selftest import TestCase
-from bzrlib.inventory import Inventory, InventoryEntry
-from bzrlib.xml import serializer_v4, serializer_v5
-
-_working_inventory_v4 = """<inventory file_id="TREE_ROOT">
-<entry file_id="bar-20050901064931-73b4b1138abc9cd2" kind="file" name="bar" parent_id="TREE_ROOT" />
-<entry file_id="foo-20050801201819-4139aa4a272f4250" kind="directory" name="foo" parent_id="TREE_ROOT" />
-<entry file_id="bar-20050824000535-6bc48cfad47ed134" kind="file" name="bar" parent_id="foo-20050801201819-4139aa4a272f4250" />
-</inventory>"""
-
-
-_revision_v4 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;"
-    inventory_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
-    revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    timestamp="1125907235.211783886"
-    timezone="36000">
-<message>- start splitting code for xml (de)serialization away from objects
-  preparatory to supporting multiple formats by a single library
-</message>
-<parents>
-<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92" revision_sha1="7bdf4cc8c5bdac739f8cf9b10b78cf4b68f915ff" />
-</parents>
-</revision>
-"""
-
-_revision_v5 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;"
-    inventory_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
-    revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    timestamp="1125907235.211783886"
-    timezone="36000">
-<message>- start splitting code for xml (de)serialization away from objects
-  preparatory to supporting multiple formats by a single library
-</message>
-<parents>
-<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92"/>
-</parents>
-</revision>
-"""
-
-_committed_inv_v5 = """<inventory>
-<file file_id="bar-20050901064931-73b4b1138abc9cd2" 
-      name="bar" parent_id="TREE_ROOT" 
-      text_version="mbp@foo-123123" entry_version="mbp@foo-123123"
-      />
-<directory name="subdir"
-           file_id="foo-20050801201819-4139aa4a272f4250"
-           parent_id="TREE_ROOT" 
-           entry_version="mbp@foo-00"/>
-<file file_id="bar-20050824000535-6bc48cfad47ed134" 
-      name="bar" parent_id="foo-20050801201819-4139aa4a272f4250" 
-      entry_version="mbp@foo-00"
-      text_version="mbp@foo-123123"/>
-</inventory>
-"""
-
-class TestSerializer(TestCase):
-    """Test XML serialization"""
-    def test_canned_inventory(self):
-        """Test unpacked a canned inventory v4 file."""
-        inp = StringIO(_working_inventory_v4)
-        inv = serializer_v4.read_inventory(inp)
-        self.assertEqual(len(inv), 4)
-        self.assert_('bar-20050901064931-73b4b1138abc9cd2' in inv)
-
-    def test_unpack_revision(self):
-        """Test unpacking a canned revision v4"""
-        inp = StringIO(_revision_v4)
-        rev = serializer_v4.read_revision(inp)
-        eq = self.assertEqual
-        eq(rev.committer,
-           "Martin Pool <mbp@sourcefrog.net>")
-        eq(rev.inventory_id,
-           "mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9")
-        eq(len(rev.parents), 1)
-        eq(rev.parents[0].revision_id,
-           "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
-
-    def test_unpack_revision_5(self):
-        """Test unpacking a canned revision v5"""
-        inp = StringIO(_revision_v5)
-        rev = serializer_v5.read_revision(inp)
-        eq = self.assertEqual
-        eq(rev.committer,
-           "Martin Pool <mbp@sourcefrog.net>")
-        eq(rev.inventory_id,
-           "mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9")
-        eq(len(rev.parents), 1)
-        eq(rev.timezone, 36000)
-        eq(rev.parents[0].revision_id,
-           "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
-
-    def test_unpack_inventory_5(self):
-        """Unpack canned new-style inventory"""
-        inp = StringIO(_committed_inv_v5)
-        inv = serializer_v5.read_inventory(inp)
-        eq = self.assertEqual
-        eq(len(inv), 4)
-        ie = inv['bar-20050824000535-6bc48cfad47ed134']
-        eq(ie.kind, 'file')
-        eq(ie.text_version, 'mbp@foo-123123')
-        eq(ie.entry_version, 'mbp@foo-00')
-        eq(ie.name, 'bar')
-        eq(inv[ie.parent_id].kind, 'directory')
-
-    def test_repack_inventory_5(self):
-        inp = StringIO(_committed_inv_v5)
-        inv = serializer_v5.read_inventory(inp)
-        outp = StringIO()
-        serializer_v5.write_inventory(inv, outp)
-        inv2 = serializer_v5.read_inventory(StringIO(outp.getvalue()))
-        self.assertEqual(inv, inv2)
-
-    def test_repack_revision_5(self):
-        inp = StringIO(_revision_v5)
-        rev = serializer_v5.read_revision(inp)
-        outp = StringIO()
-        serializer_v5.write_revision(rev, outp)
-        rev2 = serializer_v5.read_revision(StringIO(outp.getvalue()))
-        self.assertEqual(rev, rev2)
-

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-09-06 11:09:03 +0000
+++ bzrlib/selftest/testbranch.py	2005-08-25 05:58:05 +0000
@@ -14,10 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class TestAppendRevisions(TestCaseInTempDir):
+from bzrlib.selftest import InTempDir
+
+
+
+class TestAppendRevisions(InTempDir):
     """Test appending more than one revision"""
     def test_append_revisions(self):
         from bzrlib.branch import Branch
@@ -26,6 +27,13 @@
         self.assertEquals(br.revision_history(), ["rev1",])
         br.append_revision("rev2", "rev3")
         self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
+        
+
+
+TEST_CLASSES = [
+    TestAppendRevisions,
+    ]
+
 
 
 # TODO: rewrite this as a regular unittest, without relying on the displayed output        

=== modified file 'bzrlib/selftest/testdiff.py'
--- bzrlib/selftest/testdiff.py	2005-08-25 12:46:42 +0000
+++ bzrlib/selftest/testdiff.py	2005-08-24 02:34:24 +0000
@@ -46,3 +46,5 @@
         check_patch(lines)
         assert lines[5] == '\\ No newline at end of file\n', \
             "expected no-nl, got %r" % lines[5]
+
+TEST_CLASSES = [ TestDiff ]

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/testfetch.py	2005-08-29 01:25:00 +0000
@@ -20,12 +20,14 @@
 import sys
 import os
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
         
 
-class TestFetch(TestCaseInTempDir):
+class TestFetch(InTempDir):
     def runTest(self):
+        from bzrlib.commit import commit
         from bzrlib.fetch import greedy_fetch, has_revision
+        from bzrlib.selftest.testrevision import make_branches
 
         def new_branch(name):
             os.mkdir(name)
@@ -91,5 +93,5 @@
 
 
 if __name__ == '__main__':
-    import unittest
-    sys.exit(unittest.run_suite(unittest.makeSuite()))
+    import sys
+    sys.exit(run_suite(unittest.makeSuite()))

=== removed file 'bzrlib/selftest/testgraph.py'
--- bzrlib/selftest/testgraph.py	2005-09-10 23:46:35 +0000
+++ bzrlib/selftest/testgraph.py	1970-01-01 00:00:00 +0000
@@ -1,36 +0,0 @@
-from bzrlib.selftest import TestCase
-from bzrlib.graph import farthest_nodes
-
-class TestBase(TestCase):
-    def edge_add(self, *args):
-        for start, end in zip(args[:-1], args[1:]):
-            if start not in self.graph:
-                self.graph[start] = {}
-            if end not in self.graph:
-                self.graph[end] = {}
-            self.graph[start][end] = 1
-
-    def setUp(self):
-        TestCase.setUp(self)
-        self.graph = {}
-        self.edge_add('A', 'B', 'C', 'D')
-        self.edge_add('A', 'E', 'F', 'C')
-        self.edge_add('A', 'G', 'H', 'I', 'B')
-        self.edge_add('A', 'J', 'K', 'L', 'M', 'N')
-        self.edge_add('O', 'N')
-    
-    def test_farthest(self):
-        descendants = {'A':set()}
-        for node in self.graph:
-            for ancestor in self.graph[node]:
-                if ancestor not in descendants:
-                    descendants[ancestor] = set()
-                descendants[ancestor].add(node)
-        nodes = farthest_nodes(self.graph, descendants, 'A')
-        self.assertEqual(nodes[0], 'D')
-        assert nodes[1] in ('N', 'C')
-        assert nodes[2] in ('N', 'C')
-        assert nodes[3] in ('B', 'M')
-        assert nodes[4] in ('B', 'M')
-
-

=== modified file 'bzrlib/selftest/testhashcache.py'
--- bzrlib/selftest/testhashcache.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/testhashcache.py	2005-08-24 02:34:24 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
 
 
@@ -31,12 +31,13 @@
         time.sleep(0.2)
     
 
-class TestHashCache(TestCaseInTempDir):
+class TestHashCache(InTempDir):
 
     def test_hashcache(self):
         """Functional tests for hashcache"""
         from bzrlib.hashcache import HashCache
         import os
+        import time
 
         # make a dummy bzr directory just to hold the cache
         os.mkdir('.bzr')

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-09-05 08:00:35 +0000
+++ bzrlib/selftest/testinv.py	2005-08-24 02:34:24 +0000
@@ -49,11 +49,3 @@
         self.assertEqual(inv.path2id('src/bye.c'), 'bye-id')
         
         self.assert_('src-id' in inv)
-
-
-    def test_version(self):
-        """Inventory remembers the text's version."""
-        inv = Inventory()
-        ie = inv.add_path('foo.txt', 'file')
-        ## XXX
-

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-09-05 01:31:37 +0000
+++ bzrlib/selftest/testlog.py	2005-08-29 01:25:00 +0000
@@ -17,10 +17,9 @@
 import os
 from cStringIO import StringIO
 
-from bzrlib.selftest import BzrTestBase, TestCaseInTempDir
+from bzrlib.selftest import BzrTestBase, InTempDir
 from bzrlib.log import LogFormatter, show_log, LongLogFormatter
 from bzrlib.branch import Branch
-from bzrlib.errors import InvalidRevisionNumber
 
 class _LogEntry(object):
     # should probably move into bzrlib.log?
@@ -49,7 +48,7 @@
         self.logs.append(le)
 
 
-class SimpleLogTest(TestCaseInTempDir):
+class SimpleLogTest(InTempDir):
 
     def checkDelta(self, delta, **kw):
         """Check the filenames touched by a delta are as expected."""
@@ -64,27 +63,9 @@
             got = [x[0] for x in getattr(delta, n)]
             self.assertEquals(expected, got)
 
-    def test_cur_revno(self):
-        b = Branch('.', init=True)
-
-        lf = LogCatcher()
-        b.commit('empty commit')
-        show_log(b, lf, verbose=True, start_revision=1, end_revision=1)
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=2, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=0, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=0) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=-1, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=-1) 
-
     def test_simple_log(self):
         eq = self.assertEquals
+        ass = self.assert_
         
         b = Branch('.', init=True)
 

=== removed file 'bzrlib/selftest/testmerge.py'
--- bzrlib/selftest/testmerge.py	2005-09-14 16:35:46 +0000
+++ bzrlib/selftest/testmerge.py	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-from bzrlib.branch import Branch
-from bzrlib.commit import commit
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.merge import merge
-from bzrlib.errors import UnrelatedBranches, NoCommits
-import os
-class TestMerge(TestCaseInTempDir):
-    """Test appending more than one revision"""
-    def test_pending(self):
-        br = Branch(".", init=True)
-        commit(br, "lala!")
-        self.assertEquals(len(br.pending_merges()), 0)
-        merge(['.', -1], [None, None])
-        self.assertEquals(len(br.pending_merges()), 0)
-
-    def test_nocommits(self):
-        self.test_pending()
-        os.mkdir('branch2')
-        br2 = Branch('branch2', init=True)
-        self.assertRaises(NoCommits, merge, ['branch2', -1], 
-                          [None, None])
-        return br2
-
-    def test_unrelated(self):
-        br2 = self.test_nocommits()
-        commit(br2, "blah")
-        merge, ['branch2', -1], [None, None]
-        self.assertRaises(UnrelatedBranches, merge, ['branch2', -1], 
-                          [None, None])
-

=== modified file 'bzrlib/selftest/testmerge3.py'
--- bzrlib/selftest/testmerge3.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/testmerge3.py	2005-08-24 02:34:24 +0000
@@ -15,7 +15,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.selftest import TestCaseInTempDir, TestCase
+from bzrlib.selftest import InTempDir, TestCase
 from bzrlib.merge3 import Merge3
 
 def split_lines(t):
@@ -82,12 +82,12 @@
      The two are the same,
      But after they are produced,
        they have different names.
-<<<<<<< LAO
-=======
+<<<<<<<< LAO
+========
      
        -- The Way of Lao-Tzu, tr. Wing-tsit Chan
 
->>>>>>> TAO
+>>>>>>>> TAO
 """)
 
 class TestMerge3(TestCase):
@@ -221,8 +221,8 @@
                             start_marker='<<',
                             mid_marker='--',
                             end_marker='>>')
-        self.assertEquals(''.join(ml), 'aaa\n222\nbbb\n')
-        
+        self.assertEquals(''.join(m3.merge_lines()),
+                          'aaa\n222\nbbb\n')
 
     def test_insert_clash(self):
         """Both try to insert lines in the same place."""
@@ -300,3 +300,6 @@
         self.log('merge result:')
         self.log(''.join(ml))
         self.assertEquals(ml, MERGED_RESULT)
+
+
+TEST_CLASSES = [ TestMerge3 ]

=== removed file 'bzrlib/selftest/testremotebranch.py'
--- bzrlib/selftest/testremotebranch.py	2005-09-14 18:07:16 +0000
+++ bzrlib/selftest/testremotebranch.py	1970-01-01 00:00:00 +0000
@@ -1,78 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-import bzrlib.errors
-from bzrlib.selftest.testrevision import make_branches
-from bzrlib.trace import mutter
-from bzrlib.branch import Branch, find_branch
-import sys
-import os
-
-from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
-        
-
-class TestFetch(TestCaseWithWebserver):
-    def runTest(self):
-        from bzrlib.fetch import greedy_fetch, has_revision
-
-        def new_branch(name):
-            os.mkdir(name)
-            return Branch(name, init=True)
-            
-        #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
-        br_rem = find_branch(self.get_remote_url(br_a.base))
-        assert not has_revision(br_b, br_rem.revision_history()[3])
-        assert has_revision(br_b, br_rem.revision_history()[2])
-        assert len(br_b.revision_history()) == 7
-        assert greedy_fetch(br_b, br_rem, br_rem.revision_history()[2])[0] == 0
-
-        # greedy_fetch is not supposed to alter the revision history
-        assert len(br_b.revision_history()) == 7
-        assert not has_revision(br_b, br_rem.revision_history()[3])
-
-        assert len(br_b.revision_history()) == 7
-        assert greedy_fetch(br_b, br_rem, br_rem.revision_history()[3])[0] == 1
-        assert has_revision(br_b, br_a.revision_history()[3])
-        assert not has_revision(br_rem, br_b.revision_history()[3])
-        assert not has_revision(br_rem, br_b.revision_history()[4])
-
-        # When a non-branch ancestor is missing, it should be a failure, not
-        # exception
-        br_a4 = new_branch('br_a4')
-        count, failures = greedy_fetch(br_a4, br_rem)
-        assert count == 6
-        assert failures == set((br_b.revision_history()[4],
-                                br_b.revision_history()[5])) 
-
-        assert greedy_fetch(br_a, br_b)[0] == 4
-        assert has_revision(br_a, br_b.revision_history()[3])
-        assert has_revision(br_a, br_b.revision_history()[4])
-
-        br_b2 = new_branch('br_b2')
-        assert greedy_fetch(br_b2, br_b)[0] == 7
-        assert has_revision(br_b2, br_b.revision_history()[4])
-        assert has_revision(br_b2, br_a.revision_history()[2])
-        assert not has_revision(br_b2, br_a.revision_history()[3])
-
-        br_a2 = new_branch('br_a2')
-        assert greedy_fetch(br_a2, br_rem)[0] == 9
-        assert has_revision(br_a2, br_b.revision_history()[4])
-        assert has_revision(br_a2, br_a.revision_history()[3])
-
-
-if __name__ == '__main__':
-    import unittest
-    sys.exit(unittest.run_suite(unittest.makeSuite()))

=== modified file 'bzrlib/selftest/testrevision.py'
--- bzrlib/selftest/testrevision.py	2005-09-12 12:39:58 +0000
+++ bzrlib/selftest/testrevision.py	2005-08-25 05:58:05 +0000
@@ -14,12 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
 
 def make_branches():
     from bzrlib.branch import Branch
     from bzrlib.commit import commit
+    from bzrlib.revision import validate_revision_id
     import os
     os.mkdir("branch1")
     br1 = Branch("branch1", init=True)
@@ -45,7 +46,8 @@
     return br1, br2
 
 
-class TestIsAncestor(TestCaseInTempDir):
+class TestIsAncestor(InTempDir):
+
     def test_is_ancestor(self):
         """Test checking whether a revision is an ancestor of another revision"""
         from bzrlib.revision import is_ancestor, MultipleRevisionSources
@@ -66,76 +68,11 @@
         assert is_ancestor(revisions[3], revisions_2[3], sources)
         assert not is_ancestor(revisions[3], revisions_2[3], br1)
 
-class TestIntermediateRevisions(TestCaseInTempDir):
-
-    def setUp(self):
-        from bzrlib.commit import commit
-        TestCaseInTempDir.setUp(self)
-        self.br1, self.br2 = make_branches()
-        commit(self.br2, "Commit eleven", rev_id="b@u-0-7")
-        commit(self.br2, "Commit twelve", rev_id="b@u-0-8")
-        commit(self.br2, "Commit thirtteen", rev_id="b@u-0-9")
-        self.br1.add_pending_merge(self.br2.revision_history()[6])
-        commit(self.br1, "Commit fourtten", rev_id="a@u-0-6")
-        self.br2.add_pending_merge(self.br1.revision_history()[6])
-        commit(self.br2, "Commit fifteen", rev_id="b@u-0-10")
-
-        from bzrlib.revision import MultipleRevisionSources
-        self.sources = MultipleRevisionSources(self.br1, self.br2)
-
-    def intervene(self, ancestor, revision, revision_history=None):
-        from bzrlib.revision import get_intervening_revisions
-        return get_intervening_revisions(ancestor,revision, self.sources, 
-                                         revision_history)
-
-    def test_intervene(self):
-        """Find intermediate revisions, without requiring history"""
-        from bzrlib.errors import NotAncestor, NoSuchRevision
-        assert len(self.intervene('a@u-0-0', 'a@u-0-0')) == 0
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-1'), ['a@u-0-1'])
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-2'), 
-                         ['a@u-0-1', 'a@u-0-2'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-3'), 
-                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3'])
-        self.assertEqual(self.intervene('b@u-0-3', 'a@u-0-3'), 
-                         ['b@u-0-4', 'a@u-0-3'])
-        self.assertEqual(self.intervene('a@u-0-2', 'a@u-0-3', 
-                                        self.br1.revision_history()), 
-                         ['a@u-0-3'])
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-5', 
-                                        self.br1.revision_history()), 
-                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
-                          'a@u-0-5'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-6', 
-                         self.br1.revision_history()), 
-                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
-                          'b@u-0-6'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-5'), 
-                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3', 'b@u-0-4', 
-                          'b@u-0-5'])
-        self.assertEqual(self.intervene('b@u-0-3', 'b@u-0-6', 
-                         self.br2.revision_history()), 
-                         ['b@u-0-4', 'b@u-0-5', 'b@u-0-6'])
-        self.assertEqual(self.intervene('b@u-0-6', 'b@u-0-10'), 
-                         ['b@u-0-7', 'b@u-0-8', 'b@u-0-9', 'b@u-0-10'])
-        self.assertEqual(self.intervene('b@u-0-6', 'b@u-0-10', 
-                                        self.br2.revision_history()), 
-                         ['b@u-0-7', 'b@u-0-8', 'b@u-0-9', 'b@u-0-10'])
-        self.assertRaises(NotAncestor, self.intervene, 'b@u-0-10', 'b@u-0-6', 
-                          self.br2.revision_history())
-        self.assertRaises(NoSuchRevision, self.intervene, 'c@u-0-10', 
-                          'b@u-0-6', self.br2.revision_history())
-        self.assertRaises(NoSuchRevision, self.intervene, 'b@u-0-10', 
-                          'c@u-0-6', self.br2.revision_history())
-
-
-class TestCommonAncestor(TestCaseInTempDir):
+
+class TestCommonAncestor(InTempDir):
     """Test checking whether a revision is an ancestor of another revision"""
-
-    def test_old_common_ancestor(self):
-        """Pick a resonable merge base using the old functionality"""
-        from bzrlib.revision import find_present_ancestors
-        from bzrlib.revision import old_common_ancestor as common_ancestor
+    def runTest(self):
+        from bzrlib.revision import find_present_ancestors, common_ancestor
         from bzrlib.revision import MultipleRevisionSources
         br1, br2 = make_branches()
         revisions = br1.revision_history()
@@ -172,43 +109,7 @@
         self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
                           revisions_2[5])
 
-    def test_common_ancestor(self):
-        """Pick a reasonable merge base"""
-        from bzrlib.revision import find_present_ancestors
-        from bzrlib.revision import common_ancestor
-        from bzrlib.revision import MultipleRevisionSources
-        br1, br2 = make_branches()
-        revisions = br1.revision_history()
-        revisions_2 = br2.revision_history()
-        sources = MultipleRevisionSources(br1, br2)
-
-        expected_ancestors_list = {revisions[3]:(0, 0), 
-                                   revisions[2]:(1, 1),
-                                   revisions_2[4]:(2, 1), 
-                                   revisions[1]:(3, 2),
-                                   revisions_2[3]:(4, 2),
-                                   revisions[0]:(5, 3) }
-        ancestors_list = find_present_ancestors(revisions[3], sources)
-        assert len(expected_ancestors_list) == len(ancestors_list)
-        for key, value in expected_ancestors_list.iteritems():
-            self.assertEqual(ancestors_list[key], value, 
-                              "key %r, %r != %r" % (key, ancestors_list[key],
-                                                    value))
-
-        self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
-                          revisions[0])
-        self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[1], revisions[1], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[2], revisions_2[4], sources),
-                          revisions[2])
-        self.assertEqual(common_ancestor(revisions[3], revisions_2[4], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4])
-        self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions[4])
-
+TEST_CLASSES = [
+    TestIsAncestor,
+    TestCommonAncestor,
+    ]

=== modified file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-09-14 17:23:14 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	2005-08-24 02:34:24 +0000
@@ -14,17 +14,16 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.errors import NoCommonAncestor, NoCommits
-from bzrlib.branch import copy_branch
-from bzrlib.merge import merge
-
-class TestRevisionNamespaces(TestCaseInTempDir):
+
+from bzrlib.selftest import InTempDir
+
+class TestRevisionNamespaces(InTempDir):
     def test_revision_namespaces(self):
         """Functional tests for hashcache"""
-        from bzrlib.errors import NoSuchRevision
+        from bzrlib.errors import BzrError
         from bzrlib.branch import Branch
+        import os
+        import time
 
         b = Branch('.', init=True)
 
@@ -32,30 +31,16 @@
         b.commit('Commit two', rev_id='a@r-0-2')
         b.commit('Commit three', rev_id='a@r-0-3')
 
-        self.assertEquals(b.get_revision_info(None), (0, None))
         self.assertEquals(b.get_revision_info(1), (1, 'a@r-0-1'))
         self.assertEquals(b.get_revision_info('revno:1'), (1, 'a@r-0-1'))
         self.assertEquals(b.get_revision_info('revid:a@r-0-1'), (1, 'a@r-0-1'))
-        self.assertRaises(NoSuchRevision, b.get_revision_info, 'revid:a@r-0-0')
-        self.assertRaises(TypeError, b.get_revision_info, object)
+        self.assertRaises(BzrError, b.get_revision_info, 'revid:a@r-0-0')
 
         self.assertEquals(b.get_revision_info('date:-tomorrow'), (3, 'a@r-0-3'))
         self.assertEquals(b.get_revision_info('date:+today'), (1, 'a@r-0-1'))
 
         self.assertEquals(b.get_revision_info('last:1'), (3, 'a@r-0-3'))
-        self.assertEquals(b.get_revision_info('-1'), (3, 'a@r-0-3'))
-
-        os.mkdir('newbranch')
-        b2 = Branch('newbranch', init=True)
-        self.assertEquals(b2.lookup_revision('revid:a@r-0-1'), 'a@r-0-1')
-
-        self.assertRaises(NoCommits, b2.lookup_revision, 'ancestor:.')
-        self.assertEquals(b.lookup_revision('ancestor:.'), 'a@r-0-3')
-        os.mkdir('copy')
-        b3 = copy_branch(b, 'copy')
-        b3.commit('Commit four', rev_id='b@r-0-4')
-        self.assertEquals(b3.lookup_revision('ancestor:.'), 'a@r-0-3')
-        merge(['copy', -1], [None, None])
-        b.commit('Commit five', rev_id='a@r-0-4')
-        self.assertEquals(b.lookup_revision('ancestor:copy'), 'b@r-0-4')
-        self.assertEquals(b3.lookup_revision('ancestor:.'), 'b@r-0-4')
+
+TEST_CLASSES = [
+    TestRevisionNamespaces
+    ]

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/teststatus.py	2005-08-24 02:34:24 +0000
@@ -21,9 +21,9 @@
 """
 
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
-class BranchStatus(TestCaseInTempDir):
+class BranchStatus(InTempDir):
     
     def test_branch_status(self): 
         """Basic 'bzr mkdir' operation"""
@@ -40,14 +40,11 @@
 
         tof = StringIO()
         self.build_tree(['hello.c', 'bye.c'])
-        b.add_pending_merge('pending@pending-0-0')
         show_status(b, to_file=tof)
         tof.seek(0)
         self.assertEquals(tof.readlines(),
                           ['unknown:\n',
                            '  bye.c\n',
                            '  hello.c\n',
-                           'pending merges:\n',
-                           '  pending@pending-0-0\n'
                            ])
 

=== removed file 'bzrlib/selftest/teststore.py'
--- bzrlib/selftest/teststore.py	2005-09-15 21:35:53 +0000
+++ bzrlib/selftest/teststore.py	1970-01-01 00:00:00 +0000
@@ -1,111 +0,0 @@
-# Copyright (C) 2005 by Canonical Development Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test Store implementation
-"""
-from bzrlib.transport.local import LocalTransport
-from bzrlib.transport import NoSuchFile
-from bzrlib.store.compressed_text import CompressedTextStore
-from bzrlib.selftest import TestCaseInTempDir
-from StringIO import StringIO
-from bzrlib.errors import BzrError
-
-def fill_store(store):
-    store.add(StringIO('hello'), 'a')
-    store.add(StringIO('other'), 'b')
-    store.add(StringIO('something'), 'c')
-    store.add(StringIO('goodbye'), '123123')
-
-def check_equals(tester, store, files, values, ignore_missing=False):
-    files = store.get(files, ignore_missing=ignore_missing)
-    count = 0
-    for f, v in zip(files, values):
-        count += 1
-        if v is None:
-            tester.assert_(f is None)
-        else:
-            tester.assertEquals(f.read(), v)
-    tester.assertEquals(count, len(values))
-    # We need to check to make sure there are no more
-    # files to be returned, I'm using a cheezy way
-    # Convert to a list, and there shouldn't be any left
-    tester.assertEquals(len(list(files)), 0)
-
-def test_multiple_add(tester, store):
-    fill_store(store)
-    tester.assertRaises(BzrError, store.add, StringIO('goodbye'), '123123')
-
-def test_get(tester, store):
-    fill_store(store)
-
-    check_equals(tester, store, ['a'], ['hello'])
-    check_equals(tester, store, ['b', 'c'], ['other', 'something'])
-
-    # Make sure that requesting a non-existing file fails
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d'], [None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['a', 'd'], ['hello', None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d', 'a'], [None, 'hello'])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['d', 'd', 'd'], [None, None, None])
-    tester.assertRaises(NoSuchFile, check_equals, tester, store,
-            ['a', 'd', 'b'], ['hello', None, 'other'])
-
-def test_ignore_get(tester, store):
-    fill_store(store)
-
-    files = store.get(['d'], ignore_missing=True)
-    files = list(files)
-    tester.assertEquals(len(files), 1)
-    tester.assert_(files[0] is None)
-
-    check_equals(tester, store, ['a', 'd'], ['hello', None],
-            ignore_missing=True)
-    check_equals(tester, store, ['d', 'a'], [None, 'hello'],
-            ignore_missing=True)
-    check_equals(tester, store, ['d', 'd'], [None, None],
-            ignore_missing=True)
-    check_equals(tester, store, ['a', 'd', 'b'], ['hello', None, 'other'],
-            ignore_missing=True)
-    check_equals(tester, store, ['a', 'd', 'b'], ['hello', None, 'other'],
-            ignore_missing=True)
-    check_equals(tester, store, ['b', 'd', 'c'], ['other', None, 'something'],
-            ignore_missing=True)
-
-def get_compressed_store():
-    t = LocalTransport('.')
-    return CompressedTextStore(t)
-
-class TestCompressedTextStore(TestCaseInTempDir):
-    def test_multiple_add(self):
-        """Multiple add with same ID should raise a BzrError"""
-        store = get_compressed_store()
-        test_multiple_add(self, store)
-
-    def test_get(self):
-        store = get_compressed_store()
-        test_get(self, store)
-
-    def test_ignore_get(self):
-        store = get_compressed_store()
-        test_ignore_get(self, store)
-
-
-TEST_CLASSES = [
-    TestCompressedTextStore,
-    ]

=== removed file 'bzrlib/selftest/testtransport.py'
--- bzrlib/selftest/testtransport.py	2005-09-15 21:35:53 +0000
+++ bzrlib/selftest/testtransport.py	1970-01-01 00:00:00 +0000
@@ -1,227 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-from bzrlib.selftest import TestCaseInTempDir
-
-def test_transport(tester, t, readonly=False):
-    """Test a transport object. Basically, it assumes that the
-    Transport object is connected to the current working directory.
-    So that whatever is done through the transport, should show
-    up in the working directory, and vice-versa.
-
-    This also tests to make sure that the functions work with both
-    generators and lists (assuming iter(list) is effectively a generator)
-    """
-    import tempfile, os
-    from bzrlib.transport.local import LocalTransport
-
-    # Test has
-    files = ['a', 'b', 'e', 'g']
-    tester.build_tree(files)
-    tester.assertEqual(t.has('a'), True)
-    tester.assertEqual(t.has('c'), False)
-    tester.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
-            [True, True, False, False, True, False, True, False])
-    tester.assertEqual(list(t.has_multi(iter(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']))),
-            [True, True, False, False, True, False, True, False])
-
-    # Test get
-    tester.assertEqual(t.get('a').read(), open('a').read())
-    content_f = t.get_multi(files)
-    for path,f in zip(files, content_f):
-        tester.assertEqual(open(path).read(), f.read())
-
-    content_f = t.get_multi(iter(files))
-    for path,f in zip(files, content_f):
-        tester.assertEqual(open(path).read(), f.read())
-
-    tester.assertRaises(NoSuchFile, t.get, 'c')
-    try:
-        files = list(t.get_multi(['a', 'b', 'c']))
-    except NoSuchFile:
-        pass
-    else:
-        tester.fail('Failed to raise NoSuchFile for missing file in get_multi')
-    try:
-        files = list(t.get_multi(iter(['a', 'b', 'c', 'e'])))
-    except NoSuchFile:
-        pass
-    else:
-        tester.fail('Failed to raise NoSuchFile for missing file in get_multi')
-
-    # Test put
-    if readonly:
-        open('c', 'wb').write('some text for c\n')
-    else:
-        t.put('c', 'some text for c\n')
-    tester.assert_(os.path.exists('c'))
-    tester.assertEqual(open('c').read(), 'some text for c\n')
-    tester.assertEqual(t.get('c').read(), 'some text for c\n')
-    # Make sure 'has' is updated
-    tester.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
-            [True, True, True, False, True, False, True, False])
-    if readonly:
-        open('a', 'wb').write('new\ncontents for\na\n')
-        open('d', 'wb').write('contents\nfor d\n')
-    else:
-        # Put also replaces contents
-        tester.assertEqual(t.put_multi([('a', 'new\ncontents for\na\n'),
-                                      ('d', 'contents\nfor d\n')]),
-                         2)
-    tester.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
-            [True, True, True, True, True, False, True, False])
-    tester.assertEqual(open('a').read(), 'new\ncontents for\na\n')
-    tester.assertEqual(open('d').read(), 'contents\nfor d\n')
-
-    if readonly:
-        open('a', 'wb').write('diff\ncontents for\na\n')
-        open('d', 'wb').write('another contents\nfor d\n')
-    else:
-        tester.assertEqual(
-            t.put_multi(iter([('a', 'diff\ncontents for\na\n'),
-                              ('d', 'another contents\nfor d\n')]))
-                         , 2)
-    tester.assertEqual(open('a').read(), 'diff\ncontents for\na\n')
-    tester.assertEqual(open('d').read(), 'another contents\nfor d\n')
-
-    if not readonly:
-        tester.assertRaises(NoSuchFile, t.put, 'path/doesnt/exist/c', 'contents')
-
-    # Test mkdir
-    os.mkdir('dir_a')
-    tester.assertEqual(t.has('dir_a'), True)
-    tester.assertEqual(t.has('dir_b'), False)
-
-    if readonly:
-        os.mkdir('dir_b')
-    else:
-        t.mkdir('dir_b')
-    tester.assertEqual(t.has('dir_b'), True)
-    tester.assert_(os.path.isdir('dir_b'))
-
-    if readonly:
-        os.mkdir('dir_c')
-        os.mkdir('dir_d')
-    else:
-        t.mkdir_multi(['dir_c', 'dir_d'])
-    tester.assertEqual(list(t.has_multi(['dir_a', 'dir_b', 'dir_c', 'dir_d', 'dir_e', 'dir_b'])),
-            [True, True, True, True, False, True])
-    for d in ['dir_a', 'dir_b', 'dir_c', 'dir_d']:
-        tester.assert_(os.path.isdir(d))
-
-    if not readonly:
-        tester.assertRaises(NoSuchFile, t.mkdir, 'path/doesnt/exist')
-        tester.assertRaises(FileExists, t.mkdir, 'dir_a') # Creating a directory again should fail
-
-    # Make sure the transport recognizes when a
-    # directory is created by other means
-    # Caching Transports will fail, because dir_e was already seen not
-    # to exist. So instead, we will search for a new directory
-    #os.mkdir('dir_e')
-    #if not readonly:
-    #    tester.assertRaises(FileExists, t.mkdir, 'dir_e')
-
-    os.mkdir('dir_f')
-    if not readonly:
-        tester.assertRaises(FileExists, t.mkdir, 'dir_f')
-
-    # Test get/put in sub-directories
-    if readonly:
-        open('dir_a/a', 'wb').write('contents of dir_a/a')
-        open('dir_b/b', 'wb').write('contents of dir_b/b')
-    else:
-        tester.assertEqual(
-            t.put_multi([('dir_a/a', 'contents of dir_a/a'),
-                         ('dir_b/b', 'contents of dir_b/b')])
-                      , 2)
-    for f in ('dir_a/a', 'dir_b/b'):
-        tester.assertEqual(t.get(f).read(), open(f).read())
-
-    # Test copy_to
-    dtmp = tempfile.mkdtemp(dir='.', prefix='test-transport-')
-    dtmp_base = os.path.basename(dtmp)
-    local_t = LocalTransport(dtmp)
-
-    files = ['a', 'b', 'c', 'd']
-    t.copy_to(files, local_t)
-    for f in files:
-        tester.assertEquals(open(f).read(), open(os.path.join(dtmp_base, f)).read())
-
-    # TODO: Test append
-    # TODO: Make sure all entries support file-like objects as well as strings.
-
-class LocalTransportTest(TestCaseInTempDir):
-    def test_local_transport(self):
-        from bzrlib.transport.local import LocalTransport
-
-        t = LocalTransport('.')
-        test_transport(self, t)
-
-class HttpServer(object):
-    """This just encapsulates spawning and stopping
-    an httpserver.
-    """
-    def __init__(self):
-        """This just spawns a separate process to serve files from
-        this directory. Call the .stop() function to kill the
-        process.
-        """
-        from BaseHTTPServer import HTTPServer
-        from SimpleHTTPServer import SimpleHTTPRequestHandler
-        import os
-        if hasattr(os, 'fork'):
-            self.pid = os.fork()
-            if self.pid != 0:
-                return
-        else: # How do we handle windows, which doesn't have fork?
-            raise NotImplementedError('At present HttpServer cannot fork on Windows')
-
-            # We might be able to do something like os.spawn() for the
-            # python executable, and give it a simple script to run.
-            # but then how do we kill it?
-
-        try:
-            self.s = HTTPServer(('', 9999), SimpleHTTPRequestHandler)
-            # TODO: Is there something nicer than killing the server when done?
-            self.s.serve_forever()
-        except KeyboardInterrupt:
-            pass
-        os._exit(0)
-
-    def stop(self):
-        import os
-        if self.pid is None:
-            return
-        if hasattr(os, 'kill'):
-            import signal
-            os.kill(self.pid, signal.SIGINT)
-            os.waitpid(self.pid, 0)
-            self.pid = None
-        else:
-            raise NotImplementedError('At present HttpServer cannot stop on Windows')
-
-class HttpTransportTest(TestCaseInTempDir):
-    def test_http_transport(self):
-        from bzrlib.transport.http import HttpTransport
-
-        s = HttpServer()
-
-        t = HttpTransport('http://localhost:9999/')
-        test_transport(self, t, readonly=True)
-
-        s.stop()
-

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-09-12 01:29:49 +0000
+++ bzrlib/selftest/versioning.py	2005-08-29 03:42:38 +0000
@@ -17,12 +17,13 @@
 
 """Tests of simple versioning operations"""
 
+# TODO: test adding a file whose directory is not versioned
 # TODO: test trying to commit within a directory that is not yet added
 
 
 import os
 
-from bzrlib.selftest import BzrTestBase, TestCaseInTempDir
+from bzrlib.selftest import BzrTestBase, FunctionalTestCase
 from bzrlib.branch import Branch
 
 import logging
@@ -30,7 +31,7 @@
 debug = logger.debug
 
 
-class TestVersioning(TestCaseInTempDir):
+class TestVersioning(FunctionalTestCase):
     
     def test_mkdir(self): 
         """Basic 'bzr mkdir' operation"""
@@ -54,11 +55,11 @@
         self.assertEquals(delta.added[0][0], 'foo')
         self.failIf(delta.modified)
 
-    def test_branch_add_in_unversioned(self):
+    def test_add_in_unversioned(self):
         """Try to add a file in an unversioned directory.
 
-        "bzr add" adds the parent as necessary, but simple branch add
-        doesn't do that.
+        smart_add may eventually add the parent as necessary, but simple
+        branch add doesn't do that.
         """
         from bzrlib.branch import Branch
         from bzrlib.errors import NotVersionedError
@@ -74,53 +75,7 @@
         
         self.check_and_upgrade()
 
-
-    def test_add_in_unversioned(self):
-        """Try to add a file in an unversioned directory.
-
-        "bzr add" should add the parent(s) as necessary.
-        """
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        eq = self.assertEqual
-
-        b = Branch('.', init=True)
-
-        self.build_tree(['inertiatic/', 'inertiatic/esp'])
-        eq(list(b.unknowns()), ['inertiatic'])
-        run_bzr(['add', 'inertiatic/esp'])
-        eq(list(b.unknowns()), [])
-
-        # Multiple unversioned parents
-        self.build_tree(['veil/', 'veil/cerpin/', 'veil/cerpin/taxt'])
-        eq(list(b.unknowns()), ['veil'])
-        run_bzr(['add', 'veil/cerpin/taxt'])
-        eq(list(b.unknowns()), [])
-
-        # Check whacky paths work
-        self.build_tree(['cicatriz/', 'cicatriz/esp'])
-        eq(list(b.unknowns()), ['cicatriz'])
-        run_bzr(['add', 'inertiatic/../cicatriz/esp'])
-        eq(list(b.unknowns()), [])
-
-    def test_add_in_versioned(self):
-        """Try to add a file in a versioned directory.
-
-        "bzr add" should do this happily.
-        """
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        eq = self.assertEqual
-
-        b = Branch('.', init=True)
-
-        self.build_tree(['inertiatic/', 'inertiatic/esp'])
-        eq(list(b.unknowns()), ['inertiatic'])
-        run_bzr(['add', '--no-recurse', 'inertiatic'])
-        eq(list(b.unknowns()), ['inertiatic/esp'])
-        run_bzr(['add', 'inertiatic/esp'])
-        eq(list(b.unknowns()), [])
-
+        
     def test_subdir_add(self):
         """Add in subdirectory should add only things from there down"""
         
@@ -159,6 +114,7 @@
         """After all the above changes, run the check and upgrade commands.
 
         The upgrade should be a no-op."""
+        from bzrlib.commands import run_bzr
         b = Branch('.')
         debug('branch has %d revisions', b.revno())
         
@@ -176,7 +132,8 @@
         
 
         
-class SubdirCommit(TestCaseInTempDir):
+        
+class SubdirCommit(FunctionalTestCase):
 
     def test_subdir_commit(self):
         """Test committing a subdirectory, and committing within a directory."""

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-09-15 21:35:53 +0000
+++ bzrlib/selftest/whitebox.py	2005-08-24 02:34:24 +0000
@@ -1,12 +1,14 @@
+#! /usr/bin/python
+
 import os
 import unittest
 
-from bzrlib.selftest import TestCaseInTempDir, TestCase
+from bzrlib.selftest import InTempDir, TestCase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import NotBranchError, NotVersionedError
 
 
-class TestBranch(TestCaseInTempDir):
+class TestBranch(InTempDir):
 
     def test_unknowns(self):
         b = Branch('.', init=True)
@@ -70,28 +72,35 @@
                           'Martin Pool <mbp@sourcefrog.net>-20050311061123-96a255005c7c9dbe')
 
 
-class PendingMerges(TestCaseInTempDir):
-
+class PendingMerges(InTempDir):
     def test_pending_merges(self):
         """Tracking pending-merged revisions."""
         b = Branch('.', init=True)
 
         self.assertEquals(b.pending_merges(), [])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+    
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+
         b.add_pending_merge('wibble@fofof--20050401--1928390812')
         self.assertEquals(b.pending_merges(),
                           ['foo@azkhazan-123123-abcabc',
                            'wibble@fofof--20050401--1928390812'])
+
         b.commit("commit from base with two merges")
+
         rev = b.get_revision(b.revision_history()[0])
         self.assertEquals(len(rev.parents), 2)
         self.assertEquals(rev.parents[0].revision_id,
                           'foo@azkhazan-123123-abcabc')
         self.assertEquals(rev.parents[1].revision_id,
                            'wibble@fofof--20050401--1928390812')
+
         # list should be cleared when we do a commit
         self.assertEquals(b.pending_merges(), [])
         
@@ -209,3 +218,9 @@
         finally:
             os.chdir(savedir)
             shutil.rmtree(dtmp)
+
+
+TEST_CLASSES = [TestBranch,
+                TestRevisionId,
+                PendingMerges
+                ]

=== modified file 'bzrlib/shellcomplete.py'
--- bzrlib/shellcomplete.py	2005-09-09 17:12:26 +0000
+++ bzrlib/shellcomplete.py	2005-08-22 16:31:16 +0000
@@ -17,15 +17,15 @@
 
     from inspect import getdoc
     import commands
-    cmdobj = commands.get_cmd_object(cmdname)
+    context, cmdclass = commands.get_cmd_class(cmdname)
 
-    doc = getdoc(cmdobj)
+    doc = getdoc(cmdclass)
     if doc == None:
         raise NotImplementedError("sorry, no detailed shellcomplete yet for %r" % cmdname)
 
-    shellcomplete_on_option(cmdobj.takes_options, outfile = None)
-    for aname in cmdobj.takes_args:
-        outfile.write(aname + '\n')
+    shellcomplete_on_option(cmdclass.takes_options, outfile = None)
+    for aname in cmdclass.takes_args:
+	    outfile.write(aname + '\n')
 
 
 def shellcomplete_on_option(options, outfile = None):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-09-07 23:14:30 +0000
+++ bzrlib/status.py	2005-08-25 05:58:05 +0000
@@ -19,24 +19,17 @@
 def show_status(branch, show_unchanged=False,
                 specific_files=None,
                 show_ids=False,
-                to_file=None,
-                show_pending=True):
-    """Display status for non-ignored working files.
+                to_file=None):
+    """Display single-line status for non-ignored working files.
 
-    show_unchanged
-        If set, includes unchanged files.
+    show_all
+        If true, show unmodified files too.
 
     specific_files
         If set, only show the status of files in this list.
 
-    show_ids
-        If set, includes each file's id.
-
     to_file
         If set, write to this file (default stdout.)
-
-    show_pending
-        If set, write pending merges.
     """
     import sys
     from bzrlib.delta import compare_trees
@@ -69,10 +62,6 @@
                 print >>to_file, 'unknown:'
                 done_header = True
             print >>to_file, ' ', path
-        if show_pending and len(branch.pending_merges()) > 0:
-            print >>to_file, 'pending merges:'
-            for merge in branch.pending_merges():
-                print >> to_file, ' ', merge
     finally:
         branch.unlock()
         

=== removed directory 'bzrlib/store'
=== renamed file 'bzrlib/store/__init__.py' => 'bzrlib/store.py'
--- bzrlib/store/__init__.py	2005-09-15 21:35:53 +0000
+++ bzrlib/store.py	2005-08-25 09:17:19 +0000
@@ -21,10 +21,11 @@
 unique ID.
 """
 
-import bzrlib
+import os, tempfile, types, osutils, gzip, errno
+from stat import ST_SIZE
+from StringIO import StringIO
 from bzrlib.trace import mutter
 import bzrlib.ui
-import bzrlib.transport
 
 ######################################################################
 # stores
@@ -32,154 +33,220 @@
 class StoreError(Exception):
     pass
 
-class Store(object):
-    """This class represents the abstract storage layout for saving information.
+
+class ImmutableStore(object):
+    """Store that holds files indexed by unique names.
+
+    Files can be added, but not modified once they are in.  Typically
+    the hash is used as the name, or something else known to be unique,
+    such as a UUID.
+
+    >>> st = ImmutableScratchStore()
+
+    >>> st.add(StringIO('hello'), 'aa')
+    >>> 'aa' in st
+    True
+    >>> 'foo' in st
+    False
+
+    You are not allowed to add an id that is already present.
+
+    Entries can be retrieved as files, which may then be read.
+
+    >>> st.add(StringIO('goodbye'), '123123')
+    >>> st['123123'].read()
+    'goodbye'
+
+    TODO: Atomic add by writing to a temporary file and renaming.
+
+    In bzr 0.0.5 and earlier, files within the store were marked
+    readonly on disk.  This is no longer done but existing stores need
+    to be accomodated.
     """
-    _transport = None
-    _max_buffered_requests = 10
-
-    def __init__(self, transport):
-        assert isinstance(transport, bzrlib.transport.Transport)
-        self._transport = transport
+
+    def __init__(self, basedir):
+        self._basedir = basedir
+
+    def _path(self, id):
+        if '\\' in id or '/' in id:
+            raise ValueError("invalid store id %r" % id)
+        return os.path.join(self._basedir, id)
 
     def __repr__(self):
-        if self._transport is None:
-            return "%s(None)" % (self.__class__.__name__)
+        return "%s(%r)" % (self.__class__.__name__, self._basedir)
+
+    def add(self, f, fileid, compressed=True):
+        """Add contents of a file into the store.
+
+        f -- An open file, or file-like object."""
+        # FIXME: Only works on files that will fit in memory
+        
+        from bzrlib.atomicfile import AtomicFile
+        
+        mutter("add store entry %r" % (fileid))
+        if isinstance(f, types.StringTypes):
+            content = f
         else:
-            return "%s(%r)" % (self.__class__.__name__, self._transport.base)
-
-    __str__ = __repr__
-
-    def __len__(self):
-        raise NotImplementedError('Children should define their length')
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        raise NotImplementedError
-
-    def __contains__(self, fileid):
-        """"""
-        raise NotImplementedError
-
-    def __iter__(self):
-        raise NotImplementedError
-
-    def add(self, f, fileid):
-        """Add a file object f to the store accessible from the given fileid"""
-        raise NotImplementedError('Children of Store must define their method of adding entries.')
-
-    def add_multi(self, entries):
-        """Add a series of file-like or string objects to the store with the given
-        identities.
-        
-        :param entries: A list of tuples of file,id pairs [(file1, id1), (file2, id2), ...]
-                        This could also be a generator yielding (file,id) pairs.
-        """
-        for f, fileid in entries:
-            self.add(f, fileid)
-
-    def has(self, fileids):
-        """Return True/False for each entry in fileids.
-
-        :param fileids: A List or generator yielding file ids.
-        :return: A generator or list returning True/False for each entry.
-        """
-        for fileid in fileids:
-            if fileid in self:
-                yield True
+            content = f.read()
+            
+        p = self._path(fileid)
+        if os.access(p, os.F_OK) or os.access(p + '.gz', os.F_OK):
+            from bzrlib.errors import bailout
+            raise BzrError("store %r already contains id %r" % (self._basedir, fileid))
+
+        fn = p
+        if compressed:
+            fn = fn + '.gz'
+            
+        af = AtomicFile(fn, 'wb')
+        try:
+            if compressed:
+                gf = gzip.GzipFile(mode='wb', fileobj=af)
+                gf.write(content)
+                gf.close()
             else:
-                yield False
-
-    def get(self, fileids, ignore_missing=False, pb=None):
-        """Return a set of files, one for each requested entry.
-        
-        :param ignore_missing: If true, return None for entries which do not 
-                               exist.
-        :return: A list or generator of file-like objects, one for each id.
-        """
-        for fileid in fileids:
-            try:
-                yield self[fileid]
-            except KeyError:
-                if ignore_missing:
-                    yield None
-                else:
-                    raise
-
-    def copy_multi(self, other, ids, pb=None, permit_failure=False):
+                af.write(content)
+            af.commit()
+        finally:
+            af.close()
+
+
+    def copy_multi(self, other, ids, permit_failure=False):
         """Copy texts for ids from other into self.
 
-        If an id is present in self, it is skipped.  A count of copied
-        ids is returned, which may be less than len(ids).
+        If an id is present in self, it is skipped.
 
-        :param other: Another Store object
-        :param ids: A list of entry ids to be copied
-        :param pb: A ProgressBar object, if none is given, the default will be created.
-        :param permit_failure: Allow missing entries to be ignored
-        :return: (n_copied, [failed]) The number of entries copied successfully,
-            followed by a list of entries which could not be copied (because they
-            were missing)
+        Returns (count_copied, failed), where failed is a collection of ids
+        that could not be copied.
         """
-        if pb is None:
-            pb = bzrlib.ui.ui_factory.progress_bar()
-
-        ids = list(ids) # Make sure we don't have a generator, since we iterate 2 times
+        pb = bzrlib.ui.ui_factory.progress_bar()
+        
         pb.update('preparing to copy')
-        to_copy = []
-        for file_id, has in zip(ids, self.has(ids)):
-            if not has:
-                to_copy.append(file_id)
-        return self._do_copy(other, to_copy, pb, permit_failure=permit_failure)
-
-    def _do_copy(self, other, to_copy, pb, permit_failure=False):
-        """This is the standard copying mechanism, just get them one at
-        a time from remote, and store them locally.
-
-        :param other: Another Store object
-        :param to_copy: A list of entry ids to copy
-        :param pb: A ProgressBar object to display completion status.
-        :param permit_failure: Allow missing entries to be ignored
-        :return: (n_copied, [failed])
-            The number of entries copied, and a list of failed entries.
-        """
-        # This should be updated to use add_multi() rather than
-        # the current methods of buffering requests.
-        # One question, is it faster to queue up 1-10 and then copy 1-10
-        # then queue up 11-20, copy 11-20
-        # or to queue up 1-10, copy 1, queue 11, copy 2, etc?
-        # sort of pipeline versus batch.
-
-        # We can't use self._transport.copy_to because we don't know
-        # whether the local tree is in the same format as other
+        to_copy = [id for id in ids if id not in self]
+        if isinstance(other, ImmutableStore):
+            return self.copy_multi_immutable(other, to_copy, pb)
+        count = 0
+        for id in to_copy:
+            count += 1
+            pb.update('copy', count, len(to_copy))
+            if not permit_failure:
+                self.add(other[id], id)
+            else:
+                try:
+                    entry = other[id]
+                except IndexError:
+                    failures.add(id)
+                    continue
+                self.add(entry, id)
+                
+        assert count == len(to_copy)
+        pb.clear()
+        return count, []
+
+
+    def copy_multi_immutable(self, other, to_copy, pb, permit_failure=False):
+        from shutil import copyfile
+        count = 0
         failed = set()
-        def buffer_requests():
-            count = 0
-            buffered_requests = []
-            for fileid in to_copy:
-                try:
-                    f = other[fileid]
-                except KeyError:
-                    if permit_failure:
-                        failed.add(fileid)
-                        continue
+        for id in to_copy:
+            p = self._path(id)
+            other_p = other._path(id)
+            try:
+                copyfile(other_p, p)
+            except IOError, e:
+                if e.errno == errno.ENOENT:
+                    if not permit_failure:
+                        copyfile(other_p+".gz", p+".gz")
                     else:
-                        raise
-
-                buffered_requests.append((f, fileid))
-                if len(buffered_requests) > self._max_buffered_requests:
-                    yield buffered_requests.pop(0)
-                    count += 1
-                    pb.update('copy', count, len(to_copy))
-
-            for req in buffered_requests:
-                yield req
-                count += 1
-                pb.update('copy', count, len(to_copy))
-
-            assert count == len(to_copy)
-
-        self.add_multi(buffer_requests())
-
+                        try:
+                            copyfile(other_p+".gz", p+".gz")
+                        except IOError, e:
+                            if e.errno == errno.ENOENT:
+                                failed.add(id)
+                            else:
+                                raise
+                else:
+                    raise
+            
+            count += 1
+            pb.update('copy', count, len(to_copy))
+        assert count == len(to_copy)
         pb.clear()
-        return len(to_copy), failed
-
+        return count, failed
+    
+
+    def __contains__(self, fileid):
+        """"""
+        p = self._path(fileid)
+        return (os.access(p, os.R_OK)
+                or os.access(p + '.gz', os.R_OK))
+
+    # TODO: Guard against the same thing being stored twice, compressed and uncompresse
+
+    def __iter__(self):
+        for f in os.listdir(self._basedir):
+            if f[-3:] == '.gz':
+                # TODO: case-insensitive?
+                yield f[:-3]
+            else:
+                yield f
+
+    def __len__(self):
+        return len(os.listdir(self._basedir))
+
+
+    def __getitem__(self, fileid):
+        """Returns a file reading from a particular entry."""
+        p = self._path(fileid)
+        try:
+            return gzip.GzipFile(p + '.gz', 'rb')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+
+        try:
+            return file(p, 'rb')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+
+        raise IndexError(fileid)
+
+
+    def total_size(self):
+        """Return (count, bytes)
+
+        This is the (compressed) size stored on disk, not the size of
+        the content."""
+        total = 0
+        count = 0
+        for fid in self:
+            count += 1
+            p = self._path(fid)
+            try:
+                total += os.stat(p)[ST_SIZE]
+            except OSError:
+                total += os.stat(p + '.gz')[ST_SIZE]
+                
+        return count, total
+
+
+
+
+class ImmutableScratchStore(ImmutableStore):
+    """Self-destructing test subclass of ImmutableStore.
+
+    The Store only exists for the lifetime of the Python object.
+ Obviously you should not put anything precious in it.
+    """
+    def __init__(self):
+        ImmutableStore.__init__(self, tempfile.mkdtemp())
+
+    def __del__(self):
+        for f in os.listdir(self._basedir):
+            fpath = os.path.join(self._basedir, f)
+            # needed on windows, and maybe some other filesystems
+            os.chmod(fpath, 0600)
+            os.remove(fpath)
+        os.rmdir(self._basedir)
+        mutter("%r destroyed" % self)

=== removed file 'bzrlib/store/compressed_text.py'
--- bzrlib/store/compressed_text.py	2005-09-15 21:35:53 +0000
+++ bzrlib/store/compressed_text.py	1970-01-01 00:00:00 +0000
@@ -1,255 +0,0 @@
-# Copyright (C) 2005 by Canonical Development Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""
-An implementation the primary storage type CompressedTextStore.
-
-This store keeps compressed versions of the full text. It does not
-do any sort of delta compression.
-"""
-
-import os, tempfile, gzip
-
-import bzrlib.store
-from bzrlib.trace import mutter
-from bzrlib.errors import BzrError
-
-from StringIO import StringIO
-from stat import ST_SIZE
-
-class CompressedTextStore(bzrlib.store.Store):
-    """Store that holds files indexed by unique names.
-
-    Files can be added, but not modified once they are in.  Typically
-    the hash is used as the name, or something else known to be unique,
-    such as a UUID.
-
-    Files are stored gzip compressed, with no delta compression.
-
-    >>> st = ScratchCompressedTextStore()
-
-    >>> st.add(StringIO('hello'), 'aa')
-    >>> 'aa' in st
-    True
-    >>> 'foo' in st
-    False
-
-    You are not allowed to add an id that is already present.
-
-    Entries can be retrieved as files, which may then be read.
-
-    >>> st.add(StringIO('goodbye'), '123123')
-    >>> st['123123'].read()
-    'goodbye'
-    """
-
-    def __init__(self, basedir):
-        super(CompressedTextStore, self).__init__(basedir)
-
-    def _check_fileid(self, fileid):
-        if '\\' in fileid or '/' in fileid:
-            raise ValueError("invalid store id %r" % fileid)
-
-    def _relpath(self, fileid):
-        self._check_fileid(fileid)
-        return fileid + '.gz'
-
-    def add(self, f, fileid):
-        """Add contents of a file into the store.
-
-        f -- An open file, or file-like object."""
-        # TODO: implement an add_multi which can do some of it's
-        #       own piplelining, and possible take advantage of
-        #       transport.put_multi(). The problem is that
-        #       entries potentially need to be compressed as they
-        #       are received, which implies translation, which
-        #       means it isn't as straightforward as we would like.
-        from cStringIO import StringIO
-        from bzrlib.osutils import pumpfile
-        
-        mutter("add store entry %r" % (fileid))
-        if isinstance(f, basestring):
-            f = StringIO(f)
-            
-        fn = self._relpath(fileid)
-        if self._transport.has(fn):
-            raise BzrError("store %r already contains id %r" % (self._transport.base, fileid))
-
-
-        sio = StringIO()
-        gf = gzip.GzipFile(mode='wb', fileobj=sio)
-        # if pumpfile handles files that don't fit in ram,
-        # so will this function
-        if isinstance(f, basestring):
-            gf.write(f)
-        else:
-            pumpfile(f, gf)
-        gf.close()
-        sio.seek(0)
-        self._transport.put(fn, sio)
-
-    def _do_copy(self, other, to_copy, pb, permit_failure=False):
-        if isinstance(other, CompressedTextStore):
-            return self._copy_multi_text(other, to_copy, pb,
-                    permit_failure=permit_failure)
-        return super(CompressedTextStore, self)._do_copy(other, to_copy,
-                pb, permit_failure=permit_failure)
-
-    def _copy_multi_text(self, other, to_copy, pb,
-            permit_failure=False):
-        # Because of _transport, we can no longer assume
-        # that they are on the same filesystem, we can, however
-        # assume that we only need to copy the exact bytes,
-        # we don't need to process the files.
-
-        failed = set()
-        if permit_failure:
-            new_to_copy = set()
-            for fileid, has in zip(to_copy, self.has(to_copy)):
-                if has:
-                    new_to_copy.add(fileid)
-                else:
-                    failed.add(fileid)
-            to_copy = new_to_copy
-
-        paths = [self._relpath(fileid) for fileid in to_copy]
-        count = other._transport.copy_to(paths, self._transport, pb=pb)
-        assert count == len(to_copy)
-        return count, failed
-
-    def __contains__(self, fileid):
-        """"""
-        fn = self._relpath(fileid)
-        return self._transport.has(fn)
-
-    def has(self, fileids, pb=None):
-        """Return True/False for each entry in fileids.
-
-        :param fileids: A List or generator yielding file ids.
-        :return: A generator or list returning True/False for each entry.
-        """
-        relpaths = (self._relpath(fid) for fid in fileids)
-        return self._transport.has_multi(relpaths, pb=pb)
-
-    def get(self, fileids, ignore_missing=False, pb=None):
-        """Return a set of files, one for each requested entry.
-        
-        TODO: Write some tests to make sure that ignore_missing is
-              handled correctly.
-
-        TODO: What should the exception be for a missing file?
-              KeyError, or NoSuchFile?
-        """
-
-        # This next code gets a bit hairy because it can allow
-        # to not request a file which doesn't seem to exist.
-        # Also, the same fileid may be requested twice, so we
-        # can't just build up a map.
-        rel_paths = [self._relpath(fid) for fid in fileids]
-        is_requested = []
-
-        if ignore_missing:
-            existing_paths = []
-            for path, has in zip(rel_paths,
-                    self._transport.has_multi(rel_paths)):
-                if has:
-                    existing_paths.append(path)
-                    is_requested.append(True)
-                else:
-                    is_requested.append(False)
-        else:
-            existing_paths = rel_paths
-            is_requested = [True for x in rel_paths]
-
-        count = 0
-        for f in self._transport.get_multi(existing_paths, pb=pb):
-            assert count < len(is_requested)
-            while not is_requested[count]:
-                yield None
-                count += 1
-            if hasattr(f, 'tell'):
-                yield gzip.GzipFile(mode='rb', fileobj=f)
-            else:
-                from cStringIO import StringIO
-                sio = StringIO(f.read())
-                yield gzip.GzipFile(mode='rb', fileobj=sio)
-            count += 1
-
-        while count < len(is_requested):
-            yield None
-            count += 1
-
-    def __iter__(self):
-        # TODO: case-insensitive?
-        for f in self._transport.list_dir('.'):
-            if f[-3:] == '.gz':
-                yield f[:-3]
-            else:
-                yield f
-
-    def __len__(self):
-        return len([f for f in self._transport.list_dir('.')])
-
-
-    def __getitem__(self, fileid):
-        """Returns a file reading from a particular entry."""
-        fn = self._relpath(fileid)
-        # This will throw if the file doesn't exist.
-        try:
-            f = self._transport.get(fn)
-        except:
-            raise KeyError('This store (%s) does not contain %s' % (self, fileid))
-
-        # gzip.GzipFile.read() requires a tell() function
-        # but some transports return objects that cannot seek
-        # so buffer them in a StringIO instead
-        if hasattr(f, 'tell'):
-            return gzip.GzipFile(mode='rb', fileobj=f)
-        else:
-            from cStringIO import StringIO
-            sio = StringIO(f.read())
-            return gzip.GzipFile(mode='rb', fileobj=sio)
-            
-
-    def total_size(self):
-        """Return (count, bytes)
-
-        This is the (compressed) size stored on disk, not the size of
-        the content."""
-        total = 0
-        count = 0
-        relpaths = [self._relpath(fid) for fid in self]
-        for st in self._transport.stat_multi(relpaths):
-            count += 1
-            total += st[ST_SIZE]
-                
-        return count, total
-
-class ScratchCompressedTextStore(CompressedTextStore):
-    """Self-destructing test subclass of CompressedTextStore.
-
-    The Store only exists for the lifetime of the Python object.
-    Obviously you should not put anything precious in it.
-    """
-    def __init__(self):
-        from transport import transport
-        super(ScratchCompressedTextStore, self).__init__(transport(tempfile.mkdtemp()))
-
-    def __del__(self):
-        self._transport.delete_multi(self._transport.list_dir('.'))
-        os.rmdir(self._transport.base)
-        mutter("%r destroyed" % self)
-

=== removed directory 'bzrlib/transport'
=== removed file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2005-09-15 21:35:53 +0000
+++ bzrlib/transport/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,442 +0,0 @@
-#!/usr/bin/env python
-"""\
-This module contains the basic class handling transport of
-information.
-"""
-
-from bzrlib.trace import mutter
-from bzrlib.errors import BzrError
-
-_protocol_handlers = {
-}
-
-def register_transport(prefix, klass, override=True):
-    global _protocol_handlers
-
-    if _protocol_handlers.has_key(prefix):
-        if override:
-            mutter('overriding transport: %s => %s' % (prefix, klass.__name__))
-            _protocol_handlers[prefix] = klass
-    else:
-        mutter('registering transport: %s => %s' % (prefix, klass.__name__))
-        _protocol_handlers[prefix] = klass
-
-class TransportError(BzrError):
-    """All errors thrown by Transport implementations should derive
-    from this class.
-    """
-    def __init__(self, msg=None, orig_error=None):
-        if msg is None and orig_error is not None:
-            msg = str(orig_error)
-        BzrError.__init__(self, msg)
-        self.msg = msg
-        self.orig_error = orig_error
-
-class AsyncError(TransportError):
-    pass
-
-# A set of semi-meaningful errors which can be thrown
-class TransportNotPossible(TransportError):
-    """This is for transports where a specific function is explicitly not
-    possible. Such as pushing files to an HTTP server.
-    """
-    pass
-
-class NonRelativePath(TransportError):
-    """An absolute path was supplied, that could not be decoded into
-    a relative path.
-    """
-    pass
-
-class NoSuchFile(TransportError, IOError):
-    """A get() was issued for a file that doesn't exist."""
-    def __init__(self, msg=None, orig_error=None):
-        import errno
-        TransportError.__init__(self, msg=msg, orig_error=orig_error)
-        IOError.__init__(self, errno.ENOENT, self.msg)
-
-class FileExists(TransportError, OSError):
-    """An operation was attempted, which would overwrite an entry,
-    but overwritting is not supported.
-
-    mkdir() can throw this, but put() just overwites existing files.
-    """
-    def __init__(self, msg=None, orig_error=None):
-        import errno
-        TransportError.__init__(self, msg=msg, orig_error=orig_error)
-        OSError.__init__(self, errno.EEXIST, self.msg)
-
-class PermissionDenied(TransportError):
-    """An operation cannot succeed because of a lack of permissions."""
-    pass
-
-class ConnectionReset(TransportError):
-    """The connection has been closed."""
-    pass
-
-class AsyncFile(object):
-    """This will be returned from a Transport object,
-    whenever an asyncronous get is requested.
-    """
-    _max_write_buffer = 8192
-
-    def __init__(self):
-        self.read_buffer = []
-        self.write_buffer = []
-        self._finalized = False
-
-    def _total_len(self, buffer):
-        count = 0
-        for b in buffer:
-            count += len(b)
-        return count
-
-    def finalize(self):
-        """This will block until all data has been buffered for
-        reading, or all data has been flushed for writing.
-        Once this is called, you can no longer write more data.
-        """
-        raise NotImplementedError
-
-    def can_read(self):
-        """Can we read some data without blocking"""
-        return len(self.read_buffer) > 0
-
-    def can_write(self):
-        """Can we write some more data out without blocking?"""
-        return (not self._finalized \
-                and self._total_len(self.write_buffer) < self._max_write_buffer)
-
-    def write(self, chunk):
-        if self._finalized:
-            raise AsyncError('write attempted on finalized file.')
-        self.write_buffer.append(chunk)
-
-    def read(self, size=None):
-        if size is None:
-            return ''.join(self.read_buffer)
-        else:
-            out = ''
-            while True:
-                buf = self.read_buffer.pop(0)
-                if len(buf) + len(out) < size:
-                    out += buf
-                else:
-                    left = size - len(out)
-                    out += buf[:left]
-                    buf = buf[left:]
-                    self.read_buffer.insert(0, buf)
-                    return out
-
-
-class Transport(object):
-    """This class encapsulates methods for retrieving or putting a file
-    from/to a storage location.
-
-    Most functions have a _multi variant, which allows you to queue up
-    multiple requests. They generally have a dumb base implementation 
-    which just iterates over the arguments, but smart Transport
-    implementations can do pipelining.
-    In general implementations should support having a generator or a list
-    as an argument (ie always iterate, never index)
-    """
-
-    def __init__(self, base):
-        super(Transport, self).__init__()
-        self.base = base
-
-    def clone(self, offset=None):
-        """Return a new Transport object, cloned from the current location,
-        using a subdirectory. This allows connections to be pooled,
-        rather than a new one needed for each subdir.
-        """
-        raise NotImplementedError
-
-    def should_cache(self):
-        """Return True if the data pulled across should be cached locally.
-        """
-        return False
-
-    def _pump(self, from_file, to_file):
-        """Most children will need to copy from one file-like 
-        object or string to another one.
-        This just gives them something easy to call.
-        """
-        if isinstance(from_file, basestring):
-            to_file.write(from_file)
-        else:
-            from bzrlib.osutils import pumpfile
-            pumpfile(from_file, to_file)
-
-    def _get_total(self, multi):
-        """Try to figure out how many entries are in multi,
-        but if not possible, return None.
-        """
-        try:
-            return len(multi)
-        except TypeError: # We can't tell how many, because relpaths is a generator
-            return None
-
-    def _update_pb(self, pb, msg, count, total):
-        """Update the progress bar based on the current count
-        and total available, total may be None if it was
-        not possible to determine.
-        """
-        if pb is None:
-            return
-        if total is None:
-            pb.update(msg, count, count+1)
-        else:
-            pb.update(msg, count, total)
-
-    def _iterate_over(self, multi, func, pb, msg, expand=True):
-        """Iterate over all entries in multi, passing them to func,
-        and update the progress bar as you go along.
-
-        :param expand:  If True, the entries will be passed to the function
-                        by expanding the tuple. If False, it will be passed
-                        as a single parameter.
-        """
-        total = self._get_total(multi)
-        count = 0
-        for entry in multi:
-            self._update_pb(pb, msg, count, total)
-            if expand:
-                func(*entry)
-            else:
-                func(entry)
-            count += 1
-        return count
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        raise NotImplementedError
-
-    def relpath(self, abspath):
-        """Return the local path portion from a given absolute path.
-        """
-        raise NotImplementedError
-
-    def has(self, relpath):
-        """Does the target location exist?"""
-        raise NotImplementedError
-
-    def has_multi(self, relpaths, pb=None):
-        """Return True/False for each entry in relpaths"""
-        total = self._get_total(relpaths)
-        count = 0
-        for relpath in relpaths:
-            self._update_pb(pb, 'has', count, total)
-            yield self.has(relpath)
-            count += 1
-
-    def get(self, relpath):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        raise NotImplementedError
-
-    def get_partial(self, relpath, portion):
-        """Get just part of a file.
-
-        :param relpath: Path to the file, relative to base
-        :param portion: A tuple of [start,length). 
-                        Length can be -1 indicating copy until the end
-                        of the file. If the file ends before length bytes,
-                        just the set of bytes will be returned (think read())
-        :return: A file-like object containing at least the specified bytes.
-                 Some implementations may return objects which can be read
-                 past this length, but this is not guaranteed.
-        """
-        raise NotImplementedError
-
-    def get_partial_multi(self, files, pb=None):
-        """Put a set of files or strings into the location.
-
-        Requesting multiple portions of the same file can be dangerous.
-
-        :param files: A list of tuples of relpath, portion
-                      [(path1, portion1), (path2, portion2),...]
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: A generator of file-like objects.
-        """
-        def get_partial(relpath, portion):
-            yield self.get_partial(relpath, portion)
-        self._iterate_over(files, get_partial, pb, 'get_partial', expand=True)
-
-    def get_multi(self, relpaths, pb=None):
-        """Get a list of file-like objects, one for each entry in relpaths.
-
-        :param relpaths: A list of relative paths.
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: A list or generator of file-like objects
-        """
-        # TODO: Consider having this actually buffer the requests,
-        # in the default mode, it probably won't give worse performance,
-        # and all children wouldn't have to implement buffering
-        total = self._get_total(relpaths)
-        count = 0
-        for relpath in relpaths:
-            self._update_pb(pb, 'get', count, total)
-            yield self.get(relpath)
-            count += 1
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        raise NotImplementedError
-
-    def put_multi(self, files, pb=None):
-        """Put a set of files or strings into the location.
-
-        :param files: A list of tuples of relpath, file object [(path1, file1), (path2, file2),...]
-        :param pb:  An optional ProgressBar for indicating percent done.
-        :return: The number of files copied.
-        """
-        def put(relpath, f):
-            self.put(relpath, f)
-        return self._iterate_over(files, put, pb, 'put', expand=True)
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        raise NotImplementedError
-
-    def mkdir_multi(self, relpaths, pb=None):
-        """Create a group of directories"""
-        return self._iterate_over(relpaths, self.mkdir, pb, 'mkdir', expand=False)
-
-    def append(self, relpath, f):
-        """Append the text in the file-like or string object to 
-        the supplied location.
-        """
-        raise NotImplementedError
-
-    def append_multi(self, files):
-        """Append the text in each file-like or string object to
-        the supplied location.
-
-        :param files: A set of (path, f) entries
-        :param pb:  An optional ProgressBar for indicating percent done.
-        """
-        return self._iterate_over(files, self.append, pb, 'append', expand=True)
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
-
-    def copy_multi(self, relpaths, pb=None):
-        """Copy a bunch of entries.
-        
-        :param relpaths: A list of tuples of the form [(from, to), (from, to),...]
-        """
-        # This is the non-pipelined implementation, so that
-        # implementors don't have to implement everything.
-        return self._iterate_over(relpaths, self.copy, pb, 'copy', expand=True)
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-        """
-        # The dummy implementation just does a simple get + put
-        def copy_entry(path):
-            other.put(path, self.get(path))
-
-        return self._iterate_over(relpaths, copy_entry, pb, 'copy_to', expand=False)
-
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
-
-    def move_multi(self, relpaths, pb=None):
-        """Move a bunch of entries.
-        
-        :param relpaths: A list of tuples of the form [(from1, to1), (from2, to2),...]
-        """
-        return self._iterate_over(relpaths, self.move, pb, 'move', expand=True)
-
-    def move_multi_to(self, relpaths, rel_to):
-        """Move a bunch of entries to a single location.
-        This differs from move_multi in that you give a list of from, and
-        a single destination, rather than multiple destinations.
-
-        :param relpaths: A list of relative paths [from1, from2, from3, ...]
-        :param rel_to: A directory where each entry should be placed.
-        """
-        # This is not implemented, because you need to do special tricks to
-        # extract the basename, and add it to rel_to
-        raise NotImplementedError
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        raise NotImplementedError
-
-    def delete_multi(self, relpaths, pb=None):
-        """Queue up a bunch of deletes to be done.
-        """
-        return self._iterate_over(relpaths, self.delete, pb, 'delete', expand=False)
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        WARNING: This may not be implementable for all protocols, so use
-        sparingly.
-        """
-        raise NotImplementedError
-
-    def stat_multi(self, relpaths, pb=None):
-        """Stat multiple files and return the information.
-        """
-        #TODO:  Is it worth making this a generator instead of a
-        #       returning a list?
-        stats = []
-        def gather(path):
-            stats.append(self.stat(path))
-
-        count = self._iterate_over(relpaths, gather, pb, 'stat', expand=False)
-        return stats
-
-
-    def list_dir(self, relpath):
-        """Return a list of all files at the given location.
-        WARNING: many transports do not support this, so trying avoid using
-        it if at all possible.
-        """
-        raise NotImplementedError
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should contain an unlock() function.
-        """
-        raise NotImplementedError
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should contain an unlock() function.
-        """
-        raise NotImplementedError
-
-
-def transport(base):
-    global _protocol_handlers
-    if base is None:
-        base = '.'
-    for proto, klass in _protocol_handlers.iteritems():
-        if proto is not None and base.startswith(proto):
-            return klass(base)
-    # The default handler is the filesystem handler
-    # which has a lookup of None
-    return _protocol_handlers[None](base)
-
-# Local transport should always be initialized
-import bzrlib.transport.local

=== removed file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2005-09-15 21:35:53 +0000
+++ bzrlib/transport/http.py	1970-01-01 00:00:00 +0000
@@ -1,253 +0,0 @@
-#!/usr/bin/env python
-"""\
-An implementation of the Transport object for http access.
-"""
-
-from bzrlib.transport import Transport, register_transport, \
-    TransportNotPossible, NoSuchFile, NonRelativePath, \
-    TransportError
-import os, errno
-from cStringIO import StringIO
-import urllib2
-
-from bzrlib.errors import BzrError, BzrCheckError
-from bzrlib.branch import Branch, BZR_BRANCH_FORMAT
-from bzrlib.trace import mutter
-
-# velocitynet.com.au transparently proxies connections and thereby
-# breaks keep-alive -- sucks!
-
-
-ENABLE_URLGRABBER = False
-
-
-if ENABLE_URLGRABBER:
-    import urlgrabber
-    import urlgrabber.keepalive
-    import urlgrabber.grabber
-    urlgrabber.keepalive.DEBUG = 0
-    def get_url(path, compressed=False):
-        try:
-            url = path
-            if compressed:
-                url += '.gz'
-            mutter("grab url %s" % url)
-            url_f = urlgrabber.urlopen(url, keepalive=1, close_connection=0)
-            if not compressed:
-                return url_f
-            else:
-                return gzip.GzipFile(fileobj=StringIO(url_f.read()))
-        except urllib2.URLError, e:
-            raise BzrError("remote fetch failed: %r: %s" % (url, e))
-        except urlgrabber.grabber.URLGrabError, e:
-            raise BzrError("remote fetch failed: %r: %s" % (url, e))
-else:
-    def get_url(url, compressed=False):
-        import urllib2
-        if compressed:
-            url += '.gz'
-        mutter("get_url %s" % url)
-        url_f = urllib2.urlopen(url)
-        if compressed:
-            return gzip.GzipFile(fileobj=StringIO(url_f.read()))
-        else:
-            return url_f
-
-def _find_remote_root(url):
-    """Return the prefix URL that corresponds to the branch root."""
-    orig_url = url
-    while True:
-        try:
-            ff = get_url(url + '/.bzr/branch-format')
-
-            fmt = ff.read()
-            ff.close()
-
-            fmt = fmt.rstrip('\r\n')
-            if fmt != BZR_BRANCH_FORMAT.rstrip('\r\n'):
-                raise BzrError("sorry, branch format %r not supported at url %s"
-                               % (fmt, url))
-            
-            return url
-        except urllib2.URLError:
-            pass
-
-        try:
-            idx = url.rindex('/')
-        except ValueError:
-            raise BzrError('no branch root found for URL %s' % orig_url)
-
-        url = url[:idx]        
-        
-class HttpTransportError(TransportError):
-    pass
-
-class HttpTransport(Transport):
-    """This is the transport agent for http:// access.
-    
-    TODO: Implement pipelined versions of all of the *_multi() functions.
-    """
-
-    def __init__(self, base):
-        """Set the base path where files will be stored."""
-        assert base.startswith('http://') or base.startswith('https://')
-        super(HttpTransport, self).__init__(base)
-        # In the future we might actually connect to the remote host
-        # rather than using get_url
-        # self._connection = None
-
-    def should_cache(self):
-        """Return True if the data pulled across should be cached locally.
-        """
-        return True
-
-    def clone(self, offset=None):
-        """Return a new HttpTransport with root at self.base + offset
-        For now HttpTransport does not actually connect, so just return
-        a new HttpTransport object.
-        """
-        if offset is None:
-            return HttpTransport(self.base)
-        else:
-            return HttpTransport(self.abspath(offset))
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        if isinstance(relpath, basestring):
-            relpath = [relpath]
-        baseurl = self.base.rstrip('/')
-        return '/'.join([baseurl] + relpath)
-
-    def relpath(self, abspath):
-        if not abspath.startswith(self.base):
-            raise NonRelativePath('path %r is not under base URL %r'
-                           % (abspath, self.base))
-        pl = len(self.base)
-        return abspath[pl:].lstrip('/')
-
-    def has(self, relpath):
-        """Does the target location exist?
-
-        TODO: HttpTransport.has() should use a HEAD request,
-        not a full GET request.
-        """
-        try:
-            f = get_url(self.abspath(relpath))
-            return True
-        except BzrError:
-            return False
-        except urllib2.URLError:
-            return False
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                return False
-            raise HttpTransportError(orig_error=e)
-
-    def get(self, relpath, decode=False):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        try:
-            return get_url(self.abspath(relpath))
-        except BzrError, e:
-            raise NoSuchFile(orig_error=e)
-        except urllib2.URLError, e:
-            raise NoSuchFile(orig_error=e)
-        except IOError, e:
-            raise NoSuchFile(orig_error=e)
-        except Exception,e:
-            raise HttpTransportError(orig_error=e)
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        raise TransportNotPossible('http PUT not supported')
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        raise TransportNotPossible('http does not support mkdir()')
-
-    def append(self, relpath, f):
-        """Append the text in the file-like object into the final
-        location.
-        """
-        raise TransportNotPossible('http does not support append()')
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        raise TransportNotPossible('http does not support copy()')
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-
-        TODO: if other is LocalTransport, is it possible to
-              do better than put(get())?
-        """
-        # At this point HttpTransport might be able to check and see if
-        # the remote location is the same, and rather than download, and
-        # then upload, it could just issue a remote copy_this command.
-        if isinstance(other, HttpTransport):
-            raise TransportNotPossible('http cannot be the target of copy_to()')
-        else:
-            return super(HttpTransport, self).copy_to(relpaths, other, pb=pb)
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        raise TransportNotPossible('http does not support move()')
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        raise TransportNotPossible('http does not support delete()')
-
-    def async_get(self, relpath):
-        """Make a request for an file at the given location, but
-        don't worry about actually getting it yet.
-
-        :rtype: AsyncFile
-        """
-        raise NotImplementedError
-
-    def list_dir(self, relpath):
-        """Return a list of all files at the given location.
-        WARNING: many transports do not support this, so trying avoid using
-        it if at all possible.
-        """
-        raise TransportNotPossible('http does not support list_dir()')
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        """
-        raise TransportNotPossible('http does not support stat()')
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        # The old RemoteBranch ignore lock for reading, so we will
-        # continue that tradition and return a bogus lock object.
-        class BogusLock(object):
-            def __init__(self, path):
-                self.path = path
-            def unlock(self):
-                pass
-        return BogusLock(relpath)
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        raise TransportNotPossible('http does not support lock_write()')
-
-register_transport('http://', HttpTransport)
-register_transport('https://', HttpTransport)
-

=== removed file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2005-09-15 21:35:53 +0000
+++ bzrlib/transport/local.py	1970-01-01 00:00:00 +0000
@@ -1,198 +0,0 @@
-#!/usr/bin/env python
-"""\
-An implementation of the Transport object for local
-filesystem access.
-"""
-
-from bzrlib.transport import Transport, register_transport, \
-    TransportError, NoSuchFile, FileExists
-import os, errno
-
-class LocalTransportError(TransportError):
-    pass
-
-class LocalTransport(Transport):
-    """This is the transport agent for local filesystem access."""
-
-    def __init__(self, base):
-        """Set the base path where files will be stored."""
-        if base.startswith('file://'):
-            base = base[7:]
-        super(LocalTransport, self).__init__(os.path.realpath(base))
-
-    def should_cache(self):
-        return False
-
-    def clone(self, offset=None):
-        """Return a new LocalTransport with root at self.base + offset
-        Because the local filesystem does not require a connection, 
-        we can just return a new object.
-        """
-        if offset is None:
-            return LocalTransport(self.base)
-        else:
-            return LocalTransport(self.abspath(offset))
-
-    def abspath(self, relpath):
-        """Return the full url to the given relative path.
-        This can be supplied with a string or a list
-        """
-        if isinstance(relpath, basestring):
-            relpath = [relpath]
-        return os.path.join(self.base, *relpath)
-
-    def relpath(self, abspath):
-        """Return the local path portion from a given absolute path.
-        """
-        from branch import _relpath
-        return _relpath(self.base, abspath)
-
-    def has(self, relpath):
-        return os.access(self.abspath(relpath), os.F_OK)
-
-    def get(self, relpath):
-        """Get the file at the given relative path.
-
-        :param relpath: The relative path to the file
-        """
-        try:
-            path = self.abspath(relpath)
-            return open(path, 'rb')
-        except IOError,e:
-            if e.errno == errno.ENOENT:
-                raise NoSuchFile('File %r does not exist' % path, orig_error=e)
-            raise LocalTransportError(orig_error=e)
-
-    def put(self, relpath, f):
-        """Copy the file-like or string object into the location.
-
-        :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        """
-        from bzrlib.atomicfile import AtomicFile
-
-        try:
-            path = self.abspath(relpath)
-            fp = AtomicFile(path, 'wb')
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                raise NoSuchFile('File %r does not exist' % path, orig_error=e)
-            raise LocalTransportError(orig_error=e)
-        try:
-            self._pump(f, fp)
-            fp.commit()
-        finally:
-            fp.close()
-
-    def mkdir(self, relpath):
-        """Create a directory at the given path."""
-        try:
-            os.mkdir(self.abspath(relpath))
-        except OSError,e:
-            if e.errno == errno.EEXIST:
-                raise FileExists(orig_error=e)
-            elif e.errno == errno.ENOENT:
-                raise NoSuchFile(orig_error=e)
-            raise LocalTransportError(orig_error=e)
-
-    def append(self, relpath, f):
-        """Append the text in the file-like object into the final
-        location.
-        """
-        fp = open(self.abspath(relpath), 'ab')
-        self._pump(f, fp)
-
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        import shutil
-        path_from = self.abspath(rel_from)
-        path_to = self.abspath(rel_to)
-        try:
-            shutil.copy(path_from, path_to)
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        path_from = self.abspath(rel_from)
-        path_to = self.abspath(rel_to)
-
-        try:
-            os.rename(path_from, path_to)
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def delete(self, relpath):
-        """Delete the item at relpath"""
-        try:
-            os.remove(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def copy_to(self, relpaths, other, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-        """
-        if isinstance(other, LocalTransport):
-            # Both from & to are on the local filesystem
-            # Unfortunately, I can't think of anything faster than just
-            # copying them across, one by one :(
-            import shutil
-
-            total = self._get_total(relpaths)
-            count = 0
-            for path in relpaths:
-                self._update_pb(pb, 'copy-to', count, total)
-                shutil.copy(self.abspath(path), other.abspath(path))
-                count += 1
-            return count
-        else:
-            return super(LocalTransport, self).copy_to(relpaths, other, pb=pb)
-
-
-    def async_get(self, relpath):
-        """Make a request for an file at the given location, but
-        don't worry about actually getting it yet.
-
-        :rtype: AsyncFile
-        """
-        raise NotImplementedError
-
-    def list_dir(self, relpath):
-        """Return a list of all files at the given location.
-        WARNING: many transports do not support this, so trying avoid using
-        it if at all possible.
-        """
-        try:
-            return os.listdir(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def stat(self, relpath):
-        """Return the stat information for a file.
-        """
-        try:
-            return os.stat(self.abspath(relpath))
-        except OSError,e:
-            raise LocalTransportError(orig_error=e)
-
-    def lock_read(self, relpath):
-        """Lock the given file for shared (read) access.
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        from bzrlib.lock import ReadLock
-        return ReadLock(self.abspath(relpath))
-
-    def lock_write(self, relpath):
-        """Lock the given file for exclusive (write) access.
-        WARNING: many transports do not support this, so trying avoid using it
-
-        :return: A lock object, which should be passed to Transport.unlock()
-        """
-        from bzrlib.lock import WriteLock
-        return WriteLock(self.abspath(relpath))
-
-# If nothing else matches, try the LocalTransport
-register_transport(None, LocalTransport)
-register_transport('file://', LocalTransport)

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-09-15 21:35:53 +0000
+++ bzrlib/upgrade.py	2005-08-29 03:42:25 +0000
@@ -15,11 +15,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import tempfile, os, errno
-                
 import bzrlib.errors
 import bzrlib.progress
-from bzrlib.xml import serializer_v4
 
 
 def upgrade(branch):
@@ -99,8 +96,11 @@
                 # revision entry. I'm not supremely happy about it, but
                 # there should be *some* way of making old entries have
                 # the full meta information.
+                import tempfile, os, errno
+                from bzrlib.xml import pack_xml
+                
                 rev_tmp = tempfile.TemporaryFile()
-                serializer_v4.write_revision(rev, rev_tmp)
+                pack_xml(rev, rev_tmp)
                 rev_tmp.seek(0)
 
                 tmpfd, tmp_path = tempfile.mkstemp(prefix=rev_id, suffix='.gz',

=== modified file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2005-09-15 13:32:36 +0000
+++ bzrlib/weavefile.py	2005-08-24 04:40:43 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-08-29 13:51:52 +0000
+++ bzrlib/workingtree.py	2005-07-22 19:32:52 +0000
@@ -21,12 +21,10 @@
 # it's not predictable when it will be written out.
 
 import os
-import fnmatch
-        
+    
 import bzrlib.tree
-from bzrlib.osutils import appendpath, file_kind, isdir, splitpath
-from bzrlib.errors import BzrCheckError
-from bzrlib.trace import mutter
+from errors import BzrCheckError
+from trace import mutter
 
 class WorkingTree(bzrlib.tree.Tree):
     """Working copy tree.
@@ -137,6 +135,9 @@
 
         Skips the control directory.
         """
+        from osutils import appendpath, file_kind
+        import os
+
         inv = self._inventory
 
         def descend(from_dir_relpath, from_dir_id, dp):
@@ -204,6 +205,8 @@
         Currently returned depth-first, sorted by name within directories.
         """
         ## TODO: Work from given directory downwards
+        from osutils import isdir, appendpath
+        
         for path, dir_entry in self.inventory.directories():
             mutter("search for unknowns in %r" % path)
             dirabs = self.abspath(path)
@@ -266,6 +269,9 @@
         # Eventually it should be replaced with something more
         # accurate.
         
+        import fnmatch
+        from osutils import splitpath
+        
         for pat in self.get_ignore_list():
             if '/' in pat or '\\' in pat:
                 
@@ -284,4 +290,4 @@
                     return pat
         else:
             return None
-        
+        
\ No newline at end of file

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-09-15 13:32:36 +0000
+++ bzrlib/xml.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -19,344 +20,21 @@
 # "XML is like violence: if it doesn't solve your problem, you aren't
 # using enough of it." -- various
 
-# importing this module is fairly slow because it has to load several
-# ElementTree bits
-
+# importing this module is fairly slow because it has to load several ElementTree bits
 try:
     from util.cElementTree import ElementTree, SubElement, Element
 except ImportError:
     from util.elementtree.ElementTree import ElementTree, SubElement, Element
 
-from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-from bzrlib.revision import Revision, RevisionReference        
-from bzrlib.errors import BzrError
-
-
-class Serializer(object):
-    """Abstract object serialize/deserialize"""
-    def write_inventory(self, inv, f):
-        """Write inventory to a file"""
-        elt = self._pack_inventory(inv)
-        self._write_element(elt, f)
-
-    def read_inventory(self, f):
-        return self._unpack_inventory(self._read_element(f))
-
-    def write_revision(self, rev, f):
-        self._write_element(self._pack_revision(rev), f)
-
-    def read_revision(self, f):
-        return self._unpack_revision(self._read_element(f))
-
-    def _write_element(self, elt, f):
-        ElementTree(elt).write(f, 'utf-8')
-        f.write('\n')
-
-    def _read_element(self, f):
-        return ElementTree().parse(f)
-
-
-
-class _Serializer_v4(Serializer):
-    """Version 0.0.4 serializer
-
-    You should use the serialzer_v4 singleton."""
-    
-    __slots__ = []
-    
-    def _pack_inventory(self, inv):
-        """Convert to XML Element"""
-        e = Element('inventory')
-        e.text = '\n'
-        if inv.root.file_id not in (None, ROOT_ID):
-            e.set('file_id', inv.root.file_id)
-        for path, ie in inv.iter_entries():
-            e.append(self._pack_entry(ie))
-        return e
-
-
-    def _pack_entry(self, ie):
-        """Convert InventoryEntry to XML element"""
-        e = Element('entry')
-        e.set('name', ie.name)
-        e.set('file_id', ie.file_id)
-        e.set('kind', ie.kind)
-
-        if ie.text_size != None:
-            e.set('text_size', '%d' % ie.text_size)
-
-        for f in ['text_id', 'text_sha1']:
-            v = getattr(ie, f)
-            if v != None:
-                e.set(f, v)
-
-        # to be conservative, we don't externalize the root pointers
-        # for now, leaving them as null in the xml form.  in a future
-        # version it will be implied by nested elements.
-        if ie.parent_id != ROOT_ID:
-            assert isinstance(ie.parent_id, basestring)
-            e.set('parent_id', ie.parent_id)
-
-        e.tail = '\n'
-
-        return e
-
-
-    def _unpack_inventory(self, elt):
-        """Construct from XML Element
-        """
-        assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        inv = Inventory(root_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            if ie.parent_id == ROOT_ID:
-                ie.parent_id = root_id
-            inv.add(ie)
-        return inv
-
-
-    def _unpack_entry(self, elt):
-        assert elt.tag == 'entry'
-
-        ## original format inventories don't have a parent_id for
-        ## nodes in the root directory, but it's cleaner to use one
-        ## internally.
-        parent_id = elt.get('parent_id')
-        if parent_id == None:
-            parent_id = ROOT_ID
-
-        ie = InventoryEntry(elt.get('file_id'),
-                              elt.get('name'),
-                              elt.get('kind'),
-                              parent_id)
-        ie.text_id = elt.get('text_id')
-        ie.text_sha1 = elt.get('text_sha1')
-
-        ## mutter("read inventoryentry: %r" % (elt.attrib))
-
-        v = elt.get('text_size')
-        ie.text_size = v and int(v)
-
-        return ie
-
-
-    def _pack_revision(self, rev):
-        """Revision object -> xml tree"""
-        root = Element('revision',
-                       committer = rev.committer,
-                       timestamp = '%.9f' % rev.timestamp,
-                       revision_id = rev.revision_id,
-                       inventory_id = rev.inventory_id,
-                       inventory_sha1 = rev.inventory_sha1,
-                       )
-        if rev.timezone:
-            root.set('timezone', str(rev.timezone))
-        root.text = '\n'
-
-        msg = SubElement(root, 'message')
-        msg.text = rev.message
-        msg.tail = '\n'
-
-        if rev.parents:
-            pelts = SubElement(root, 'parents')
-            pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
-                p = SubElement(pelts, 'revision_ref')
-                p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-                if rr.revision_sha1:
-                    p.set('revision_sha1', rr.revision_sha1)
-
-        return root
-
-    
-    def _unpack_revision(self, elt):
-        """XML Element -> Revision object"""
-        
-        # <changeset> is deprecated...
-        if elt.tag not in ('revision', 'changeset'):
-            raise BzrError("unexpected tag in revision file: %r" % elt)
-
-        rev = Revision(committer = elt.get('committer'),
-                       timestamp = float(elt.get('timestamp')),
-                       revision_id = elt.get('revision_id'),
-                       inventory_id = elt.get('inventory_id'),
-                       inventory_sha1 = elt.get('inventory_sha1')
-                       )
-
-        precursor = elt.get('precursor')
-        precursor_sha1 = elt.get('precursor_sha1')
-
-        pelts = elt.find('parents')
-
-        if pelts:
-            for p in pelts:
-                assert p.tag == 'revision_ref', \
-                       "bad parent node tag %r" % p.tag
-                rev_ref = RevisionReference(p.get('revision_id'),
-                                            p.get('revision_sha1'))
-                rev.parents.append(rev_ref)
-
-            if precursor:
-                # must be consistent
-                prec_parent = rev.parents[0].revision_id
-                assert prec_parent == precursor
-        elif precursor:
-            # revisions written prior to 0.0.5 have a single precursor
-            # give as an attribute
-            rev_ref = RevisionReference(precursor, precursor_sha1)
-            rev.parents.append(rev_ref)
-
-        v = elt.get('timezone')
-        rev.timezone = v and int(v)
-
-        rev.message = elt.findtext('message') # text of <message>
-        return rev
-
-
-
-class _Serializer_v5(Serializer):
-    """Version 5 serializer
-
-    Packs objects into XML and vice versa.
-
-    You should use the serialzer_v5 singleton."""
-    
-    __slots__ = []
-    
-    def _pack_inventory(self, inv):
-        """Convert to XML Element"""
-        e = Element('inventory')
-        e.text = '\n'
-        if inv.root.file_id not in (None, ROOT_ID):
-            e.set('file_id', inv.root.file_id)
-        for path, ie in inv.iter_entries():
-            e.append(self._pack_entry(ie))
-        return e
-
-
-    def _pack_entry(self, ie):
-        """Convert InventoryEntry to XML element"""
-        assert ie.kind == 'directory' or ie.kind == 'file'
-        e = Element(ie.kind)
-        e.set('name', ie.name)
-        e.set('file_id', ie.file_id)
-
-        if ie.text_size != None:
-            e.set('text_size', '%d' % ie.text_size)
-
-        for f in ['text_version', 'text_sha1', 'entry_version']:
-            v = getattr(ie, f)
-            if v != None:
-                e.set(f, v)
-
-        # to be conservative, we don't externalize the root pointers
-        # for now, leaving them as null in the xml form.  in a future
-        # version it will be implied by nested elements.
-        if ie.parent_id != ROOT_ID:
-            assert isinstance(ie.parent_id, basestring)
-            e.set('parent_id', ie.parent_id)
-
-        e.tail = '\n'
-
-        return e
-
-
-    def _pack_revision(self, rev):
-        """Revision object -> xml tree"""
-        root = Element('revision',
-                       committer = rev.committer,
-                       timestamp = '%.9f' % rev.timestamp,
-                       revision_id = rev.revision_id,
-                       inventory_id = rev.inventory_id,
-                       inventory_sha1 = rev.inventory_sha1,
-                       )
-        if rev.timezone:
-            root.set('timezone', str(rev.timezone))
-        root.text = '\n'
-
-        msg = SubElement(root, 'message')
-        msg.text = rev.message
-        msg.tail = '\n'
-
-        if rev.parents:
-            pelts = SubElement(root, 'parents')
-            pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
-                p = SubElement(pelts, 'revision_ref')
-                p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-
-        return root
-
-    
-
-    def _unpack_inventory(self, elt):
-        """Construct from XML Element
-        """
-        assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        inv = Inventory(root_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            if ie.parent_id == ROOT_ID:
-                ie.parent_id = root_id
-            inv.add(ie)
-        return inv
-
-
-    def _unpack_entry(self, elt):
-        kind = elt.tag
-        assert kind == 'directory' or kind == 'file'
-
-        parent_id = elt.get('parent_id')
-        if parent_id == None:
-            parent_id = ROOT_ID
-
-        ie = InventoryEntry(elt.get('file_id'),
-                            elt.get('name'),
-                            kind,
-                            parent_id)
-        ie.text_version = elt.get('text_version')
-        ie.entry_version = elt.get('entry_version')
-        ie.text_sha1 = elt.get('text_sha1')
-        v = elt.get('text_size')
-        ie.text_size = v and int(v)
-
-        return ie
-
-
-    def _unpack_revision(self, elt):
-        """XML Element -> Revision object"""
-        assert elt.tag == 'revision'
-        
-        rev = Revision(committer = elt.get('committer'),
-                       timestamp = float(elt.get('timestamp')),
-                       revision_id = elt.get('revision_id'),
-                       inventory_id = elt.get('inventory_id'),
-                       inventory_sha1 = elt.get('inventory_sha1')
-                       )
-
-        for p in elt.find('parents'):
-            assert p.tag == 'revision_ref', \
-                   "bad parent node tag %r" % p.tag
-            rev_ref = RevisionReference(p.get('revision_id'))
-            rev.parents.append(rev_ref)
-
-        v = elt.get('timezone')
-        rev.timezone = v and int(v)
-
-        rev.message = elt.findtext('message') # text of <message>
-        return rev
-
-
-
-"""singleton instance"""
-serializer_v4 = _Serializer_v4()
-
-serializer_v5 = _Serializer_v5()
+
+def pack_xml(o, f):
+    """Write object o to file f as XML.
+
+    o must provide a to_element method.
+    """
+    ElementTree(o.to_element()).write(f, 'utf-8')
+    f.write('\n')
+
+
+def unpack_xml(cls, f):
+    return cls.from_element(ElementTree().parse(f))

=== modified file 'doc/index.txt'
--- doc/index.txt	2005-09-01 02:39:02 +0000
+++ doc/index.txt	2005-05-17 00:33:59 +0000
@@ -14,9 +14,10 @@
 __ http://canonical.com/
 
 
-**Note: These documents describe the initial design and are out of
-date in parts.**  For more up-to-date information see the wiki at
-http://bazaar.canonical.com/
+**Note:** These documents are in a very preliminary state, and so may
+be internally or externally inconsistent or redundant.  Comments are
+still very welcome.  Please send them to <mbp@sourcefrog.net>.
+
 
 For more information, see the homepage at http://bazaar-ng.org/
 

=== modified file 'doc/todo-from-arch.txt'
--- doc/todo-from-arch.txt	2005-09-01 02:34:38 +0000
+++ doc/todo-from-arch.txt	2005-04-15 01:31:21 +0000
@@ -2,11 +2,10 @@
 Opportunities for improvement on GNU Arch
 ***************************************** 
 
-[note that this document is rather out of date in 2005-08]
 
-GNU Arch is one influence on bazaar-ng.  There are several things we
-would change from Arch in Bazaar to (we hope) improve the user
-experience.
+Bazaar-NG is based on the GNU Arch system, and inherits a lot of its
+design from Arch.  However, there are several things we will change in
+Baz to (we hope) improve the user experience.
 
 The core design of Arch is good, brilliant even.  It can scale from
 small projects too large ones, and is a good foundation for building

=== modified file 'setup.py'
--- setup.py	2005-09-04 03:32:17 +0000
+++ setup.py	2005-08-25 05:58:05 +0000
@@ -19,5 +19,5 @@
                 'bzrlib.util',
                 'bzrlib.util.elementtree',
                 'bzrlib.util.effbot.org',
-                ],
+                'bzrlib.util.urlgrabber'],
       scripts=['bzr'])

=== modified file 'testsweet.py'
--- testsweet.py	2005-09-15 21:35:53 +0000
+++ testsweet.py	2005-08-29 01:25:00 +0000
@@ -39,7 +39,6 @@
 
 import unittest
 import sys
-from bzrlib.selftest import TestUtil
 
 # XXX: Don't need this anymore now we depend on python2.4
 def _need_subprocess():
@@ -56,29 +55,6 @@
     # XXX: Not used yet
 
 
-class EarlyStoppingTestResultAdapter(object):
-    """An adapter for TestResult to stop at the first first failure or error"""
-
-    def __init__(self, result):
-        self._result = result
-
-    def addError(self, test, err):
-        self._result.addError(test, err)
-        self._result.stop()
-
-    def addFailure(self, test, err):
-        self._result.addFailure(test, err)
-        self._result.stop()
-
-    def __getattr__(self, name):
-        return getattr(self._result, name)
-
-    def __setattr__(self, name, value):
-        if name == '_result':
-            object.__setattr__(self, name, value)
-        return setattr(self._result, name, value)
-
-
 class _MyResult(unittest._TextTestResult):
     """
     Custom TestResult.
@@ -128,36 +104,13 @@
 class TextTestRunner(unittest.TextTestRunner):
 
     def _makeResult(self):
-        result = _MyResult(self.stream, self.descriptions, self.verbosity)
-        return EarlyStoppingTestResultAdapter(result)
-
-
-class filteringVisitor(TestUtil.TestVisitor):
-    """I accruse all the testCases I visit that pass a regexp filter on id
-    into my suite
-    """
-
-    def __init__(self, filter):
-        import re
-        TestUtil.TestVisitor.__init__(self)
-        self._suite=None
-        self.filter=re.compile(filter)
-
-    def suite(self):
-        """answer the suite we are building"""
-        if self._suite is None:
-            self._suite=TestUtil.TestSuite()
-        return self._suite
-
-    def visitCase(self, aCase):
-        if self.filter.match(aCase.id()):
-            self.suite().addTest(aCase)
-
-
-def run_suite(suite, name='test', verbose=False, pattern=".*"):
+        return _MyResult(self.stream, self.descriptions, self.verbosity)
+
+
+def run_suite(suite, name='test', verbose=False):
     import shutil
-    from bzrlib.selftest import TestCaseInTempDir
-    TestCaseInTempDir._TEST_NAME = name
+    from bzrlib.selftest import FunctionalTestCase
+    FunctionalTestCase._TEST_NAME = name
     if verbose:
         verbosity = 2
     else:
@@ -165,15 +118,13 @@
     runner = TextTestRunner(stream=sys.stdout,
                             descriptions=0,
                             verbosity=verbosity)
-    visitor = filteringVisitor(pattern)
-    suite.visit(visitor)
-    result = runner.run(visitor.suite())
+    result = runner.run(suite)
     # This is still a little bogus, 
     # but only a little. Folk not using our testrunner will
     # have to delete their temp directories themselves.
     if result.wasSuccessful():
-        if TestCaseInTempDir.TEST_ROOT is not None:
-            shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
+        if FunctionalTestCase.TEST_ROOT:
+            shutil.rmtree(FunctionalTestCase.TEST_ROOT) 
     else:
-        print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT
+        print "Failed tests working directories are in '%s'\n" % FunctionalTestCase.TEST_ROOT
     return result.wasSuccessful()

=== modified file 'tools/weavebench.py'
--- tools/weavebench.py	2005-08-25 07:48:27 +0000
+++ tools/weavebench.py	2005-07-18 11:23:40 +0000
@@ -51,7 +51,7 @@
             if lines:
                 del lines[randrange(0, len(lines))]
 
-        rev_id = wf.add("%s" % i, parents, lines)
+        rev_id = wf.add(parents, lines)
         parents = [rev_id]
 
     write_weave(wf, file(WEAVE_NAME, 'wb'))

=== modified file 'tutorial.txt'
--- tutorial.txt	2005-09-14 09:03:27 +0000
+++ tutorial.txt	2005-08-26 00:10:48 +0000
@@ -5,8 +5,11 @@
 current for bzr 0.0.6pre, July 2005
 
 
-*NOTE* For a more current and user-editable version of this 
-document, see the wiki at http://bazaar.canonical.com/IntroductionToBzr
+*Note:* This tutorial is a work in 
+progress, and describes code that is itself still evolving. 
+If you have comments on either the design or the tutorial, 
+please send them to the bazaar-ng@lists.canonical.com mailing list.
+
 
 
 Introduction
@@ -51,7 +54,7 @@
 Some people want to avoid sharing their email address so as not to
 get spam.  bzr will never
 disclose your email address unless you tell it to by publishing an
-archive or transmitting a changeset.  It's recommended that you do use
+archive or transmiting a changeset.  It's recommended that you do use
 a real address, so that people can contact you about your work, but
 it's not required.  You can use an address which is obfuscated, which
 bounces, or which goes through an anti-spam service such as spamgourmet.com.
@@ -289,7 +292,7 @@
 a copy.  Because this new copy is potentially a new branch, the
 command is called *branch*::
 
-    % bzr branch http://bazaar-ng.org/bzr/bzr.dev
+    % bzr branch http://bazaar-ng.org/bzr/bzr.dev 
     % cd bzr.dev
 
 This copies down the complete history of this branch, so we can
@@ -307,6 +310,6 @@
 
     % bzr pull
 
-This only works if your local branch includes only changes from the
-parent branch.  Otherwise, the branches are said to have *diverged*,
-and they must be merged instead.
+This only works if the local branch if your branch includes only
+changes from the parent branch.  Otherwise, the branches are said to
+have *diverged*, and they must be merged instead.

